#=============================================================================
# BBS Note Comet 1.x
# Copyright(C) WonderCatStudio. All rights reserved.
# This code cannot be redistributed without
# permission from wondercatstudio.com
# LastModify : 2008/02/03
# Version : 0.11.000 build 2
#=============================================================================
package BN::Admin;
use strict;
use vars qw( $bn $VERSION );

$VERSION = '0.11.000';

sub new {
  my $class = $_[0];
  my $ad = bless { }, $class;
  $bn = $_[1];
  $ad;
}

sub menu {
  my $ad = $_[0];
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my $sk = $bn->{skin};
  my $fl = $bn->{flag};
  my $gl = $bn->{global};
  my $sys = $bn->{sys};
  my $disable_menu = $sys->{CMS}{DISABLE_MENU};
  $sys->{MODE} = 'ADMIN';

  if ($fl->{AUTHORITY} ne 'ADMIN') {
  my($pwd, $usr) = $bn->get_admin_pass;
  $bn->check_authority($pwd)
    or $bn->error('PASSWORD_ERROR');
  }

  $bn->call('OpenAdminInit');

  if ($in->{cmd} eq 'reflesh_index') {
    $bn->error('ERR_FUNCTION')
    if exists $disable_menu->{system_reflesh_index};
    delete $in->{cmd};
    $bn->app->reflesh;
  } elsif($in->{cmd} =~ /delete(_wide)?/) {
    $bn->app->delete;
  } elsif($in->{cmd} eq 'recover_sysindex') {
    $bn->error('ERR_FUNCTION')
     if exists $disable_menu->{system_recover_index};
    $ad->recover_sys_index; return;
  } elsif($in->{cmd} eq 'recover_fileindex') {
  $bn->error('ERR_FUNCTION')
    if exists $disable_menu->{system_recover_backup};
    $ad->recover_file_index; return;
  } elsif($in->{cmd} eq 'recover_backupindex') {
    $bn->error('ERR_FUNCTION')
      if exists $disable_menu->{system_recover_file};
    $ad->backup_sys_index; return;
  } elsif($in->{cmd} eq 'thread_lock') {
    $bn->error('ERR_FUNCTION')
      if exists $disable_menu->{limit_thread_lock};
    $ad->thread_lock;
  } elsif($in->{cmd} eq 'thread_view') {
    $bn->error('ERR_FUNCTION')
      if exists $disable_menu->{limit_thread_view};
    $ad->thread_view;
  } elsif($in->{cmd} eq 'paint_poollist') {
    $bn->pm->open_pool_list;
  }

  $bn->set($cf, 'LogViewReply', 0);
  $bn->set($sk, 'StylePageLink', 1);

  # hooks
  $bn->set_call( $in->{fc} eq 'thread' ? 'OpenThreadMenu' : 'OpenPageMenu',
  sub {
  my @txt = $bn->info('ADMIN_TEXT');
  my $hash = ref $bn->get($sk, 'TagTableFont') eq 'HASH' ? $bn->get($sk, 'TagTableFont') : {};
  my $contents; $gl->{contents} = \$contents;
  $contents .= '<table width="450" style="font-size:10pt;color:'.$hash->{color}.'"><tr><td>';
  my $bbs = $bn->get($cf, 'BBSNoteUrl');
  my $cgi_form = '<form method="post" action="'.$bbs.'">'.
  '<input type="hidden" name="password" value="'.$in->{password}.'">'.
  '<input type="hidden" name="name" value="'.$in->{name}.'">'.
  '<input type="hidden" name="page" value="'.$in->{page}.'">'.
  '<input type="hidden" name="sort" value="'.$in->{sort}.'">';
  delete $bn->{arg}{AdminMenuForm}{mode};
  $cgi_form .= $bn->set_form_arg($bn->{arg}{AdminMenuForm});
  $gl->{cgi_form} = \$cgi_form;

  # config manager
  $contents .= $cgi_form.'<input type="hidden" name="fc" value="setting">'.
   '<input type="submit" class="submit" value="'.$txt[12].'"></form><p>'.$txt[13]."</p>\n";

  # access log
  if ($bn->get($cf, 'UseAccessLog') && ! exists $disable_menu->{system_access_log}) {
    $contents .= $cgi_form.'<input type="hidden" name="fc" value="access_log">'.
    '<input type="submit" class="submit" value="'.$txt[14].'"></form><p>'.$txt[15]."</p>\n";
  }

  # index reflesh
  if ($bn->get($cf, 'UseRefleshIndex') && ! exists $disable_menu->{system_reflesh_index}) {
    $contents .= $cgi_form.'<input type="hidden" name="fc" value="admin">'.
    '<input type="hidden" name="cmd" value="reflesh_index">'.
    '<input type="submit" class="submit" value="'.$txt[10].'"></form><p>'.$txt[11]."</p>\n";
  }

  $bn->call('OpenAdminMenu');

  my $f = $cgi_form;
  $f =~ s/(method)/name=menuform $1/;

  # delete wide
  if ($in->{cmd} eq 'delete_wide') {
    $fl->{MENUFORM} = 'ADMIN';
    $contents .= $cgi_form.
    '<input type="hidden" name="fc" value="admin">'.
    '<input type="hidden" name="cmd" value="">'.
    '<input type="hidden" name="mode" value="'.$in->{mode}.'">'.
    '<input type="hidden" name="sort" value="'.$in->{sort}.'">'.
    '<input type="submit" class="submit" value="'.$txt[3].'"></form><p>'.$txt[8].'</p>'.$f.
    '<input type="hidden" name="fc" value="admin">'.
    '<input type="hidden" name="cmd" value="delete_wide">'.
    '<input type="hidden" name="mode" value="'.$in->{mode}.'">'.
    '<input type="hidden" name="sort" value="'.$in->{sort}.'">'.
    '<input type="submit" class="submit" value="'.$txt[5].'">'.$txt[6].
    '<input style="text-align:center" name="number" type="text" size="10" class="input"><p>'.$txt[9].'</p>';
  } else {
  # normal

  # /* -- hook --
  my $cmd = sub{
    my $t_out = $bn->get($sk, 'TagTableOut');
    my $t_in = $bn->get($sk, 'TagTableIn');
    my $command = $gl->{Command} = [];
    my $bg1 = $t_out->{bgcolor};
    my $bg2 = $t_in->{bgcolor};
    my $number = $_[0] ? $gl->{IndexNumber}: "$gl->{IndexNumber}-$gl->{LogValue}{num}",

    my @cell = (1,1,3,0); # cell space padding
    my $cmd_del = { action => $bbs, fc => 'admin', cmd => 'delete', page => $in->{page}, sort => $in->{sort}, submit => $txt[5], number => $number };
    push @$command, $cmd_del;

    if ($bn->get($cf, 'UseThreadLock') && ! exists $disable_menu->{limit_thread_lock} && $_[0] ) {
    my $cmd_tlock = { action => $bbs, fc => 'admin', cmd => 'thread_lock', page => $in->{page}, number => $number,
      submit => $bn->text( $gl->{LogExValue}{thread_lock} ? 'THREAD_UNLOCK' : 'THREAD_LOCK') };
    push @$command, $cmd_tlock;
    }

    $bn->call('OpenAdminCommand');

    my $s;
    for my $h(@$command){
      if ($h->{action}) {
        $s .= '<form action="' . $h->{action} . '" method="post"><td>'.
          '<input type="hidden" name="name" value="' . $in->{name} . '">'.
          '<input type="hidden" name="password" value="' . $in->{password} . '">'.
          '<input type="submit" class="submit" value="' . $h->{submit} . '">';
        delete $h->{action}; delete $h->{submit};
        map{ $s .= '<input type="hidden" name="' . $_ . '" value="' . $h->{$_} . '">' if $h->{$_} ne '' } keys %$h;
        $s .= '</td></form>';
      }
    }

    return unless $s;
    $gl->{LogValue}{message} .= '<br><br><table class="AdminCmdTableOut" cellpadding="'.$cell[0].'" cellspacing="'.$cell[1].'" bgcolor="'.$bg1.'"><tr><td>'.
     '<table class="AdminCmdTableIn" cellpadding="'.$cell[2].'" cellspacing="'.$cell[3].'" bgcolor="'.$bg2.'">'.
     '<tr><td bgcolor="'.$bg1.'" style="color:'.$bg2.'">'.$txt[2].'</td>'.$s.
     '</td></tr></table></td></tr></table>';

  };# -- hook -- */

  $bn->set_call('SkinMainInit', sub{ &$cmd(1) } );
  $bn->set_call('SkinReplyBegin',sub{ &$cmd(0) } );

  $contents .= $f.'<input type="hidden" name="fc" value="admin">'.
    '<input type="hidden" name="cmd" value="delete_wide">'.
    '<input type="submit" class="submit" value="'.$txt[4].'">'.
    '<p>'.$txt[7].'</p></form>';

  }

  $contents .= '</td></tr></table>';

  $bn->frame($txt[0] . ($fl->{AutoLogin} ? " : $txt[1]" : ''), $contents);

  });

  $bn->set_call( 'OpenPageBegin', sub{ $in->{mode} = 'normal' if $in->{mode} eq 'catalog' } );

  $bn->open_page if $in->{fc} ne 'thread';

}

sub login {
  my $ad = $_[0];
  my $cf = $bn->{cfg};
  my $sk = $bn->{skin};
  my $fl = $bn->{flag};
  my $gl = $bn->{global};
  my $ck = $bn->{cookie};
  my $fr = $sk->{form};

  delete $fl->{AutoLogin};
  my $flag_form = 1 if exists $bn->{in}{password};
  my( $pwd, $usr ) = $bn->get_admin_pass;
  if ($pwd) {
    my $ok = $bn->check_authority( $pwd );
    if ( !$ok || $fl->{AUTHORITY} ne 'ADMIN' ) {
      delete $ck->{adminuser}; delete $ck->{adminpass};
      $bn->write_cookie($ck);
      $bn->error('PASSWORD_ERROR') if exists $fl->{AutoLogin};
    } else {
    # admin info
      $ck->{adminuser} = $usr; $ck->{adminpass} = $pwd;
      $bn->write_cookie($ck);
      $ad->menu; return;
    }
  }
  $ad->login_form;
}

sub login_form {
  my $ad = shift;
  my $cf = $bn->{cfg};
  $bn->{arg}{LoginForm} = $_[0];
  my $str = $_[1];
  my @text = $bn->info( 'LOGIN_TEXT' );
  $bn->call( 'OpenLoginInit' );
  $bn->send_http_header->head( $bn->get( $cf, 'BbsTitle' ) . ' : ' . $text[0] );
  $bn->{flag}{MENUFORM} = 'LOGIN';
  $bn->call( 'OpenLoginForm' );
  $bn->create_menu_form( 'login', "<h2>$text[0]</h2>$str$text[1]<br>",
   'LoginForm' )->foot( 'NotPageLink' )->EXIT;
}

sub thread_lock {
  my $ad = $_[0];
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my $gl = $bn->{global};

  $bn->get( $cf, 'UseThreadLock' ) or $bn->error( 'ERR_FUNCTION' );

  my $val = $gl->{LogValue} = {};
  my $ex = $gl->{LogExValue} = {};
  my $path = $bn->filelog( $in->{number} );
  my $fh = $bn->open($path);
  $fh or $bn->error( 'ERR_DATA_NOTOPEN', $path );
  $_ = <$fh>; close $fh;
  $bn->get_log_main_value( $_, $val, $ex );
  $ex->{thread_lock} = $ex->{thread_lock} ? '' : 1;
  $bn->{sys}{MODE} = 'EDIT_POST';
  $bn->filelock;
  $bn->po->write_log_value( $path, $val, $ex );
  $bn->fileunlock;
}


sub thread_view {
  my $ad = $_[0];
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my $gl = $bn->{global};

  $bn->get( $cf, 'UseThreadLock' )
  or $bn->error('ERR_FUNCTION');

  my $val = $gl->{LogValue} = {};
  my $ex = $gl->{LogExValue} = {};
  my $path = $bn->filelog($in->{number});
  my $fh = $bn->open($path);
  $fh or $bn->error('ERR_DATA_NOTOPEN', $path);
  $_ = <$fh>; close $fh;
  $bn->get_log_main_value($_, $val, $ex);
  $ex->{thread_view} = $in->{thread_view} =~ /(\d)/ ? $1 : '';
  $ex->{thread_view_pass} = exists $in->{thread_view_pass} && $in->{thread_view_pass} =~ /(\w{0,8}?)/ ? $1 : '';

  $bn->{sys}{MODE} = 'EDIT_POST';
  $bn->filelock;
  $bn->po->write_log_value($path, $val, $ex);
  $bn->fileunlock;
}

sub backup_sys_index {
  my $ad = $_[0];
  my $sys = $bn->{sys};
  my $sys_index_cgi = $sys->{DirSys}. '/index.'. $sys->{Exe};
  my $sys_count_cgi = $sys->{DirSys}. '/count.'. $sys->{Exe};
  my( $cnt, $bin, $buf );
  $bn->send_http_header( 'application/octet-stream' );

  $| = 1;
  $bn->print( $sys->{SysIndexHead} );
  my $size = -s $sys_index_cgi;
  if ( $size ) { $buf .= ":$size:";
    my $fh = $bn->open( $sys_index_cgi );
    binmode $fh; read $fh, $bin, $size; close $fh;
  }
  $size = -s $sys_count_cgi;
  if ( $size ) { $buf .= "$size:";
    my $fh = $bn->open( $sys_count_cgi );
    binmode $fh; read $fh, $bin, $size; close $fh;
  }
  my @sum_bin = $ad->check_sum_file( \$bin );
  my @sum_cnt = $ad->check_sum_file( \$cnt );
  $buf .= join ':', @sum_bin, @sum_cnt;
  $bn->print( ( sprintf "%04d", ( length $buf ) -1 ), $buf, $bin, $cnt );
  $ad;
}
sub recover_file_index {
  my $ad = $_[0];
  my $in = $bn->{in};
  my $sk = $bn->{skin};
  my $sys = $bn->{sys};
  my @txt = $bn->info( 'FILERECOVER_TEXT' );

  $ad->recover_file_index_form( @txt ) unless $in->{file};

  my $l = length $sys->{SysIndexHead};

  # file head check
  $bn->end( 'ERROR', '', $bn->text('UNKNOWN_FORMAT') )
    if $sys->{SysIndexHead} ne ( substr $in->{file}, 0, $l );

  my $header_len = int substr $in->{file}, $l, 4;
  my $header = substr $in->{file}, $l + 5, $header_len;

  my( $index_len, $count_len, @index_sum, @count_sum );
  ( $index_len, $count_len, @index_sum[0..2], @count_sum[0..2] ) = split ':', $header;

  my $index_bin = substr $in->{file}, $l + 5 + $header_len, $index_len;
  my $count_bin = substr $in->{file}, $l + 5 + $header_len + $index_len, $count_len;

  my @sum_bin = $ad->check_sum_file( \$index_bin );
  my @sum_cnt = $ad->check_sum_file( \$count_bin );

  # check sum err
  $bn->end( 'ERROR',@txt[0,4] )
    unless( ( join ':', @sum_bin, @sum_cnt ) eq ( join ':', @index_sum, @count_sum ) );

  # recover
  $bn->filelock;
  my $path = $sys->{DirSys}. '/index.'. $sys->{Exe};
  my $fh_bin = $bn->open( $path, '>' );
  $fh_bin or $bn->error( 'ERR_SYS_NOTWRITE', $path );
  print $fh_bin $index_bin;
  close $fh_bin;
  $path = $sys->{DirSys}. '/count.'. $sys->{Exe};
  $fh_bin = $bn->open( $path, '>' );
  $fh_bin or $bn->error( 'ERR_SYS_NOTWRITE', $path );
  print $fh_bin $count_bin;
  close $fh_bin;
  @txt = $bn->info( 'RECOVER_TEXT' );
  $bn->send_http_header->head( $txt[0] );
  $bn->print( '<div style="text-align:center"><h2>', $txt[1], '</h2>' );
  $bn->{arg}{BackButton}{fc} = 'admin';
  $bn->{arg}{BackButton}{password} = $in->{password};
  undef $in->{mode};
  $bn->print( $bn->back_button, '</div>' );
  $bn->foot->fileunlock;
}

sub recover_file_index_form {
  my $ad = shift;
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my $bbs = $bn->get( $cf, 'BBSNoteUrl' );
  my @txt = @_;

  $bn->send_http_header->head( $txt[0] );
  $bn->print('<br><br>');
my $contents = <<_HTML_;
<table width="500"><tr><td style="text-align:center;font-size:10pt">$txt[3]
<form enctype="multipart/form-data" method="post" action=2$bbs">
<input type="hidden" name="password" value="$in->{password}">
<input type="hidden" name="name" value=2$in->{name}">
<input type="hidden" name="fc" value="$in->{fc}">
<input type="hidden" name="cmd" value="$in->{cmd}2>
$txt[1]<input type="file" name="file" class="input">
<input type="submit" value="$txt[2]" class="submit"></form>
_HTML_

  $bn->{arg}{BackButton}{fc} = 'admin';
  $bn->{arg}{BackButton}{password} = $in->{password};
  undef $in->{mode};
  $contents .= $bn->back_button. '</td></tr></table>' x 3 . '<br><br>';
  $bn->frame( $txt[0], $contents )->foot->EXIT;

}

sub check_sum_file {
  my( $ad, $h ) = @_;
  my( $i, $sum1, $sum2, $sum3 );
  for ( unpack "v*", $$h ) {
    $i++;
    if ( $i % 2 ) { $sum1+=$_; $sum2+=$_ } else { $sum1-=$_; $sum3-=$_ }
    if ( $i % 3 ) { $sum2-=$_; $sum3+=$_ }
  }
  return( abs $sum1, abs $sum2, abs $sum3 );
}

sub recover_sys_index {
  my $ad = $_[0];
  my $sk = $bn->{skin};
  my $sys = $bn->{sys};
  my $p = $sys->{DirData};
  my $dir_temp = $p. '/recover';
  my $rsleep = $sys->{RecoverSleep};
  my $progress_on = 1 if $bn->{global}{UserBrowserVer} ne 'NN 4';

  my( $start, $stime );
  my @txt = $bn->info('RECOVER_TEXT');

  eval( '$start = (times)[1]' );

  $bn->filelock;

  # /* progress script
  $bn->set_call( 'SkinHeadFormat', sub{
    return if $bn->{flag}{CreateHtml};
    undef $bn->{data}{javascript};
    $bn->reset_javascript;
    if ( $progress_on ) {
      $bn->get_javascript('MM_findObj', \$bn->{data}{javascript});
      $bn->{data}{javascript} .= <<_SCRIPT_;
var bar_t;var bar_max;var navi_t;
function BN_prog(n,s){
 if(s){ MM_findObj('navi').innerHTML= s}
 else if(n > 1){ p = parseInt(n * 100 / bar_max);
 if(1 > p) p = 1; bar_t.width = p + "%";navi_t.innerHTML= bar_t.width}}
function BN_proginit(m){bar_max = m;bar_t = MM_findObj('bar');navi_t = MM_findObj('navi')}
_SCRIPT_
    }
  });
  # progress script */

  $bn->send_http_header->head( $txt[0] );

  $| = 1;
  my $in = $bn->get( $sk, 'TagTableIn' );
  my $out = $bn->get( $sk, 'TagTableOut' );
  $bn->print( '<h2>', $txt[0], '</h2>' );

  if ( $progress_on ) {
    $bn->print( <<HTML );
<table width="500" border="1" bgcolor="$in->{bgcolor}"><tr><td>
<table id="bar" bgcolor="$out->{bgcolor}" width="0%"><tr><td>
</td></tr></table></td></tr></table>
<table width="500" border="0"><tr><td align="center">
<span id="navi" style="font-size:12px"></span>
</td></tr></table><hr>
HTML
  }
  $bn->print( '<script>BN_prog(0,"'.$txt[2].'")</script>' ) if $progress_on;

  my( $log_count, $max_msg_count ) = $ad->recover_index_scan( $p, $progress_on );

  $bn->print(
    "Log Count : $log_count<br>",
    '<script>BN_proginit(',
    $log_count ? $log_count * 2 : 2 ,
    ')</script>'
  ) if $progress_on;

  my( $max_log_count, $index_count )
   = $ad->recover_index_write( $log_count, $max_msg_count, $progress_on );

  $bn->print( 'Max Log Count : ', $max_log_count, '<br>',
    'Max Msg Count : ', $max_msg_count, '<br><hr>' );

  eval( '$stime = sprintf "%.3f", ( (times)[1] - $start )' );

  $bn->print( '<b>TIME : ', $stime,  '</b><br>' ) if $stime;

  $bn->print(
    '<script>BN_prog(',
    $log_count ? $log_count * 2 : 2,
    ')</script><script>BN_prog(0,"'.$txt[1].'")</script>'
  ) if $progress_on;

  $bn->print( $txt[1] );

  $bn->{arg}{BackButton}{fc} = 'admin';
  $bn->{arg}{BackButton}{password} = $bn->{in}{password};
  undef $bn->{in}{mode};

  $bn->call( 'RecoverSysIndexEnd' );
  $bn->print( $bn->back_button );
  $bn->foot->fileunlock;
}

sub recover_sys_index_silent {
  my( $ad, $lock ) = @_;
  my $sys = $bn->{sys};
  my $p = $sys->{DirData};
  my $progress_on = 0;
  $bn->filelock if $lock;
  my( $log_count, $max_msg_count ) = $ad->recover_index_scan( $p );
  my( $max_log_count, $index_count )
   = $ad->recover_index_write( $log_count, $max_msg_count, $progress_on );
  $bn->fileunlock if $lock;
}

sub recover_index_scan {
  my( $ad, $p, $progress_on ) = @_;
  my $cf = $bn->{cfg};
  my $sys = $bn->{sys};
  my $rsleep = $sys->{RecoverSleep};
  my $dir_temp = $p. '/recover';
  my $temp_index = $dir_temp. '/index';
  my $temp_sort = $dir_temp. '/sort';
  my $temp_number = $dir_temp. '/number';
  my $dir_permission = 0707;

  $ad->rmtree( $dir_temp ) if -e $dir_temp;

  # make temp dir
  mkdir $dir_temp,    $dir_permission or $bn->error( 'ERR_DIR_NOTMAKE', $dir_temp);
  mkdir $temp_sort,   $dir_permission or $bn->error( 'ERR_DIR_NOTMAKE', $temp_sort );
  mkdir $temp_index,  $dir_permission or $bn->error( 'ERR_DIR_NOTMAKE', $temp_index );
  mkdir $temp_number, $dir_permission or $bn->error( 'ERR_DIR_NOTMAKE', $temp_number );

  my $dh = $bn->opendir( $p );
  $dh or $bn->error( 'ERR_DIR_NOTFOUND', $p );

  my $log_count = 0;
  my $max_msg_count = 0;
  my $nlen = length "\n";

  my $max_log;
  while ( my $log_file = readdir $dh ) {
    next if $log_file !~ /(\d+)\.$sys->{Exe}$/;
    $max_log++;
  }

  seekdir $dh, 0;
  while ( my $log_file = readdir $dh ) {
    next if $log_file !~ /(\d+)\.$sys->{Exe}$/;

    my( $n, $endres, @dates );
    my $thread_no = $1;
    my $fh = $bn->open( $p. '/'. $log_file );
    $fh or $bn->error( 'ERR_DATA_NOTOPEN', $p. '/'. $log_file );
    if ( defined( my $line = <$fh> ) ) {
      my $val = {}; my $ex = {}; my %msg_num;
      $bn->get_log_main_value( $line, $val, $ex );

      # create html thread
      if ( $bn->get( $cf, 'UseHtmlThread' ) && exists $ex->{html} ) {
        my $path = "$bn->{bn_dir}/$ex->{html}";
        $path .= '.html' if $path !~ /\.html?$/;
        $bn->app->create_html( int $thread_no, $path );
      }

      # thread lastmodified
      $msg_num{$val->{num}}++;
      $max_msg_count = $val->{num} if $max_msg_count < $val->{num};
      my( $first_record, $last_record ) = $ad->get_record($val->{date}, $ex->{edit});

      # last reply date
      while ( <$fh> ) {
        my $val = {}; my $ex = {};
        $bn->get_log_reply_value( $_, $val, $ex );
        $max_msg_count = $val->{num} if $max_msg_count < $val->{num};
        $msg_num{$val->{num}}++;
        my( $f_date, $l_date ) = $ad->get_record( $val->{date}, $ex->{edit} );
        $first_record = $f_date if $first_record gt $f_date;
        $last_record = $l_date if $last_record lt $l_date;
      }
      close $fh;
      my @f_dates = split /\-/, $first_record;
      my @l_dates = split /\-/, $last_record;

      my $dir_first = "$temp_index/$f_dates[0]$f_dates[1]";
      my $dir_first_day = "$dir_first/$f_dates[2]";
      mkdir $dir_first, $dir_permission unless -d $dir_first;

      my $fh = $bn->open( $dir_first_day, '>>' );
      print $fh "$f_dates[3]$f_dates[4]$f_dates[5]-$thread_no\n";
      close $fh;

      my $dir_last = "$temp_sort/$l_dates[0]$l_dates[1]";
      my $dir_last_day = "$dir_last/$l_dates[2]";
      mkdir $dir_last, $dir_permission unless -d $dir_last;

      my $fh = $bn->open( $dir_last_day, '>>' );
      print $fh "$l_dates[3]$l_dates[4]$l_dates[5]-$thread_no\n";
      close $fh;

      while ( my($num, $n ) = each %msg_num ) { if ( $n > 1 ) {
        my $num = $ad->recover_log_number( $p. '/'. $log_file );
          $max_msg_count = $num if $max_msg_count < $num; last } }
    }
    $log_count++;
    $bn->print( '<script>BN_prog(0,"', $log_file, ' ', $log_count, '/', $max_log, '")</script>' )
      if $progress_on && $rsleep && !($log_count % 200);

#    sleep 1 if $rsleep && !($log_count % 200);
  }
  closedir $dh;
  return( $log_count, $max_msg_count );
}


sub recover_index_write {
  my( $ad, $log_count, $max_msg_count, $progress_on ) = @_;
  my $sys = $bn->{sys};
  my $rsleep = $sys->{RecoverSleep};
  my $p = $sys->{DirData};
  my $dir_temp = $p. '/recover';
  my $temp_sort = $dir_temp. '/sort';
  my $temp_index = $dir_temp. '/index';
  my $temp_number = $dir_temp. '/number';
  my $temp_index_cgi = $dir_temp. '/index.'. $sys->{Exe};
  my $temp_phase_cgi = $dir_temp. '/phase.'. $sys->{Exe};
  my $temp_number_bin = $dir_temp. '/number.bin';
  my $sys_index_cgi = $sys->{DirSys}. '/index.'. $sys->{Exe};
  my $sys_count_cgi = $sys->{DirSys}. '/count.'. $sys->{Exe};
  my $dir_permission = 0707;
  my $max_log_count = 0;
  my $index_count = 1;

  my $in_bin = $bn->open( $temp_index_cgi, '>' );
  binmode $in_bin;

  my $fh_phaze;
  if ( -e $temp_phase_cgi ) {
    $fh_phaze = $bn->open( $temp_phase_cgi, '+<' );
  } else {
    $fh_phaze = $bn->open( $temp_phase_cgi, '>' )
  }
  close $fh_phaze;

  my $dh_index = $bn->opendir( $temp_index );
  my @dir = readdir $dh_index;
  closedir $dh_index;
  @dir = reverse sort map( "$temp_index/$_", grep $_!~/^\.{1,2}$/s, @dir );

  for my $root_mon ( @dir ) {
    my $dh_mon = $bn->opendir( $root_mon );
    my @dir_day = readdir $dh_mon;
    closedir $dh_mon;

    @dir_day = reverse sort map( "$root_mon/$_", grep $_!~/^\.{1,2}$/s, @dir_day );

    for my $root_day ( @dir_day ) {
      my @day;
      my $fh = $bn->open( $root_day );
      while ( <$fh> ) { chomp; push @day, $_ }

      @day = reverse sort map( "$root_day/$_", grep $_!~/^\.{1,2}$/s, @day );

      for my $day_log ( @day ) {
        next if $day_log !~ /(\d+)$/;
        my $no = int $1;
        my $block = int( $no / 100 );
        my $bdir = "$temp_number/$block";

        $max_log_count = $no if $max_log_count < $no;
        $bn->print( '<script>BN_prog(',$index_count,")</script>\n" ) if $progress_on;

        print $in_bin pack 'S', $no;  # write bin index

        mkdir $bdir, $dir_permission if !-e $bdir;
        my $fh_num = $bn->open( "$bdir/$no", '>' );
        print $fh_num ( $log_count - $index_count );
        close $fh_num;

        $index_count++;
 #       sleep 1 if $rsleep && !( $index_count % 100 );
      }
    }
  }

  my $num_bin = $bn->open( $temp_number_bin, '+>' );
  binmode $num_bin;

  undef @dir;
  my $dh_sort = $bn->opendir( $temp_sort );
  @dir = readdir $dh_sort;
  closedir $dh_sort;
  @dir = reverse sort map( "$temp_sort/$_", grep $_!~/^\.{1,2}$/s, @dir );

  for my $root_mon ( @dir ) {
    my $dh = $bn->opendir( $root_mon );
    my @dir_day = readdir $dh;
    closedir $dh;
    @dir_day = reverse sort map( "$root_mon/$_", grep $_!~/^\.{1,2}$/s, @dir_day );

    for my $root_day ( @dir_day ) {
      my @day;
      my $fh = $bn->open( $root_day );
      while ( <$fh> ) { chomp; push @day, $_ }

      @day = reverse sort map( "$root_day/$_", grep $_!~/^\.{1,2}$/s, @day );

      for my $day_log ( @day ) {
        next if $day_log !~ /(\d+)$/;
        my $no = int $1;
        my $block = int( $no / 100 );
        my $bdir = "$temp_number/$block";

        my $fh_num = $bn->open( "$temp_number/$block/$no" );
        my $number = <$fh_num>;
        close $fh_num;

        $bn->print( '<script>BN_prog(',$index_count,")</script>\n" ) if $progress_on;
        $index_count++;
        print $in_bin pack 'S', $no; # write bin sort index
        print $num_bin pack 'S', $number; # write bin number
#        sleep 1 if $rsleep && !($index_count % 100);
      }
    }
  }

  seek $num_bin, 0, 0;
  read $num_bin, my $bin, (stat $num_bin)[7];
  close $num_bin;
  print $in_bin $bin;
  close $in_bin;

  my $fh_cnt = $bn->open( $sys_count_cgi, '>' );
  $fh_cnt or $bn->error( 'ERR_SYS_NOTWRITE', $sys_count_cgi );
  print $fh_cnt "$max_log_count\t$max_msg_count";
  close $fh_cnt;

  unlink $temp_number_bin;
  unlink $sys_index_cgi;
  rename $temp_index_cgi, $sys_index_cgi;

  $bn->print( '<script>BN_prog(0,"',
    ($bn->info('RECOVER_TEXT'))[3], '")</script>' ) if $progress_on;

  $ad->rmtree( $dir_temp );
  return( $max_log_count, $index_count );
}

sub recover_log_number {
  my( $ad, $file ) = @_;
  my $gl = $bn->{global};
  $bn->po->get_count($gl->{count}) if !exists $gl->{count};
  my $max_num = $gl->{count}{num};
  my $fh = $bn->open( $file );
  my $out = $bn->open( "$file.tmp", '>' );
  $fh or $bn->error( 'ERR_DATA_NOTOPEN', $file );
  my $line = <$fh>; my $flag;
  my $val = {}; my $ex = {}; my %msg_num;
  $bn->get_log_main_value( $line, $val, $ex );
  $msg_num{$val->{num}}++;
  $max_num = $val->{num} if $max_num < $val->{num};
  print $out $line;
  while ( <$fh> ) {
    my $val = {}; my $ex = {};
    $bn->get_log_reply_value( $_, $val, $ex );
    if ( exists $msg_num{$val->{num}} )
      { $flag = 1; $val->{num} = ++$max_num; s/^\d+/$max_num/ }
    $max_num = $val->{num} if $max_num < $val->{num};
    $msg_num{$val->{num}}++;
    print $out $_;
  }
  close $fh; close $out;

  if ( $max_num > $gl->{count}{num} ) {
    $gl->{count}{num} = $max_num;
    $bn->po->set_sys_item('count', "$gl->{count}{log}\t$max_num")
  }
  if ( $flag ) { my $r = unlink $file; rename "$file.tmp", $file }
   else { unlink "$file.tmp" }
  return $max_num;
}

sub get_record {
  my( $ad, $mdate, $edate ) = @_;
  my @edit_record = ( $mdate, split ',', $edate );
  my( $f_date, $l_date );
  for ( @edit_record ) {
    if ( /^(\d+)\/(\d+)\/(\d+) \(\w+\) (\d\d):(\d\d):?(\d\d)?/ ) {
      my $sec = $6 ? $6 : '00';
      my $date = "$1-$2-$3-$4-$5-$sec";
      $f_date = $date if $f_date gt $date;
      $l_date = $date if $l_date lt $date;
      $f_date = $date unless defined $f_date;
    }
  }
  return( $f_date, $l_date );
}

sub rmtree {
  my( $ad, $roots ) = @_;

  if ( defined($roots) && length( $roots ) )
   { $roots = [$roots] unless ref $roots } else { return 0 }

  my $count = 0;
  for my $root ( @{$roots} ) {
    $root =~ s#/$##;
    lstat $root or next;
    if ( -d _ ) {
      my $dh = $bn->opendir( $root ); $dh or return 0;
      my @files = readdir $dh;
      closedir $dh;
      @files = map( "$root/$_", grep $_!~/^\.{1,2}$/s, @files );
      $count += $ad->rmtree( \@files );
      ++$count if rmdir $root;
    } else {
      last unless unlink $root;
      ++$count;
    }
  }
  return $count;
}

1;

__END__
