#=============================================================================
# BBS Note Comet 1.x 
# Copyright(C) WonderCatStudio. All rights reserved.
# This code cannot be redistributed without
# permission from wondercatstudio.com
# LastModify : 2008/02/03
# Version : 0.10.000 build 3
#=============================================================================
package BN::App;
use strict;
use vars qw( $bn $VERSION );

$VERSION = '0.10.000';

sub new {
  my $ap = bless { }, $_[0];
  $bn = $_[1];
  $ap;
}


sub edit {
  my $ap = $_[0];
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my $sk = $bn->{skin};
  my $fl = $bn->{flag};
  my $gl = $bn->{global};

  $bn->call( 'EditBegin' );

  if ( $in->{number} =~ /(\d+)\-?(\d+)?/ ) {
    $in->{log} = $1;
    $gl->{res_num} = $2;
  }

  my $pass = defined $in->{password} ? $in->{password} : ($bn->get_admin_pass)[0];
  $bn->open_page and return unless defined $pass;
  $bn->check_password( $pass, $ap->get_log_password( $in->{log}, $gl->{res_num} ) )
   or $bn->error('PASSWORD_ERROR');

  my $val = $gl->{LogValue} = {};
  my $ex = $gl->{LogExValue} = {};

  $gl->{res_no} = $ap->get_log( $in->{log}, $gl->{res_num}, $val, $ex );

  if ( $bn->get( $cf, 'UseThreadLock' ) ) {
    $bn->check_authority( $in->{password} );
    $bn->error( 'ERR_THREAD_LOCK' ) if $fl->{thread_lock} && $fl->{AUTHORITY} ne 'ADMIN';
  }

  # init hook
  $bn->set_call( 'PostFormInitBegin', sub {
    my $gv = $gl->{value};
    for ( qw/name mail url message title/ ) { $gv->{$_} = $val->{$_} }
    $gv->{password} = $in->{password};
    $gv->{icon} = $ex->{icon};
    $gv->{nobr} = $ex->{nobr} if exists $ex->{nobr};

    # de panic
    $bn->pa->depanic( \$gv->{message} ,\$ex->{panic} ) if $ex->{panic};

    # de tag
    $ap->delete_tag( \$gv->{message}, $ex );

    # password item name
    $bn->{item}{password} = $bn->{item}{newpassword};

    # reply mode
    if ( $gl->{res_no} ) {
      if ( $bn->get( $cf, 'UseReplyTitle' ) ) {
        $bn->{flag}{POST_FORM_TITLE} = 1;
        $gv->{title} = $gl->{LogExValue}{title};
      }
      $gv->{kaiketu} = $gl->{LogExValue}{kaiketu} if $bn->get( $cf, 'UseTreeSppCheck' );
      $bn->{flag}{UPLOAD_ENABLE} = $bn->get( $cf, 'UseReplyUpload' );
    } else {
      $bn->{flag}{POST_FORM_TITLE} = 1;
      $bn->{flag}{UPLOAD_ENABLE} = $bn->get( $cf, 'UseUpload' );
    }
    $bn->call('EditLogPostFormInit');
  });

  # init hook
  $bn->set_call( 'PostFormInitEnd', sub {
    my $fr = $bn->{skin}{form};
    my $auth_date = int $bn->get( $cf, 'UseEditDate' );
    my $auth_html = int $bn->get( $cf, 'UseHtmlThread' );

    # edit : use date edit
    if ( $auth_date && ( $auth_date == 3 || $bn->po->check_auth( $auth_date ) ) ) {
      my $style = 'text-align:right' if $gl->{UserBrowserVer} ne 'NN 4';
      $val->{date} =~ /(\d+)\/(\d+)\/(\d+) \(\w+\) (\d+):(\d+):(\d+)/;
      $sk->{form}{date_edit} = [[
        [ { TAG => 'TD', colspan => '*', nowrap => 1 } ],
        [ $bn->get( $sk, 'TagFormItems' ), { string => ' ' . $bn->{item}{date_edit} }],
        [ { string => '<br>' } ],
        [ { TAG => 'INPUT', name => 'date_year', type => 'text', class => 'input',
          style => $style, size => '5', value => $1 } ],
        [ { string => $bn->{item}{date_edit_year} } ],
        [ { TAG => 'INPUT', name => 'date_month', type => 'text', class => 'input',
          style => $style, size => '3', value => $2 } ],
        [ { string => $bn->{item}{date_edit_month} } ],
        [ { TAG => 'INPUT', name => 'date_day', type => 'text', class => 'input',
          style => $style, size => '3', value => $3 } ],
        [ { string => $bn->{item}{date_edit_day} } ],
        [ { TAG => 'INPUT', name => 'date_hour', type => 'text', class => 'input',
          style => $style, size => '3', value => $4 } ],
        [ { string => ':' } ],
        [ { TAG => 'INPUT', name => 'date_min', type => 'text', class => 'input',
          style => $style, size => '3', value => $5 } ],
        [ { string => ':' } ],
        [ { TAG => 'INPUT', name => 'date_sec', type => 'text', class => 'input',
          style => $style, size => '3', value => $6 } ],
      ]];
      $bn->set_form( $fr->{FORMS}, $sk->{form}{date_edit}, 'insert' );
    }

    # edit : use html thread
    if ( !$gl->{res_num} && $auth_html && ( $auth_html == 3 || $bn->po->check_auth( $auth_html ) ) ) {
      $sk->{form}{htmlthread} = [[
        [ { TAG => 'TD', colspan => '*', nowrap => 1 } ],
        [ $bn->get($sk, 'TagFormItems') , { id => 'PostFormHtml', string => ' HTML<br>'} ],
        [ { TAG => 'INPUT', id => 'PostFormHtmlInput', type => 'text', name => 'html',
          value => $ex->{html}, class => 'input', size => 35 } ],
      ]];
      $bn->set_form( $fr->{FORMS}, $sk->{form}{htmlthread}, 'insert' );
    }
    $bn->set_form( $fr->{FORMS}, { TAG => 'INPUT', type => 'hidden', name => 'checkpass', value => $in->{password} }, 'right', 'fc' );
    $bn->set_form( $fr->{FORMS}, { TAG => 'INPUT', type => 'hidden', name => 'edit', value => $gl->{res_num} }, 'right', 'fc' );
  });

  $bn->send_http_header->mail_crypt;
  $bn->call( 'EditEnd' );
  $ap->post_form;
  $bn->foot( 'NotPageLink' );
}

sub delete {
  my $ap = $_[0];
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my $sk = $bn->{skin};
  my $fl = $bn->{flag};
  my $ck = $bn->{cookie};
  my $gl = $bn->{global};
  my $fr = $sk->{form};
  my( $f, @del_list, %list );
  map { push @del_list,$1 if /^log([\d\-]+)/ } keys %$in;
  for ( @del_list ) { if ( $_ eq $in->{number} ) { $f = 1; last } }
  push @del_list, $in->{number} if !$f;

  for my $num ( @del_list ) { if ($num =~ /^(\d+)$/) { $list{$1} = '' } }
  for my $num ( @del_list ) {
    if ( $num=~/(\d+)\-(\d+)/ ) {
      my $log = $1;
      my $res = $2;
      next if exists $list{$log} && !$list{$log};
      $list{$log} .= "$res:";
    }
  }

  # pass cover
  $in->{password} = ($bn->get_admin_pass)[0] unless defined $in->{password};

  # limit delete
  $bn->check_limit_post( 'Delete' ) or $bn->error( 'ERR_DELETE_AUTHOR' );
  $bn->check_authority( $in->{password} );

  for my $log ( keys %list ) {
    my @r = split /:/, $list{$log};
    $r[0] = '' unless @r;
    for my $res ( @r ) {
      $bn->check_password( $in->{password}, $ap->get_log_password( $log, $res ) )
        or $bn->error( 'PASSWORD_ERROR' );
      if ( $bn->get( $cf, 'UseThreadLock' ) ) {
        $bn->error( 'ERR_THREAD_LOCK' ) if $fl->{thread_lock} && $fl->{AUTHORITY} ne 'ADMIN';
      }
    }
  }

  $bn->call( 'DeleteLogBegin' );

  $bn->filelock;
  for my $log ( keys %list ) {
    my @r = split /:/, $list{$log};
    $r[0] = '' if !@r;
    for my $res ( @r ) {
      if ( $res ) {
        $ap->delete_log_reply( $log, $res );
        if ( $bn->get( $cf, 'UseHtmlThread' ) ) {
          my $ex = {};
          $ap->get_log( $log, undef, {}, $ex );
          if ( exists $ex->{html} ) {
            my $path = $bn->{bn_dir}.'/'.$ex->{html};
            $path .= '.html' if $path !~ /\.html?$/;
            unlink $path if -e $path;
            $ap->create_html( $log, $path );
          }
        }
      } else {
        $ap->delete_log_main( $log );
      }
    }
  }
  eval{

  $bn->call( 'DeleteLogEnd' );

  # index.html reflesh
  $ap->reflesh;
  $bn->fileunlock;
  if ( $bn->{sys}{MODE} =~ /ADMIN/ ) {
    $in->{mode} = '' unless $#del_list;
    return
  }
  $bn->open_page;
};if ($@) {
    $bn->end( '', 'DEBUG', $@ );
  }
}

sub reflesh {
  my $ap = $_[0];
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my $sk = $bn->{skin};
  my $fl = $bn->{flag};
  my $gl = $bn->{global};
  my $sys = $bn->{sys};

  my $path = $bn->{bn_dir}. $bn->get( $cf, 'IndexFilePath' );
  unlink $path;
  unlink $sys->{DirSys}. '/boot.'. $sys->{Exe} if $sys->{MODE} eq 'ADMIN';

  return unless $ap->reflesh_ok;

  $bn->filelock;

  # valiable backup
  my @back_agent = @{$gl}{'UserAgent','UserOS','UserBrowser','UserBrowserVer'};
  my $back_mode = $sys->{MODE};
  my %back_in = %{$bn->{in}};
  my %back_fl = %{$bn->{flag}};
  my %back_ck = %{$bn->{cookie}};
  my %index = %{$sys->{index}} if exists $sys->{index};

  # undef
  undef $gl->{UserAgent};
  undef $gl->{UserOS};
  undef $gl->{UserBrowser};
  undef $gl->{UserBrowserVer};
  undef $sys->{MODE};
  undef %{$bn->{in}};
  undef %{$bn->{flag}};
  undef %{$bn->{cookie}};
  delete $sys->{index};

  $bn->{flag}{LOCKED} = $back_fl{LOCKED};
  $fl->{CORE_PRINT} = 1;
  $fl->{RefleshIndex} = 1;

  $bn->call( 'RefleshIndexInit' );

  my $fh;
  eval{ $fh = $bn->open( $path, '>' ) };
  $fh or $bn->error( 'ERR_SYS_NOTWRITE', $path );
  $bn->{temp}{fh}{indextop} = $fh;

  $gl->{Page} = 0 ;
  $gl->{Index} = 0;

  my @ro = split ',', $bn->get( $cf, 'ViewRotation' );
  $in->{mode} = $ro[0] if !exists $in->{mode};

  my $log_view = $bn->get( $cf, 'LogView' );
  $sys->{sortmode} = $bn->get( $cf, 'ViewSortType' );

  # change output handle
  my $out = select $fh;

  $bn->open_index;
  my( @indexs, @threads );
  for (my $index_pos = 0, my $index_seek = $gl->{Index};
      $index_pos < $log_view && $index_seek < $gl->{LogTotal};
      $index_pos++, $index_seek++
  ) {
    push @indexs, $bn->read_index($index_seek, $sys->{sortmode});
    push @threads, ($sys->{sortmode} ? $bn->read_index($index_seek, 2) : $gl->{LogTotal} - $index_seek);
  }
  $bn->close_index;

  $bn->call( 'RefleshIndexBegin' );

  unless ($bn->mail_crypt->head(undef, undef, 1)->tree)
   { goto REFLESH_END }

  $bn->menu;

  for ( my $i = 0, $gl->{IndexPos} = 0;
    $i <= $#indexs;
    $gl->{IndexPos}++, $gl->{Index}++, $i++
  ) {
    $gl->{IndexNumber} = $indexs[$i];
    $gl->{ThreadNumber} = $threads[$i];
    $bn->open_log($gl->{IndexNumber});
  }

  $bn->foot;

  REFLESH_END:
  $bn->close_index;
  delete $bn->{temp}{fh}{indextop};
  close $fh;

  $bn->fileunlock;
  if ( $bn->get( $cf, 'UseRssIndex' ) ) {
    $path =~ s/([^\\\/]+)$//;
    my $file = $1;
    $file =~ s/([^\.]+)$//;
    $path .= $file. 'rdf';
    my $fh = $bn->open( $path, '>' );
    $fh or $bn->error( 'ERR_SYS_NOTWRITE', $path );
    select $fh;
    $bn->{temp}{fh}{indexrss} = $fh;
    $bn->xml->rss1( 'NO_HEADER' );
    delete $bn->{temp}{fh}{indexrss};
    close $fh;
  }
  select $out;


  @{$gl}{'UserAgent','UserOS','UserBrowser','UserBrowserVer'} = @back_agent;
  $sys->{MODE} = $back_mode;
  %{$bn->{in}} = %back_in;
  %{$bn->{flag}} = %back_fl;
  %{$bn->{cookie}} = %back_ck;
  delete $sys->{index};
  delete $gl->{LogTotal};

  undef %{$fl->{JavaScript}};

  $bn->call( 'RefleshIndexEnd' );

  $ap;
}

sub post_form {
  my $ap = $_[0];
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my $sk = $bn->{skin};
  my $gl = $bn->{global};
  my $sys = $bn->{sys};

  $bn->head;

  my $data = $bn->{data} = {};

  $bn->bsys_init( $data );
  $bn->tag_init( $data );

  # mode
  my $mode = lc $bn->{sys}{MODE};
  $mode =~ s/write_//;
  $data->{'mode_' . $mode} = 1;

  $bn->call( 'PostFormBegin' );

  if ( $sys->{MODE} eq 'REPLY' ) {
    $gl->{IndexNumber} = $in->{log};
    $gl->{ThreadNumber} = $in->{no};
    my $f = $bn->check_reply_enable( $bn->get_reply_status( $in->{log} ) );
    $bn->open_log( $gl->{IndexNumber} );
    return unless $f;
  } elsif( $sys->{MODE} eq 'EDIT' ) {
    $gl->{IndexNumber} = $gl->{ThreadNumber} = $in->{log};
    $in->{res} = $gl->{res_no};
    $bn->open_log( $in->{log} );
  }

  $data->{number} = $sys->{MODE} eq 'REPLY' ?
    $bn->get( $cf, 'UseTree' ) ? $in->{no}. '-'. $gl->{num} :
      $in->{no} : $in->{number} ? $in->{number} : $in->{log};

  $data->{postform} .= $bn->create_post_form;

  $bn->call( 'PostFormTranslate' );

  $data->{backbutton} = $bn->back_button unless $bn->get( $cf, 'UseTree' );
  $bn->translate( $sk->{template}{POST}, $data );
  $bn->call( 'PostFormEnd' );
  $ap;
}

sub check_post_range {
  my( $ap, $mode ) = @_;
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my $fl = $bn->{flag};
  my $gl = $bn->{global};
  my $sys = $bn->{sys};
  $mode ||= $sys->{MODE};

  my ( %c, $cf_mode, $guest_check );
  if ( $mode eq 'POST' || $mode eq 'PAINT' ) { $cf_mode = 'new' }
  elsif ( $mode eq 'WRITE_POST'  ) { $cf_mode = 'new';   $guest_check = 1 }
  elsif ( $mode eq 'REPLY'       ) { $cf_mode = 'reply' }
  elsif ( $mode eq 'WRITE_REPLY' ) { $cf_mode = 'reply'; $guest_check = 1 }

  for( split ';', $bn->get( $cf, 'LimitPostRange' ) ) {
    my @a = split ':', $_, 2; next if $a[0] ne $cf_mode;
    for ( split ',', $a[1] ) { my @v = split '=', $_, 2; $c{$v[0]} = $v[1] if $v[1] } }

  $bn->check_authority if !exists $fl->{AUTHORITY};

  return $ap if $fl->{AUTHORITY} =~ /ADMIN/
   || !( $c{log} && $c{day} || $c{hour} ) || ( $c{guest} && !$guest_check );

  # disable mail sage : need reply index update
  $fl->{disable_sage} = 1;

  # user
  if ( $guest_check && $c{guest} && $bn->get($cf, 'UseNameCap') ) {
    $bn->usr->cap( $in->{name}, $in->{password}, $gl->{LogExValue} );
    if ( $gl->{LogExValue}{user_cap} ) { $fl->{no_name_cap} = 1; return $ap }
  }

  my $limit = $bn->get_date( time - ( $c{day} ? ( $c{day} - 1 ) * 86400 :
   ( $c{hour} * 3600 ) -1 ) + $bn->get($cf, 'TimeDiffSec') );
  $limit =~ s/\D//g;
  $limit = substr $limit, 0, -6 if $c{day};
  $bn->get_user_ip if !exists $gl->{IP};

  my( $hit, $err );
  $bn->open_index;
  for ( my $i = 0; $i < $gl->{LogTotal}; $i++ ) {
    my $fh = $bn->open( $bn->filelog( $bn->read_index( $i, 1 ) ) );
    if ( $cf_mode eq 'new' ) {
      my $val = {}; my $ex = {};
      while ( <$fh> ) { next if !/^\d/; $bn->get_log_main_value($_, $val, $ex); last }
      close $fh;
      my $date = exists $ex->{edit} ?
       (split '@', (split ',',$ex->{edit}, 2)[0], 2)[0] : $val->{date};
      $date =~ s/\D//g; next if $date eq '';
      if ( $limit le $date ) {
        if ( $val->{ip} eq $gl->{IP} )
         { $hit++; if ( $c{log} <= $hit ) { $err = 1; last } }
      } else { last }
    } elsif( $cf_mode eq 'reply' ) {
      my( $n, $m );
      while ( <$fh> ) { next if !/^\d/;
        $n++; my $val = {}; my $ex = {};
        $n == 1 ? $bn->get_log_main_value($_, $val, $ex) :
         $bn->get_log_reply_value($_, $val, $ex);
        my $date = exists $ex->{edit} ?
         (split '@', (split ',',$ex->{edit}, 2)[0], 2)[0] : $val->{date};
        $date =~ s/\D//g; next if $date eq '';
        if ( $limit le $date ) {
          $m++; next if $n == 1;
          my $ip = $1 if $val->{iphost} =~ /(\d+\.\d+\.\d+\.\d+)/;
          if ( $ip eq $gl->{IP} ) { $hit++; if ( $c{log} <= $hit ) { $err = 1; last } }
        }
      }
      close $fh;
      last if !$m || $err;
    }
  }

  $bn->close_index;
  delete $sys->{index}{total};

  if ( $err ) {
    my $item = $bn->text(undef, 'setting');
    $bn->error( 'ERR_POST_RANGE', ( $c{day} ? $c{day}.$item->{day} :
     $c{hour}.$item->{hour} ), $c{log}, $item->{'limit_post_multi_'.$cf_mode} );
  }
  $ap;
}

sub get_log {
  my( $ap, $log, $res, $ref_val, $ref_ex ) = @_;
  my $cf = $bn->{cfg};
  my $gl = $bn->{global};
  my $path = $bn->filelog( $log );

  $bn->error( 'ERR_DATA_NOTFOUND',
    ( $path =~ /([^\/\\]+)$/ ? $1 : $path ) ) unless -e $path;

  my $fh = $bn->open( $path );
  $fh or $bn->error( 'ERR_DATA_NOTOPEN', $path );

  my @data;
  while ( <$fh> ) { push @data, $_ }
  $gl->{LogSize} = (stat $fh)[7];
  $gl->{LogReply} = $#data;
  close $fh;

  if ( $bn->get( $cf, 'UseThreadLock' ) ) {
    my $val = {}; my $ex = {};
    $bn->get_log_main_value( $data[0], $val, $ex );
    $bn->{flag}{thread_lock} = 1 if $ex->{thread_lock};
  }

  if ( $res ne '' ) {
    for ( my $n = 1; $n <= $gl->{LogReply}; $n++ ) {
      undef %$ref_val; undef %$ref_ex;
      $bn->get_log_reply_value( $data[$n], $ref_val, $ref_ex );
      return $n if $ref_val->{num} eq $res;
    }
    if ( @data > $res ) {
      $bn->get_log_reply_value( $data[$res], $ref_val, $ref_ex );
      return $res;
    }
    $bn->error( 'ERR_DATA_NOTFOUND', 'res number '. $#data );
  } else {
    $bn->get_log_main_value( $data[0], $ref_val, $ref_ex );
  }
  return 0;
}

sub delete_tag {
  my( $ap, $ms, $ex )= @_;
  if ( exists $ex->{nobr} && $ex->{nobr} ) {
    $$ms =~ s/<!br>/\n/g;
  } else {
    $$ms =~ s/<br>/\n/ig;
  }
  $$ms =~ s/&(lt|gt|quot);/&amp;$1;/g;
  $$ms =~ s/<\/?SPAN class="quot">//ig;
  $$ms =~ s/<\/?A["-.!~*'()\w;\/?:\@&=+\$,%# ]*class="(?:quot|autolinkurl|autolinkmail)"( rel="nofollow")?>//g;
  $$ms =~ s/</&lt;/g;
  $$ms =~ s/>/&gt;/g;
}

sub get_log_password {
  my( $ap, $log, $res ) = @_;
  my $cf = $bn->{cfg};
  my $gl = $bn->{global};
  my $path = $bn->filelog( $log );
  my $val = {};
  my $ex = {};

  $bn->error( 'ERR_DATA_NOTFOUND',
    ( $path =~ /([^\/\\]*)$/ ? "$1" : $path ) ) unless -e $path;

  my $fh = $bn->open( $path );
  $fh or $bn->error( 'ERR_DATA_NOTOPEN', $path );

  if ( $bn->get( $cf, 'UseThreadLock' ) ) {
    $_ = <$fh>; seek $fh, 0, 0;
    $bn->get_log_main_value( $_, $val, $ex );
    $bn->{flag}{thread_lock} = 1 if $ex->{thread_lock};
  }

  if ( $res ) {
    while ( <$fh> ) {
      $bn->get_log_reply_value( $_, $val, $ex );
      last if $val->{num} eq $res;
    }
  } else {
    $_ = <$fh>;
    $bn->get_log_main_value( $_, $val, $ex );
  }

  close $fh;
  return $val->{password};
}

sub hook_create_html {
  my( $ap, $ex ) = @_;
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my $sk = $bn->{skin};
  my $dir = $bn->{bn_dir};
  my $html = exists $in->{html} ? $in->{html} : exists $ex->{html} ? $ex->{html} : undef;
  return unless defined $html;

  # /* this routine inside file lock */

  $html =~ s#(//|\\\\)#/#g;
  $html =~ s#[:,;\*\?"<>\|]##g;

  if ( exists $ex->{html} ) {
    my $path = "$dir/$ex->{html}";
    $path .= '.html' if $path !~ /\.html?$/;
    unlink $path if -e $path;
  }

  $html ne '' ? $ex->{html} = $html : delete $ex->{html};

  return if $html eq '';

  my $path = "$dir/$html";
  $path .= '.html' if $path !~ /\.html?$/;

  my $fh = $bn->open( $path, '>' );
  $fh or $bn->error( 'BAD_WRITE', $path );
  close $fh;
#  $bn->{template}{import} = 0;

  $bn->set_call( 'WriteHistoryEnd', sub { $ap->create_html(int $in->{log}, $path) });

}

sub create_html {
  my( $ap, $log, $path ) = @_;
  my $fl = $bn->{flag};
  my $gl = $bn->{global};
  my $sys = $bn->{sys};

  # valiable backup
  my @back_agent = @{$gl}{'UserAgent','UserOS','UserBrowser','UserBrowserVer'};
  my $back_mode = $sys->{MODE};
  my %back_in = %{$bn->{in}};
  my %back_fl = %{$bn->{flag}};
  my %back_ck = %{$bn->{cookie}};

  # undef
  undef $gl->{UserAgent};
  undef $gl->{UserOS};
  undef $gl->{UserBrowser};
  undef $gl->{UserBrowserVer};
  undef $sys->{MODE};
  undef %{$bn->{in}};
  undef %{$bn->{flag}};
  undef %{$bn->{cookie}};

  $bn->{in}{fc} = 'thread';
  $bn->{in}{log} = $gl->{IndexNumber} = $gl->{ThreadNumber} = $log;

  # change output handle
  $fl->{CORE_PRINT} = 1;
  $fl->{CreateHtml} = 1;
  $fl->{thread_view} = 1;
  # import count reset
#  $bn->{template} = { import => 0 };
  $bn->{template}{import} = 0;

  $bn->call( 'CreateHtmlThread' );

  # title get
  my $fh_log = $bn->open( $bn->filelog( $log ) );
  $fh_log or return;
  my $data = <$fh_log>;
  close $fh_log;
  my $val = {};
  $bn->get_log_main_value( $data, $val, {} );

  my $fh = $bn->open( $path, '>' );
  my $out = select $fh;
  $bn->get_mtime( $path );
  $bn->{temp}{fh}{htmlthread} = $fh;

  $bn->mail_crypt->head( $val->{title} )->menu;
  $bn->open_log( $log );
  $bn->foot( 'NotPageLink' );

  delete $bn->{temp}{fh}{htmlthread};
  close $fh;
  select $out;

  # ϐA
  @{$gl}{'UserAgent','UserOS','UserBrowser','UserBrowserVer'} = @back_agent;
  $sys->{MODE} = $back_mode;
  %{$bn->{in}} = %back_in;
  %{$bn->{flag}} = %back_fl;
  %{$bn->{cookie}} = %back_ck;

  undef %{$fl->{JavaScript}};
}


sub delete_index {
  my( $ap, $num, $try_count ) = @_;
  my $sys = $bn->{sys};
  # try_count : auto recover try count
  my( $i, $e, $s, $list );

  my $path = $sys->{DirSys}. '/index.'. $sys->{Exe};
  my $bin = pack 'S', $num;

  my( $fh_tmp, $tmp ) = $bn->get_temp_file;
  binmode $fh_tmp;

  my $fh_index = $bn->open_index;
  my $total = $sys->{index}{total};

  while ( read $fh_index, $s, 2 ) {
    $i++;
    if ( $s eq $bin ) { $e++ } else { print $fh_tmp $s }
    last if $i >= $total * 2;
  }

  $e /= 2;
  my $max = $total - $e;
  seek $fh_tmp, 0, 0;
  read $fh_tmp, $list, $max * 2;
  $i = 0;
  while ( read $fh_tmp, $s, 2 ) {
    $i++;
    my $no;
    for ( my $n = 0; $n <= $max; $n++ ) {
      if ( $s eq substr $list, $n * 2, 2 )
       { $no = $max - $n; last }
    }
    if ( $no ) {
      seek $fh_tmp, $max * 2 - 2 , 1;
      print $fh_tmp pack 'S', $no;
      seek $fh_tmp, ( $max + $i ) * 2, 0;
    } else {
      $bn->close_index;
      close $fh_tmp;
      unlink $tmp;
      # system index broken
      if ( $try_count ) {
        $bn->warn( "delete_index : system index broken. auto recover \(try $try_count\) $ENV{SCRIPT_FILENAME}" );
        $bn->ad->recover_sys_index_silent;
        return $ap->delete_index( $num, --$try_count );
      } else {
        $bn->warn( "delete_index : system index broken. Fatal Damage ! $ENV{SCRIPT_FILENAME}" );
        $bn->error( 'ERR_SYS_BROKENINDEX' );
      }
    }
    last if $i >= $max;
  }
  $bn->close_index;
  close $fh_tmp;

  rename $tmp, $path
    or unlink $tmp && $bn->error( 'ERR_SYS_NOTWRITE', $path );
}

sub delete_files {
  my $ap = shift;
  for my $f (@_) {
    $f =~ s/[\/\\\t\n\r\f]//g;
    unlink "$bn->{sys}{DirData}/$f";
  }
}

sub delete_log_main {
# /* under filelock */
  my( $ap, $log ) = @_;
  my $gl = $bn->{global};
  my $path = $bn->filelog( $log );
  $gl->{log} = $log;
  delete $bn->{flag}{NotDelSysIndex};
  my $val = $gl->{DeleteLogValue} = {};
  my $ex = $gl->{DeleteLogExValue} = {};

  my $fh = $gl->{fh} = $bn->open( $path );
  if ( $fh ) {
    $bn->call( 'DeleteLogMainBegin' );
    $_ = <$fh>;
    $bn->get_log_main_value( $_, $val, $ex );
    unlink "$bn->{bn_dir}$ex->{html}" . ( $ex->{html} !~ /\.html$/ ? '.html' : '' ) if exists $ex->{html};

    $ap->delete_files(@{$val}{'file_name', 'object'},
      @{$ex}{'filename','file_name','thumbnail','imagesrc', 'thumbsrc', 'animesrc', 'html'});

    while (<$fh>) {
      my $val = {}; my $ex = {};
      $bn->get_log_reply_value($_, $val, $ex);
      $ap->delete_files(@{$ex}{'filename','file_name','thumbnail','imagesrc','thumbsrc','animesrc'});
    }
    delete $gl->{fh};
    close $fh;
    unlink $path;
    $bn->call( 'DeleteLogMainEnd' );
  }

  $ap->delete_index( $log, 1 ) unless $bn->{flag}{NotDelSysIndex};
}

sub delete_log_reply {
# /* under filelock */
  my( $ap, $log, $res ) = @_;
  my $cf = $bn->{cfg};
  my $gl = $bn->{global};
  my $path = $gl->{Logfile} = $bn->filelog($log);
  delete $bn->{flag}{NotDelSysIndex};

  $bn->call( 'DeleteLogReplyBegin' );

  my($fh_tmp, $tmp) = $bn->get_temp_file;
  my $fh = $bn->open( $path );
  $fh or $bn->error( 'ERR_DATA_NOTOPEN', $path );

  while ( <$fh> ) {
    my $val = {}; my $ex = {};
    $bn->get_log_reply_value( $_, $val, $ex );
    if ( $val->{num} eq $res ) {
      $ap->delete_files(@{$ex}{'filename','file_name','thumbnail','imagesrc','thumbsrc','animesrc'});
      $bn->call( 'DeleteLogReplyData' );
    } elsif ($val->{num} eq '' || !exists $val->{date} || !exists $val->{password}) {
      # warm
    } else {
      print $fh_tmp $_;
    }
  }
  close $fh;
  close $fh_tmp;

  rename $tmp, $path
    or unlink $tmp && $bn->error( 'ERR_SYS_NOTWRITE', $path );

  unless ( -s $path ) {
    unlink $path;
    $ap->delete_index( $log, 1 ) unless $bn->{flag}{NotDelSysIndex};
  }
  chmod oct $bn->get($cf, 'Permission'), $path;

  $bn->call( 'DeleteLogReplyEnd' );
}

sub reflesh_ok {
  my $cf = $bn->{cfg};
  my $sk = $bn->{skin};
  return 1 if $bn->{param}{ConfigNoCoverReflesh};
  return !$bn->get($cf, 'UseRefleshIndex') ||
  $bn->get($cf, 'UseAccessLog') ||
  $bn->get($cf, 'UseCounter') ||
  $bn->get($sk, 'FormType') ne 'normal' ||
  $bn->get($sk, 'ViewTopForm') ||
  ($bn->get($cf, 'UseTree') && $bn->get($cf, 'UseTreeFrame')) ||
  $bn->get($cf, 'LimitSecurityProxy') ne '4' ||
  $bn->get($cf, 'LimitSecurityDenyIp') ne '' ||
  $bn->get($cf, 'LimitSecurityDenyHost') ne '' ||
  $bn->get($cf, 'LimitSecurityAcceptIp') ne '' ||
  $bn->get($cf, 'LimitSecurityAcceptHost') ne '' ||
  $bn->get($cf, 'LimitSecurityAcceptRef') ne '' ||
  $bn->get($cf, 'LimitSecurityDenyRawIp') ||
  $bn->get($cf, 'LimitSecurityBookMark') ||
  $bn->get($cf, 'LimitSecurityAcceptUser')
  ? 0 : 1;
}

1;

__END__
