#=============================================================================
# BBS Note Comet 1.x 
# Copyright(C) WonderCatStudio. All rights reserved.
# This code cannot be redistributed without
# permission from wondercatstudio.com
# LastModify : 2006/07/11
# Version : 0.07
#=============================================================================
package BN::Help;
use strict;
use vars qw( $bn $VERSION );

$VERSION = '0.07.004';

sub new {
  my $hp = bless { }, $_[0];
  $bn = $_[1];
  $hp->init;
}

sub init {
  my $hp = $_[0];
  my $in = $bn->{in};
  if ($in->{mode} eq 'module') { $hp->module }
  else { $hp->config }
  $hp;
}

sub config {
  my $hp = $_[0];
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my $sk = $bn->{skin};
  my $fl = $bn->{flag};
  my $gl = $bn->{global};
  my $mo = $bn->{module};

  $gl->{title} = '';

  $bn->set_call( 'SkinHeadFormat',sub{ $gl->{title} = $bn->{data}{title} } );

  $bn->{sys}{MODE} = 'HELP';

  if ( exists $in->{cookiedelete} ) {
    $bn->get_date(1);
    delete $bn->{cookie};
    $fl->{write_cookie} = 1;
  }

  $bn->send_http_header( undef, 1 )->head;

  $gl->{HelpContents} = '';

  $bn->call( 'OpenHelpBegin' );

  my $cfg = $bn->text( 'CONFIG_TEXT' );
  my $help = $bn->text( 'HELP_TEXT' );
  my $tag_in = $bn->get( $sk, 'TagTableIn' );
  my $tag_out = $bn->get( $sk, 'TagTableOut' );

  my $bg1 = ref $tag_out eq 'HASH' ? $tag_out->{bgcolor} : '#000000';
  my $bg2 = ref $tag_in eq 'HASH' ? $tag_in->{bgcolor} : '#FFFFFF';

  $bn->call( 'OpenHelpBbsVer' );

  $gl->{HelpContents} .= $help->{copyright_logo};

  # Cookie
  $gl->{HelpContents} .= '<p><b>[ Cookie Delete ]</b> '. $help->{cookie_delete}. '</p>'
   if exists $in->{cookiedelete};

  if ( exists $in->{cookiedump} ) {
    $gl->{HelpContents} .= '<p><b>[ Cookie Data ]</b><table style="font-size:10pt;color:'.$bg2.'" cellspacing="1" cellpadding="3" width="100%">';
    my $i;
    for ( keys %{$bn->{cookie}} )
     { $gl->{HelpContents} .= '<tr><td bgcolor="'. $bg1. '" width="50%">'. $_.
       '</td><td bgcolor="'. $bg1. '">'. $bn->{cookie}{$_}. '</td></tr>'; $i++ }
    $gl->{HelpContents} .= '<tr><td bgcolor="'.$bg1.'" align="center">Cookie Data None</td></tr>' unless $i;
    $gl->{HelpContents} .= '</table></p>';
  }

  $bn->call( 'OpenHelpConfig' );

  my $lr_type = $bn->get( $cf, 'LimitResType' );
  my $lr_total = $bn->get( $cf, 'LimitResTotal' );
  my $lr_size = $bn->get( $cf, 'LimitResLogSize' );

  my $r = ( $lr_type == 0 ? $cfg->{reply}. $lr_total. $cfg->{posted} :
  $lr_type ==1 ? $cfg->{capacity}. $lr_size. ' byte':
  $lr_type ==2 ? $cfg->{reply}. $lr_total. $cfg->{posted}. $cfg->{'or'}. $cfg->{capacity}. $lr_size. ' byte':
  $lr_type ==3 ? $cfg->{reply}. $lr_total. $cfg->{posted}. $cfg->{'and'}. $cfg->{capacity}. $lr_size. ' byte':'' );

  $gl->{HelpContents} .= '<hr size="1" color="'. $bg1. '"><b>'. $help->{config_setting}. '</b><table width="100%" style="font-size:10pt;color:'. $bg2. '" cellspacing="1" cellpadding="3">';
  my @config = (
    [ 'max_log',       $bn->get( $cf, 'LogMax' ). $cfg->{posted} ],
    [ 'limit_message', $bn->get( $cf, 'LimitMessage' ). ' byte' ],
    [ 'limit_reply',   $r ],
    [ 'limit_upload', $bn->get( $cf, 'UseUpload' ) ? $bn->get( $cf, 'LimitUpLoadData' ). ' byte' : undef ],
    [ 'limit_paint', exists $mo->{Paint} ? $bn->get( $cf, 'LimitPaintData' ). ' byte' : undef ],
    [ 'limit_anime', exists $mo->{Paint} ? $bn->get( $cf, 'LimitAnimeData' ). ' byte' : undef ],
    [ 'limit_thumb', $bn->get( $cf, 'LimitThumbnailData' ). ' byte' ],
    [ 'limit_image', $bn->get( $cf, 'LimitImageWidth' ) . ' x ' . $bn->get( $cf, 'LimitImageHeight' ) ],
    [ 'view_image', $bn->get( $cf, 'ViewLimitImageWidth' ) . ' x ' . $bn->get( $cf, 'ViewLimitImageHeight' ) ],
    [ 'auto_link', ( $bn->get( $cf, 'UseAutoLinkUrl' ) ? $cfg->{yes} : $cfg->{no} ) ],
    [ 'auto_mailto', ( $bn->get( $cf, 'UseAutoLinkMail' ) ? $cfg->{yes} : $cfg->{no} ) ],
    [ 'quotation', ( $bn->get( $cf, 'UseQuotation' ) ? $cfg->{yes} : undef ) ],
    [ 'access_log', ( $bn->get( $cf, 'UseAccessLog' ) ? $cfg->{yes} : undef ) ],
    [ 'message_only_post', ( $bn->get( $cf, 'NeedData' ) ? $cfg->{disabled} : undef ) ],
    [ 'upload', ( $bn->get( $cf, 'UseUpload' ) ? $cfg->{enabled} : undef ) ],
    [ 'perl', $] ],
  );

  push @config, [ $1, $2 ] if $ENV{MOD_PERL} =~ /(.+)\/(.+)/;

  if ( $bn->get( $cf, 'UseGD' ) ) {
    eval{ require GD };
    push @config, [ 'gd', $@ ? $help->{not_install} : $GD::VERSION ];
  }
  if ( $bn->get( $cf, 'UsePerlMagick' ) ) {
    eval{ require Image::Magick };
    push @config, [ 'PerlMagick', $@ ? $help->{not_install} : $Image::Magick::VERSION ];
  }
  if ( $bn->get( $cf, 'UseImageMagick' ) ) {
    my $path = $bn->get( $cf, 'ImageMagickPath' );
    my @ver = `$path -verion`;
    push @config, [ 'ImageMagick', ( @ver && $ver[0] =~ /ImageMagick ([\d\.]+)/ ? $1 : $help->{not_install} ) ];
  }

  for ( @config ) {
    next unless defined $_->[1];
    $gl->{HelpContents} .= '<tr><td style="background-color:'. $bg1. '" width="50%" nowrap="nowrap">'.
    ( exists $cfg->{$_->[0]} ? $cfg->{$_->[0]} : $_->[0] ).
    '</td><td style="background-color:'.$bg1.'">'. $_->[1]. "</td></tr>\n";
  }

  if ( $bn->get( $cf, 'UseTag' ) == 1 ) {
    $gl->{HelpContents} .= '<tr><td bgcolor="'.$bg1.'" colspan="2">'. $help->{enable_tags}. ' : <tt>';
    for ( @{ $bn->get( $cf, 'OkTag' ) } ) { $gl->{HelpContents} .= '&lt;'.$_.'&gt;&nbsp;<nobr>' }
    $gl->{HelpContents} .= '</td></tr>';
  }
  $gl->{HelpContents} .= '</table>';

  $bn->call( 'OpenHelpSkin' );

  my %skin = (
    skin       => $bn->get( $sk, 'SkinName' ),
    version    => $bn->get( $sk, 'SkinVersion' ),
    lastmodify => $bn->get( $sk, 'SkinLastmodify' ),
    copyright  => $bn->get( $sk, 'SkinCopyright' ),
    author     => $bn->get( $sk, 'SkinAuthor' ),
    siteurl    => $bn->get( $sk, 'SkinAuthorSiteURL' ),
    comment    => $bn->get( $sk, 'SkinComment' ),
  );

  $gl->{HelpContents} .= '<hr size="1" color="'.$bg1.'"><b>'.$help->{skin_info}.' : '.$skin{skin}.'</b>'.
   '<table bgcolor="'.$bg1.'" cellspacing="0" cellpadding="0">'.
   '<tr><td><table style="color:'.$bg1.';font-size:10pt" cellspacing="1" cellpadding="3">'.
   '<tr style="background-color:'.$bg2.'">'.
   '<td><b>'. $help->{version}. '</b> : '. $skin{version}. '</td>'.
   '<td><b>'. $help->{lastmodify}. '</b> : '. $skin{lastmodify}. '</td>'.
   '<td><b>'. $help->{copyright}. '</b> : '. $skin{copyright}. '</td></tr>'.
   '<tr style="background-color:'. $bg2. '">'.
   '<td><b>'. $help->{author}. '</b> : '. $skin{author}. '</td>'.
   '<td colspan="2"><b>'. $help->{author_url}. '</b> : <a href="'.$skin{siteurl}.'">'. $skin{siteurl}. '</a></td>';
  $gl->{HelpContents} .= '<tr style="background-color:'.$bg2.'"><td colspan="3">'.$skin{comment}.'</td></tr>' if $skin{comment};
  $gl->{HelpContents} .= '</tr></table></td></tr></table>';
  $bn->frame( 'Comet Ver '. $bn->VERSION, $gl->{HelpContents}. $bn->back_button );
  $bn->call( 'OpenHelpEnd' );
  $bn->foot->EXIT;
}


sub module {
  my $hp = $_[0];
  my $cf = $bn->{cfg};
  my $sk = $bn->{skin};
  my $gl = $bn->{global};
  $bn->send_http_header->head;

  my $lib_dir;
  for ( @INC ) { if (-e "$_/BN.pm" && -d "$_/BN") { $lib_dir = $_ . '/BN'; last } }

  my $dh = $bn->opendir( $lib_dir );
  $dh or $bn->error( 'ERR_DATA_NOTOPEN', $lib_dir );

  my @txt = $bn->info( 'HELP_TEXT' );

  $gl->{HelpContents} = '<table width="90%" border="1"><tr><td></td><td>'.$txt[5].'</td><td>'.$txt[6].'</td></tr>';

  while ( $_ = readdir $dh ) {
    next if /^\./;
    my( $version, $lastmodify );
    my $module = $_;
    next unless -f "$lib_dir/$_";
    my $fh = $bn->open( "$lib_dir/$_" );
    if ( $fh ) {
      while ( <$fh> ) {
        if ( /LastModify : ([\w\/]+)/i ) {
          $lastmodify = $1;
        } elsif ( /Version : ([\d\.]+)/ ) {
          $version = $1;last
        } elsif ( /package/ ) {
          last;
        }
      }
      close $fh;
      $gl->{HelpContents} .= '<tr><td>'.$module.'</td><td>'.$version.'</td><td>'.$lastmodify.'</td></tr>';
    }
  }
  close $dh;
  $gl->{HelpContents} .= '</table>';

  $bn->call( 'OpenHelpModule' );

  $bn->frame( $txt[3], $gl->{HelpContents}. $bn->back_button );
  $bn->foot;
}

1;

__END__
