#=============================================================================
# BBS Note Comet 1.x 
# Copyright(C) WonderCatStudio. All rights reserved.
# This code cannot be redistributed without
# permission from wondercatstudio.com
# LastModify : 2006/10/20
# Version : 0.04.003 build 1
#=============================================================================
package BN::Icon;
use strict;
use vars qw( $bn $VERSION );

$VERSION = '0.04.003';

sub new {
  my $ic = bless {}, $_[0];
  $bn = $_[1];
  my $item = $ic->{item} = $bn->text(undef, 'icon');
  $ic;
}

sub menu {
  my $ic = $_[0];
  if ( $bn->{in}{fc} eq 'icon_regist' )  { $ic->regist }
  elsif ( $bn->{in}{fc} eq 'icon_list' ) { $ic->list }

}

sub regist {
  my $ic = $_[0];
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my $sk = $bn->{skin};
  my $item = $ic->{item};

  $ic->check_regist;
  $ic->write if exists $in->{file} or defined $in->{icon_url};
  $ic->form;

}

sub form {
  my( $ic, $data ) = @_;
  my $cf = $bn->{cfg};
  my $sk = $bn->{skin};
  my $gl = $bn->{global};
  my $item = $ic->{item};
  my $inf = $gl->{FormInfo};

  $bn->send_http_header;
  $ic->init_cfg;
  $ic->hook_post_form( $data );

  $bn->{sys}{MODE} = 'ICON_' . ($bn->{in}{mode} eq 'edit' ? 'EDIT' : 'REGIST');
  $bn->set_call('PostFormTranslate', sub{
    $bn->{data}{mode} = $bn->{in}{mode} eq 'edit' ? $item->{icon_edit} : $item->{icon_regist} ;
  });

  $bn->app->post_form;
  $bn->foot( 'NotPageLink' )->EXIT;
}

sub list {
  my $ic = $_[0];
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my $sk = $bn->{skin};
  my $arg = $bn->{arg};
  my $ck = $bn->{cookie};
  my $item = $ic->{item};

  my $bbsnoteurl = $bn->get( $cf, 'BBSNoteUrl' );

  my @list;
  $ic->open_data( \@list );

  if ( $in->{number} ) {
    if ( $in->{mode} eq 'edit' ) {
      $ic->edit( \@list );
    } elsif( $in->{mode} eq 'delete' ) {
      $ic->write;
    }
  } elsif( $in->{mode} eq 'move' && $in->{move} ) {
    $ic->move;
  }

  $bn->send_http_header->head( $item->{icon_list} );
  $bn->print( '<div style="text-align:center"><h2>', $item->{icon_list}, '</h2>' );

  if ( $#list ) {
    my( $pwd, $usr ) = $bn->get_admin_pass;
    $bn->check_authority( $pwd );
    my $admin = 1 if $bn->{flag}{AUTHORITY} eq 'ADMIN';
    my( $move_form, $move_form_end, $form_end );

    my $out_color = $bn->get( $sk, 'TagTableOut' )->{bgcolor};
    my $in_color  = $bn->get( $sk, 'TagTableIn' )->{bgcolor};
    my $cap_color = $bn->get( $sk, 'TagTableIn' )->{bgcolor};
    my $cmd_color = $bn->get( $sk, 'TagFormAstMark' )->{color};
    my $line_color = ref $bn->get( $sk, 'TagTableFont' ) eq 'HASH' ? $bn->get( $sk, 'TagTableFont' )->{color} : '';

    my $midle_color1 = $ic->get_middle_color( $out_color, $in_color );
    my $midle_color2 = $ic->get_middle_color( $out_color, $midle_color1 );
       $midle_color2 = $midle_color1 unless $midle_color2;

    my $caption_num = '<td style="color:'.$cap_color.';font-size:12px;text-align:center;width:5%">'.$item->{number}.'</td>';

    # ړptH[
    if ($in->{mode} eq 'move') {

      my $form = '<form action="'.$bbsnoteurl.'" method="post">';
      $arg->{IconListDeleteForm}{password} = $in->{password};
      $arg->{IconListDeleteForm}{name} = $ck->{name};
      $arg->{IconListDeleteForm}{mode} = 'move';
      $arg->{IconListDeleteForm}{fc} = 'icon_list';
      $form .= $bn->set_form_arg($arg->{IconListDeleteForm});

      $caption_num = '<td style="color:'.$cap_color.';font-size:12px;text-align:center;width:2%">A</td><td style="color:'.$cap_color.';font-size:12px;text-align:center;width:2%">B</td>';
      my $submit = $item->{move};
      my $cmd = join '',map{'<option value="'.$_.'"'.($in->{moved} eq $_ ? ' selected':'').'>'. $item->{$_} .'</option>'}('move_rep','move_ins','move_add');

      $move_form = <<_HTML_;
<table width="100%" cellpadding="2" cellspacing="1" bgcolor="$midle_color1">
$form<tr bgcolor="$out_color"><td style="text-align:center">
<select class="select" name="move">$cmd</select>
<input class="submit" type="submit" value=" $submit ">
</td></tr></table>
_HTML_

      $move_form_end = '</form>';

    }

    # link
    my $a = {'fc' => 'icon_regist'};
    my $reg_url = $bn->set_tag(
      { TAG => 'A', href => "$bbsnoteurl?" . $bn->set_text_arg($a),
         style => "color:$in_color", string => $item->{regist}});

    @{$a}{'fc','mode'} = ('icon_list', 'edit');
    my $edit_url = $bn->set_tag(
      { TAG => 'A', href => "$bbsnoteurl?" . $bn->set_text_arg($a),
         style => "color:$in_color", string => $item->{edit}});

    $a->{mode} = 'delete';
    my $del_url = $bn->set_tag(
      { TAG => 'A', href => "$bbsnoteurl?" . $bn->set_text_arg($a),
         style => "color:$in_color", string => $item->{delete}});

    $a->{mode} = 'move';
    my $move_url = $bn->set_tag(
      { TAG => 'A', href => "$bbsnoteurl?" . $bn->set_text_arg($a),
         style => "color:$in_color", string => $item->{move}});

    my $ed_bg = ";background-color:$midle_color1" if $in->{mode} eq 'edit';
    my $mv_bg = ";background-color:$midle_color1" if $in->{mode} eq 'move';
    my $del_bg = ";background-color:$midle_color1" if $in->{mode} eq 'delete';


$bn->print(<<_HTML_);
<table cellpadding="2" cellspacing="2" style="background-color:$out_color;width:85%"><tr><td>
<table cellpadding="2" cellspacing="1" style="background-color:$midle_color1;width:100%">
<tr style="background-color:$out_color">
<td style="color:$cap_color;font-weight:bold;text-align:center;width:25%">[ $reg_url ]</td>
<td style="color:$cap_color;font-weight:bold;text-align:center;width:25%$del_bg">[ $del_url ]</td>
<td style="color:$cap_color;font-weight:bold;text-align:center;width:25%$ed_bg">[ $edit_url ]</td>
<td style="color:$cap_color;font-weight:bold;text-align:center;width:25%$mv_bg">[ $move_url ]</td>
</tr></table>$move_form
<table cellpadding="2" cellspacing="1" style="background-color:$midle_color1;width:100%">
<tr style="background-color:$out_color">$caption_num
<td style="color:$cap_color;font-size:12px;text-align:center;width:30%">$item->{icon}</td>
<td style="color:$cap_color;font-size:12px;text-align:center;width:30%">$item->{comment}</td>
<td style="color:$cap_color;font-size:12px;text-align:center;width:25%">$item->{info}</td>
</tr>
_HTML_

    my $mode_txt = $item->{$in->{mode}};
    my($icon_list, $file_info);
    $midle_color1 = $midle_color2 if $in->{mode} eq 'move';

    for my $h ( @list ) {
      next unless $h->{num} ne 'none' && $h->{title};

      my $ex_icon = '<br><span style="color:'.$cmd_color.';font-weight:bold">[ ' . $item->{icon_exclusive} .' ]</span>' if $h->{applet};
      $file_info = "$h->{file_width} x $h->{file_height} ($h->{file_length} byte)<br>" if $h->{file_name} !~ m#https?://#;
      my $img = $bn->set_tag( { TAG => 'IMG', border => $ex_icon ? 3 : 0,
        src => ($h->{file_name} =~ m#https?://# ? $h->{file_name} : $bn->get($cf, 'DirFileUrl') . '/icon/' .$h->{file_name}) } );
      $h->{mail} = '[' . $bn->set_tag({ TAG => 'A', href => 'mailto:' . $h->{mail}, string => 'MAIL'}) . ']' if $h->{mail};
      $h->{url} = '[' . $bn->set_tag({ TAG => 'A', href => 'http://' . $h->{url}, string => 'URL'}) . ']' if $h->{url};
      $h->{date} =~ s/\(.*\)//;
      my $form;
      if ( $in->{mode} =~ /delete|edit/ ) {
        $form = '<form action="'.$bbsnoteurl.'" method="post">';
        $arg->{IconListMenuForm}{password} = $in->{password};
        $arg->{IconListMenuForm}{name} = $ck->{name};
        $arg->{IconListMenuForm}{mode} = $in->{mode};
        $arg->{IconListMenuForm}{number} = $h->{num};
        $arg->{IconListMenuForm}{fc} = 'icon_list';

        $form.= $bn->set_form_arg($arg->{IconListMenuForm});
        $form_end = '</form>';
        $h->{num} = '<input type="submit" style="background-color:'.$midle_color2.';color:'.$cmd_color.';border-style:none;cursor:pointer" value="'."$mode_txt $h->{num}".'">';

      } elsif ( $in->{mode} eq 'move' ) {
        $form_end = '<td style="background-color:'.$midle_color1.';text-align:center"><input name="target_b" type="radio" value="'.$h->{num}.'"'.($in->{target_b} eq $h->{num}?' checked':'').'></td>';
        $h->{num} = '<input name="target_a" type="radio" value="'.$h->{num}.'"'.($in->{target_a} eq $h->{num}?' checked':'').'>';
      }

$icon_list .= <<_HTML_;
<tr style="background-color:$in_color">$form
<td style="background-color:$midle_color2;text-align:center;font-size:12p;font-weight:bold;color:$cap_color">$h->{num}</td>$form_end
<td style="text-align:center">$img</td>
<td style="color:$line_color;vertical-align:top"><b>$h->{title}</b><br><span style="font-size:12px">$h->{message}</span></td>
<td style="color:$line_color;font-size:12px;text-align:right">$h->{date}<br>$file_info
$item->{regist_name} : $h->{name} $h->{mail} $h->{url} $ex_icon
</td></tr>
_HTML_

    }

    $bn->print($icon_list, '</td></tr></table>' x 2, $move_form_end);

  } else {
    my $a = { fc => 'icon_regist' };
    $bn->print( $item->{regist_info} . '<br>');
    $bn->print( $bn->set_tag(
      { TAG => 'A', href => "$bbsnoteurl?" . $bn->set_text_arg($a),
        string => $item->{icon_regist} }) );
  }


  if ($bn->get($cf, 'IconPreviewWindow')) {
    $bn->print('<form><input type="button" class="button" value="'.
      $item->{close} . '" onclick="window.close()"></form>');
  } else {
    $bn->print($bn->back_button);
  }

  $bn->print('</div>');

  $bn->foot('NotPageLink');
  $bn->EXIT;
}


sub write {
  my $ic = shift;
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my $gl = $bn->{global};
  my $item = $ic->{item};
  my $po = $bn->po;
  my @list;
  $ic->open_data(\@list);
  $ic->init_cfg;
  $po->check_auth($bn->get($cf, 'UseIcon'))
    or $po->check_auth($bn->get($cf, 'UseIcon'), $in->{login_pass})
      or $bn->end('ERROR',split /:/,$item->{ERR_AUTH},2);

  my $pass = exists $in->{checkpass} ? $in->{checkpass} : $in->{password};

  for (@list) {
    if ($_->{num} eq $in->{number}) {
      $bn->check_password($pass, $_->{password})
        or $ic->login;
    }
  }

  my $dir = $bn->{bn_dir} . ($bn->get($cf, 'DirFilePath')) . '/icon';
  my $path = "$bn->{sys}{DirSys}/icon.$bn->{sys}{Exe}";

  if ($in->{mode} ne 'delete' && $gl->{ICON_NUM} >= $bn->get($cf, 'LimitIcon')) {
    $bn->end('ERROR',split /:/,$item->{ERR_LIMIT},2);
  }

  $bn->filelock;
  $bn->get_user_ip;
  my $DATE = $bn->get_date;
  my $val = $gl->{LogValue} = {};
  my $ex = $gl->{LogExValue} = {};
  $gl->{FILES} = {}; # file hash
  $gl->{error} = []; # error array
  my($fh_tmp, $tmp) = $bn->get_temp_file;

  my $fh = $bn->open($path);
  $bn->{temp}{fh}{icon} = $fh;
  $_ = <$fh>;

  if ($in->{mode} eq 'delete') {
  # 폜
    $gl->{ICON_NUM}--;
    print $fh_tmp "$gl->{ICON_CNT}\t$gl->{ICON_NUM}\n";

    while (<$fh>) {
      my($num, $s) = split /\t/,$_,2;
      if ($num eq $in->{number}) {
        my $bval = $gl->{BLogValue} = {};
        my $bex = $gl->{BLogExValue} = {};
        $bn->get_log_main_value($_, $bval, $bex);
        unlink "$dir/$bval->{file_name}";
        next;
      }
      print $fh_tmp $_;
    }

  } else {
    my $mo = $bn->text;
    for (qw/CHECK_TITLE CHECK_MESSAGE CHECK_TITLEOVER CHECK_MESSAGELINEOVER/)
     { $mo->{$_} = $item->{$_} }

    my $t_pos = tell $fh;

    # ACRԍύX
    my $num_flag;
    my $num = int $in->{num};

    # ԍLׂ
    if ($num && $num ne $in->{number}) {
      $num_flag = 1;
      seek $fh, $t_pos, 0;
      $num = 0 if $num > 999999;
      while ( <$fh> ) {
        my( $n, $s ) = split /\t/, $_, 2;
        if ( $n eq $num ) {
          $bn->set_call('SkinFootBegin', sub{
            $bn->{arg}{BackButton}{fc} = 'icon_list';
            $bn->{arg}{BackButton}{name} = $in->{name};
            $bn->{arg}{BackButton}{number} = $in->{number};
            $bn->{arg}{BackButton}{password} = $in->{password};
            $bn->print( '<div style="text-align:center">'. $bn->back_button('edit'). '</div>' );
          });
          $bn->end( 'ERROR', split /:/, $item->{ERR_NUM}, 2 );
        }
      }
      $in->{num} = $num;
    }

    $ic->init_cfg;

    $ic->hook_post_form;

    my $crypt_pass = $bn->crypt_string($in->{password});
    my $hfl = $gl->{FILES}{file} = {};

    if (length $in->{file} == 0) {
      if ($in->{icon_url} =~ m#^https?://[-.!~*'()\w;\/?:\@&=+\$,%\#]+\.(jpe?g|gif|png)#) {
        $bn->{flag}{FILE_CAPTOR} = 0;
        $bn->set($cf, 'NeedData', 0);
        $hfl->{filename} = $in->{icon_url};
        $hfl->{url} = 1;
        $hfl->{size} = 1;
        $gl->{ICON_CNT}++;
      } elsif (defined $in->{icon_url} && $in->{icon_url} ne 'http://') {
        $bn->set_call('CheckInputInit', sub {push @{$gl->{error}}, $item->{ERR_ICON_URL} });
      }
    }

    $po->check_input;

    $in->{message} = $po->convert_message($in->{message});

    # icon write
    $ic->write_file unless $hfl->{url};

    $gl->{ICON_CNT}-- unless $hfl->{size};

    @{$val}{$bn->LOG_MAIN_VALUE} = (
      $gl->{ICON_CNT},  # count
      $in->{name},      # name
      $DATE,            # date
      $in->{title},     # title
      $in->{mail},      # mail addr
      $in->{url},       # URL
      $in->{message},   # comment
      $gl->{HOST},      # HOST
      $gl->{IP},        # IP
      $gl->{UserAgent}, # agent
      $hfl->{filename}, # file name
      $hfl->{width},    # file width
      $hfl->{height},   # file height
      $hfl->{size},     # file length
      $crypt_pass,      # password
      '',               # none
      '',               # none
      $in->{ex_icon},   # EX flag
    );


    if ($in->{mode} eq 'edit') {
      my @buffer;
      seek $fh, $t_pos, 0;
      my $icon_cnt = 0; my $icon_num = 0;
      while ( <$fh> ) {
        my( $n, $s ) = split /\t/, $_, 2;
        if ( $n eq $in->{number} ) {
          my $bval = $gl->{BLogValue} = {};
          my $bex = $gl->{BLogExValue} = {};
          $bn->get_log_main_value( $_, $bval, $bex );

          $val->{password} = $bval->{password} if $in->{checkpass} eq $in->{password};

          if ( $hfl->{url} ) {
            unlink "$dir/$bval->{file_name}" if $bval->{file_name} !~ m#^https?://#;
            $bval->{file_name} = $hfl->{filename};
          } elsif ( $hfl->{size} && $bval->{file_name} =~ /\.(\w+)$/ ) {
            my %file = ( size => 1, mime => $1 );
            $po->set_filename( \%file, 'ICON', $num );
            unlink "$dir/$bval->{file_name}" if $num_flag && $bval->{file_name} !~ m#^https?://#;
            rename "$dir/$hfl->{filename}", "$dir/$file{filename}";
            @{$val}{'num', 'file_name'} = ($num, $file{filename});
            $bval->{file_name} = $file{filename};
          }

          if ( $num_flag ) {
            if ( $bval->{file_name} !~ m#^https?://# && $bval->{file_name} =~ /\.(\w+)$/ ) {
              my %file = ( size => 1, mime => $1 );
              $po->set_filename( \%file, 'ICON', $num );
              rename "$dir/$bval->{file_name}", "$dir/$file{filename}";
              $bval->{file_name} = $file{filename};
            }
            $bval->{num} = $num;
          }

          for (qw/num file_name file_width file_height file_length/)
           { $val->{$_} = $bval->{$_} }
          $_ = (join "\t",@{$val}{$bn->LOG_MAIN_VALUE}) . "\n";
        }
        $icon_cnt = $n if $n > $icon_cnt;
        push @buffer, $_;
        $icon_num++;
      }

      print $fh_tmp "$icon_cnt\t$icon_num\n";
      for ( @buffer ) { print $fh_tmp $_ }

    } else {
      $gl->{ICON_NUM}++;
      print $fh_tmp "$gl->{ICON_CNT}\t$gl->{ICON_NUM}\n";
      print $fh_tmp (join "\t",@{$val}{$bn->LOG_MAIN_VALUE}) . "\n";
      while ( <$fh> ) { print $fh_tmp $_ }
    }
  }

  close $fh_tmp;
  close $fh;
  delete $bn->{temp}{fh}{icon};

  rename $tmp, $path
    or unlink $tmp && $bn->error('ERR_SYS_NOTWRITE', $path);

  $ic->unlink_boot;

  $bn->fileunlock;

  delete $in->{number};
  $in->{password} = $in->{login_pass} if exists $in->{login_pass};
  $in->{name} = $in->{login_usr} if exists $in->{login_usr};
  delete $bn->{sys}{MODE};

  $ic->list;

}

sub move {
  my $ic = shift;
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my $item = $ic->{item};

  # admin check
  my $ok;
  for ($bn->{in}{password}, $bn->{cookie}{password}, $bn->{in}{login_pass}) {
     $ok = $bn->po->check_auth(1, $_);
     last if $ok;
  }
  $bn->error('PASSWORD_ERROR') if !$ok && $bn->{in}{password};

  $ic->login($item->{INF_MOVE}) unless $ok;

  # target check
  if($in->{target_a} eq '' || $in->{target_b} eq '' ){
    $bn->end('ERROR',split /:/,$item->{ERR_NONE},2);
  }
  if($in->{target_a} eq $in->{target_b}){
    $bn->end('ERROR',split /:/,$item->{ERR_TARGET},2);
  }

  my $mode = $in->{move};

  $bn->filelock;

  my $path = "$bn->{sys}{DirSys}/icon.$bn->{sys}{Exe}";
  my($fh_tmp, $tmp) = $bn->get_temp_file;

  my $fh = $bn->open($path);
  $fh or $bn->error('ERR_DATA_NOTOPEN', $path);
  $bn->{temp}{fh}{icon} = $fh;
  my $count = <$fh>;

  my $pos = tell $fh;
  my $target_a;
  my $target_b;

  while (<$fh>) {
    my($num, $s) = split /\t/, $_, 2;
    if ($num eq $in->{target_a}) {
      $target_a = $_;
    } elsif($num eq $in->{target_b}) {
      $target_b = $_;
    }
    last if $target_a && $target_b;
  }

  seek $fh, $pos, 0;

  print $fh_tmp $count;
  while (<$fh>) {
    my($num, $s) = split /\t/, $_, 2;
    if ($num eq $in->{target_a}) {
      if ($mode eq 'move_rep') {
        print $fh_tmp $target_b;
      }
      next;
    } elsif($num eq $in->{target_b}) {
      if ($mode eq 'move_rep') {
        print $fh_tmp $target_a;
        next;
      } elsif($mode eq 'move_ins') {
        print $fh_tmp $target_a;
      } elsif($mode eq 'move_add') {
        print $fh_tmp $_;
        print $fh_tmp $target_a;
        next;
      }
    }
    print $fh_tmp $_;
  }

  close $fh_tmp;
  close $fh;
  delete $bn->{temp}{fh}{icon};

  rename $tmp, $path
    or unlink $tmp && $bn->error('ERR_SYS_NOTWRITE', $path);


  $ic->unlink_boot;

  $bn->fileunlock;

  $in->{moved} = $in->{move};
  delete $in->{move};

  $ic->list;

}

sub edit {
  my( $ic, $list ) = @_;
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my $gl = $bn->{global};
  my $h;

  for ( @$list ) { next if $_->{num} ne $in->{number}; $h = $_; last }

  $bn->error('DATA_NOTFOUND') unless $h;

  my $ok = $bn->check_password($in->{password}, $h->{password});
  $bn->error('PASSWORD_ERROR') unless $ok;


  $bn->set_call('SkinBackButtonInit', sub{
    $bn->{arg}{BackButton} = { fc => 'icon_list' } });

  $bn->set_call('PostFormInitBegin', sub{
    my @val = qw/name mail url title message applet/;
    @{$gl->{value}}{@val} = @{$h}{@val};
    $gl->{value}{password} = $in->{password};
    $bn->{arg}{PostForm}{number} = $in->{number};
  });

  $bn->set_call('PostFormTranslate', sub{
    $bn->{data}{postform} = '<p>'.$bn->set_tag({ TAG => 'IMG',
      src => ($h->{file_name} =~ m#https?://# ? $h->{file_name} : $bn->get($cf, 'DirFileUrl') . "/icon/" . $h->{file_name}),
      border => $h->{applet} ? 3 : 0 }) .
      ($h->{file_name} =~ m#https?://# ? '' : "<br>$h->{file_width} x $h->{file_height} ($h->{file_length}byte)") .
      $bn->{data}{postform};
  });

  $ic->form( $h );

}

sub get_middle_color {
  my( $ic, $c1, $c2 ) = @_;
  return $bn->mo( 'Design' )->get_middle_color( $c1, $c2 );
}

sub open_data {
  my( $ic, $list ) = @_;
  my $cf = $bn->{cfg};
  my $gl = $bn->{global};

  my $dir = $bn->{bn_dir}. $bn->get($cf, 'DirFilePath'). '/icon';
  my $path = $bn->{sys}{DirSys}. '/icon.'. $bn->{sys}{Exe};
  if ( !-e $dir ) {
    mkdir $dir, 0777
#      or $bn->error( 'ERR_DIR_NOTMAKE', $dir );
      or $bn->error( 'ERR_DIR_NOTMAKE', 'debug' );
    chmod 0777, $dir;
  }

  if ( !-e $path ) {
    my $fh = $bn->open( $path, '>' );
    $fh or $bn->error( 'ERR_SYS_NOTWRITE', $path );
    print $fh "0\t0\n";
    close $fh;
    chmod 0606, $path;
  }

  my $fh = $bn->open( $path );
  $fh or $bn->error( 'ERR_SYS_NOTOPEN', $path );

  $_ = <$fh>; chomp;
  @{$gl}{'ICON_CNT','ICON_NUM'} = split /\t/;

  while ( <$fh> ) {
    my $val = {}; my $ex = {};
    $bn->get_log_main_value($_, $val, $ex);
    map{$val->{$_} = $ex->{$_}}keys %{$ex};
    push @$list, $val;
  }
  push @$list, {num => 'none', title => $ic->{item}{icon_none}};
  close $fh;
}

sub write_file {
  my $ic = shift;
  my $in = $bn->{in};
  my $sys = $bn->{sys};
  my $gl = $bn->{global};

  my $back_dir = $sys->{DirData};
  $sys->{DirData} .= '/icon';

  if ($in->{mode} eq 'edit') {
    $gl->{ICON_CNT} = $in->{num} if $in->{num} > $gl->{ICON_CNT};
    $bn->po->set_filename($gl->{FILES}{file}, 'ICON' ,$in->{num});
  } else {
    my $f = 1;
    while ( $f ) {
      $gl->{ICON_CNT} = 0 if $gl->{ICON_CNT} >= 999999;
      $bn->po->set_filename($gl->{FILES}{file}, 'ICON', ++$gl->{ICON_CNT});
      $f = -e "$bn->{sys}{DirData}/$gl->{FILES}{file}{filename}" ? 1 : 0;
    }
  }
  $sys->{DirData} = $back_dir;
  $bn->po->write_files( $gl->{FILES} ) if length $in->{file};
}

sub login {
  my $ic = $_[0];
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my $sk = $bn->{skin};
  my $ck = $bn->{cookie};
  my $fr = $sk->{form} = {};
  my $tag_form_items = $bn->get($sk, 'TagFormItems');

  my @text = $bn->info('LOGIN_TEXT');

  unless ( $bn->{flag}{COOKIE} ) {
    delete $ck->{adminuser};
    delete $ck->{adminpass};
    $bn->write_cookie($ck);
  }
  $bn->send_http_header->head($bn->get($cf, 'BbsTitle') . ' : ' . $text[0]);
  $bn->{flag}{MENUFORM} = 'LOGIN';
  $bn->create_menu_form( 'login',
    "<h2>$text[0]</h2>$_[0]$text[1]<br>", 'LoginForm' );
  $bn->foot( 'NotPageLink' )->EXIT;
}

sub unlink_boot {
  unlink "$bn->{sys}{DirSys}/boot.$bn->{sys}{Exe}";
}

sub check_icon {
  my $ic = $_[0];
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my $gl = $bn->{global};
  my $icon = $in->{icon};
  my $item = $ic->{item};

  unless ( $bn->po->check_auth( $bn->get( $cf, 'UseIcon' ) ) ) {
    push @{$gl->{error}}, $item->{ERR_USE};
  }

  my @list;
  $ic->open_data(\@list);

  my $flag;
  for ( @list ) {
    if ( $_->{file_name} eq $icon ) {
      if ( $bn->get( $cf, 'UseIconEx' ) && $_->{applet} ) {
        $bn->check_password( $in->{password}, $_->{password} )
          or push @{$gl->{error}}, $item->{ERR_EX_ICON};
      }
      $flag = 1;
      last;
    }
  }
  push @{$gl->{error}}, $item->{ERR_NOTFOUND} unless $flag;
}

sub check_regist {
  my $ic = $_[0];
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my $fl = $bn->{flag};

  $bn->error( 'ERR_FUNCTION' ) unless $bn->get( $cf, 'UseIcon' );

  ## regist admin only [ 0 = every, 1= admin, 2 = admin.sub ]
  my $regist_ok;
  if ( $bn->get( $cf, 'IconRegist' ) ) {
    for ( $in->{password}, $bn->{cookie}{password}, $in->{login_pass} ) {
      $regist_ok = $bn->po->check_auth( $bn->get( $cf, 'IconRegist' ), $_ );
      last if $regist_ok;
    }
  } else {
    $regist_ok = 1;
  }

  my $ok;
  for ( $in->{password}, $bn->{cookie}{password}, $in->{login_pass} ) {
     $ok = $bn->po->check_auth( $bn->get( $cf, 'UseIcon' ), $_ );
     last if $ok;
  }

  $bn->error( 'PASSWORD_ERROR' )
   if ( !$ok || !$regist_ok ) && ( $in->{password} || $in->{login_pass} );
  $ic->login unless $ok && $regist_ok;
}


sub init_cfg {
  my $ck = $bn->{cookie};
  my $cf = $bn->{cfg};
  my $in = $bn->{in};
  $bn->{sys}{MODE} = 'POST';
  $bn->{sys}{CaptorFormat} = 'jpg,png,gif';

  $bn->set( $cf, 'NeedName', 1 );
  $bn->set( $cf, 'NeedTitle', 1 );
  $bn->set( $cf, 'NeedPassword', 1 );
  $bn->set( $cf, 'NeedData', ( $in->{mode} eq 'edit' ? 0 : 1 ) );
  $bn->set( $cf, 'LimitImageWidth', $bn->get($cf, 'LimitIconWidth' ) );
  $bn->set( $cf, 'LimitImageHeight', $bn->get($cf, 'LimitIconHeight' ) );
  $bn->set( $cf, 'LimitUpLoadData', $bn->get($cf, 'LimitIconSize' ) );
  $bn->set( $cf, 'LimitMessage', $bn->get($cf, 'LimitIconComment' ) );

  $bn->{flag}{FILE_CAPTOR} = $bn->get( $cf, 'UseIcon' );
  $bn->{flag}{POST_FORM_TITLE} = 1;

  $ck->{name} = $in->{name} unless $ck->{name};
  $ck->{password} = $in->{password} unless $ck->{password};
}

sub hook_post_form {
  my( $ic, $data ) = @_;
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my $sk = $bn->{skin};
  my $item = $ic->{item};
  my $gl = $bn->{global};
  my $inf = $gl->{FormInfo};
  my $tag_form_items = $bn->get( $sk, 'TagFormItems' );

  $bn->set_call( 'PostFormInitBegin', sub {

    $bn->{item}{title} = $item->{icon_name};
    $bn->{item}{message} = $item->{comment};

    $bn->{global}{value}{fc} = 'icon_regist';
    $bn->{flag}{UPLOAD_ENABLE} = $bn->get( $cf, 'UseIcon' );
    $bn->{flag}{POST_FORM_TITLE} = 1;

    $bn->{arg}{BackButton}{fc} = '';
    $bn->{arg}{PostForm}{login_usr} = $in->{login_usr} ? $in->{login_usr} : $in->{name};
    $bn->{arg}{PostForm}{login_pass} = $in->{login_pass} ? $in->{login_pass} : $in->{password};

    $bn->set( $cf, 'UseIcon', 0 );
    $bn->set( $cf, 'NeedPassword', 1 );
    $bn->set( $cf, 'UsePanic', 0 );
    $bn->set( $cf, 'UseAllTag', 0 );
    $bn->set( $cf, 'UseColor', 0 );
    $bn->set( $cf, 'UseNoticeMail', 0 );

    if ( $in->{mode} eq 'edit' ) {
      $bn->{item}{password} = $bn->{item}{newpassword};
      $bn->set_call( 'PostFormInitEnd', sub {
        $sk->{form}{pass} = { TAG => 'INPUT', type => 'hidden', name => 'checkpass', value => $in->{password} };
        $bn->set_form( $sk->{form}{FORMS}, $sk->{form}{pass}, 'right', 'fc' );
      })
    }
  });

  $bn->set_call( 'PostFormInitEnd', sub {
    my $tag_ast_mark = $bn->get( $sk, 'TagFormAstMark' );
    my $fr = $sk->{form};
    my $value = $data->{file_name} =~ m#^https?://# ? $data->{file_name} : 'http://' ;

    $fr->{icon_url} = ([[
      [ { TAG => 'TD', colspan => '*' } ],
      [ $tag_form_items, { id => 'PostFormUrl', string => " $item->{icon_url} " } ],
      [ ($bn->get($cf, 'NeedData') ? $tag_ast_mark : '') ],
      [ $tag_form_items, { string => ' ' . $item->{upload_info}  } ],
      [ { string => '<br>' } ],
      [ { TAG => 'INPUT', id => 'PostFormUploadInput',name => 'icon_url', type => 'text', class => 'input',
        style => 'width:100%', size => $bn->{item_size}{url}, value => $value } ]
    ]]);
    $bn->set_form( $fr->{FORMS}, $fr->{icon_url}, 'insert', 'message' );
    push @$inf, $item->{upload_info};
  });

  if ( $in->{mode} eq 'edit' ) {
    $bn->set_call( 'PostFormInitEnd', sub {
      $sk->{form}{number} = [[
        [ { TAG => 'TD', colspan => '*', nowrap => 1 } ],
        [ $tag_form_items, { string => $item->{icon_number} } ],
        [ { string => '<br>' } ],
        [ { TAG => 'INPUT', type => 'text', name => 'num', class => 'input', value => $in->{number} } ]
      ]];
      $bn->set_form( $sk->{form}{FORMS}, $sk->{form}{number}, 'insert', 'password' );
    })
  }

  if ( $bn->get( $cf, 'UseIconEx' ) ) {
    $bn->set_call( 'PostFormInitEnd', sub {
      $sk->{form}{icon_ex} = [[[
        [ { TAG => 'TD', colspan => '*', nowrap => 1 } ],
        [ { TAG => 'INPUT', type => 'checkbox', name => 'ex_icon',
          checked => ($bn->{global}{value}{applet} ? 1 : ''), value => 1 } ],
        [ $tag_form_items, { string => $item->{icon_exclusive} } ]
      ]]];
      $bn->set_form($sk->{form}{FORMS}, $sk->{form}{icon_ex}, 'insert', 'password');
    })
  }

  $bn->set_call( 'ErrDefaultPostInit', sub {
    $bn->{sys}{MODE} = 'ICON_' . ($bn->{in}{mode} eq 'edit' ? 'EDIT' : 'REGIST');
    $bn->set_call('PostFormTranslate', sub{
      $bn->{data}{mode} = $bn->{in}{mode} eq 'edit' ? $item->{icon_edit} : $item->{icon_regist} ;
    });
  });

  map{ $bn->{arg}{BackButton}{$_} = $in->{$_} }keys %$in;
}

1;

__END__
