#=============================================================================
# BBS Note Comet 1.x
# Copyright(C) WonderCatStudio. All rights reserved.
# This code cannot be redistributed without
# permission from wondercatstudio.com
# LastModify : 2008/01/17
# Version : 0.20.001 build 4
#=============================================================================
package BN::Paint;
use strict;
use vars qw( $bn $VERSION );

$VERSION = '0.20.001';

sub new {
  my $pm = bless { }, $_[0];
  $bn = $_[1];
  $pm->init;
  $pm;
}

sub init {
  for(qw/Spa Sii Pic Pai PCHViewer All/) { $bn->{arg}{"Param_$_"} = {} }
  $_[0];
}

sub admin_menu {
  my $pm = $_[0];
  my $gl = $bn->{global};
  my $item = $pm->item;
  ${$gl->{contents}} .= ${$gl->{cgi_form}}.
    '<input type="hidden" name="fc" value="admin"><input type="hidden" name="cmd" value="paint_poollist">'.
    '<input type="submit" class="submit" value="'.$item->{poollist}.'"></form><p>'.$item->{poollist_info}.'</p>';
}

sub item {
  my $pm = $_[0];
  return $pm->{item} if exists $pm->{item};
  $pm->{item} = $bn->text('','paint');
}

sub captor {
  my $pm = $_[0];
  my $cf = $bn->{cfg};
  my $gl = $bn->{global};
  my $sys = $bn->{sys};
  my $mo = $bn->{module}{Paint};
  my $in = $bn->{in} = {};
  my $err = $pm->{error} = {};
  my %app;

  $bn->get_user_ip;

  $bn->{flag}{PAINT_CAPTOR} = 1;
  $sys->{MODE} = 'WRITE_PAINT_CAPTOR';

  for (@{$mo->{applets}}){
    $app{ $_->{applet} =~ /^(?:spapro|spanormal)$/ ? 'ShiPainter':
    $_->{applet} eq 'sii' ? 'ShiPaintBBS':
    $_->{applet} eq 'pic' ? 'PictureBBS' : 'ETC' } = 1;
  }

  # PictureBBS Image Read Request
  if ($ENV{CONTENT_LENGTH} < 50) {
    my $buf;
    $bn->read(\$buf, $ENV{CONTENT_LENGTH});
    for (split '&', $buf){ my($n,$v) = split '='; $in->{$n} = $v }
    $bn->send_http_header( 'application/octet-stream' );
    if ($bn->get($cf, 'UsePaintContinue')) {
      ($in->{name}, $in->{PASSWORD}) = ($1,$2) if $in->{PASSWORD} =~ /(\w+)%40(\w+)/;
      my $ap = $bn->app;
      $gl->{LogValue} = {}; $gl->{LogExValue} = {};
      $ap->get_log($in->{BASENUM}, '', $gl->{LogValue}, $gl->{LogExValue});
      $in->{password} = $in->{PASSWORD};
      # password err
      if ($bn->get($cf, 'UsePaintContinuePassword') == 1 &&
       ! $bn->check_password($in->{PASSWORD}, $gl->{LogValue}{password}, $bn->get( $cf, 'PaintPasswordAuth' ) )
      ){$bn->print('P'); $bn->access_log->EXIT}

      my $img = "$sys->{DirData}/$gl->{LogValue}{file_name}";
      my $size = -s $img;
      # image not found
      unless($size){$bn->print('N'); $bn->access_log->EXIT;}
      my $fh = $bn->open($img);
      $fh or $bn->error('ERR_DATA_NOTOPEN', $img);
      binmode STDOUT; binmode $fh;
      $bn->print(sprintf("\x06%08d", $size));
      while (<$fh>){ $bn->print($_) }
      close $fh;
      $bn->access_log->EXIT;
    }
    $bn->print('F');
    $bn->access_log->EXIT;
  }

  my $p_code;
  $bn->read(\$p_code, 1)
   or $bn->send_http_header( 'application/octet-stream' )
     and $bn->print("error 0\n") and $bn->access_log->EXIT;

  my $captor_mode;
  my $obj = $gl->{object} = {};
  my $arg = $gl->{object}{arg} = {};

  # ShiPainter Stream
  if ($p_code eq 'S' && $app{ShiPainter}) {
    $pm->captor_spa('ShiPainter');
    $captor_mode = 'SHIPAINTER';
  # ShiPaintBBS Stream
  } elsif($p_code eq 'P' && $app{ShiPaintBBS}) {
    $pm->captor_spa('ShiPaintBBS');
    $captor_mode = 'PAINTBBS';
  # PictureBBS Stream
  } elsif($app{PictureBBS}) {
    $pm->captor_pic;
    $captor_mode = 'PICTUREBBS';
  }

#  # don't allowd auth accept client
#  $pm->check_paint_auth($arg);

  my( $broken, @filename );
  my $flag_rep = 1 if $bn->{flag}{ReplaceContinue};
  my $id = $flag_rep ? sprintf "%06d", $arg->{log} : $pm->set_pmid;
  $id =~ s/\W//g;

  for ( 'Image','Anime','Thumb','PoolAnime' ) {
    if (exists $obj->{$_}) {
      $broken = 1 if !$obj->{$_}{mime};
      $id = $pm->set_pmid if $_ eq 'PoolAnime' && $flag_rep;
      $obj->{$_}{filename} = $bn->get($cf, 'FileHead'.
       ( $_ eq 'PoolAnime' ? 'Anime' : $_ )). "_$id.$obj->{$_}{mime}";
      $obj->{$_}{path} = "$sys->{DirData}/$obj->{$_}{filename}";
      last if $_ eq 'PoolAnime';
      push @filename, $obj->{$_}{filename};
    }
  }

  $bn->error('ERR_CAPTOR_BROKEN') if !$arg->{pmid} || $broken;

  $obj->{paint_time} = $arg->{timer} ? int substr $arg->{timer}, 0, -3:
      ( (time + $bn->get($cf, 'TimeDiffSec') ) - oct '0x' . $arg->{'time'});

  $bn->filelock;

  my $add_pool;
  my $img = $obj->{Image};

  $in->{log} = $arg->{log}; $in->{pmid} = $arg->{pmid};
  $in->{file_size} = $img->{size};
  $in->{anime_size} = $obj->{Anime}{size};
  $in->{thumb_size} = $obj->{Thumb}{size};

  $sys->{MODE} = 'WRITE_PAINT_REPLACE' if $flag_rep;
  $bn->po->check_history;

  $obj->{ip_str} = join '', map {sprintf("%02X", $_)}split '\.', $gl->{IP};

  if ( $err->{anime_over} ) {
    $err->{anime_over} = $obj->{PoolAnime}{filename};
    my $d = 'anime_alert=2' if $flag_rep;
    $add_pool = join "\t",(map{s/\t//g;$_}($obj->{ip_str}, $arg->{pmid} ), time,
     $d, $img->{width}, $img->{height}, $obj->{PoolAnime}{size}, $obj->{PoolAnime}{filename});
  }

  if ($flag_rep) {
    $bn->call('CaptorReplaceContinue');
  } else {
    if ( exists $gl->{PAINT_TEMP_REP} ) {
      my @v = split /\t/, $gl->{PAINT_TEMP_REP};
      my %temp_arg; for ( split '&', $v[3] )
       { my @a = split '=', $_, 2; $temp_arg{$a[0]} = $a[1] }
      my $ip_str = join '',map {sprintf("%02X", $_)} split '\.', $gl->{IP};
      my $paint_time = $temp_arg{timer} ? int substr $temp_arg{timer}, 0, -3 : $v[2] - oct '0x'.$temp_arg{'time'};
      $arg->{app} = "$arg->{app}+$temp_arg{app}";
      $arg->{history} = $temp_arg{history};
      $arg->{history} .= '+' if $arg->{history} ne '';
      $arg->{history} .= $bn->get_date( $v[2] )."%$paint_time%$ip_str";
      $arg->{'timer'} += $temp_arg{timer};
    }
    $add_pool = (join "\t",map{s/\t//g;$_}($obj->{ip_str}, $arg->{pmid},
      time, (join '&',(map{my $a=$_;map{"$_=$a->{$_}"}keys %$a}$arg,$err)),
      $img->{width}, $img->{height}, $img->{size}, @filename)).
      ( defined $add_pool ? "\n": '' ). $add_pool;
    $bn->call('CaptorWritePool');
  }

  $pm->check_pool(1, $arg->{pmid}, $add_pool);
  $pm->replace_continue($obj) if $flag_rep;

  $bn->call('CaptorWriteFiles');
  $bn->po->write_files($obj);
  $bn->po->write_history({
    'time' => time(), mode => $sys->{MODE}.'_'.$captor_mode,
    ip => $gl->{IP}, host => $gl->{HOST}, pmid => $arg->{pmid},
    file_name  => $img->{filename}, file_size  => $img->{size},
    anime_name => $obj->{Anime}{filename},
    anime_size => ( $obj->{Anime}{size} ? $obj->{Anime}{size} : $obj->{PoolAnime}{size}),
    thumb_name => $obj->{Thumb}{filename},
    thumb_size => $obj->{Thumb}{size},
  });

  $bn->fileunlock;
  $bn->call('CaptorEnd');

  $bn->send_http_header( 'application/octet-stream' );
  $captor_mode =~ /PICTUREBBS/ ?
   $bn->print( "\x41\x43\x4B\n" ) : $bn->print( 'ok' );
  $bn->access_log->EXIT;

}

sub captor_continue {
  my( $pm, $arg ) = @_;
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my $gl = $bn->{global};
  my $cfg_pass = $bn->get($cf, 'UsePaintContinuePassword');
  my $cfg_rep = int $bn->get($cf, 'UsePaintContinue');
  $cfg_rep = $cfg_rep == 1 || $cfg_rep == 3 ? 1 : 0 ;

  $bn->call('CaptorContinueInit');

  if ($arg->{continue} =~ /^(?:rep|new)$/) {
    $bn->{sys}{MODE} = 'WRITE_PAINT_CONTINUE';
    if ($arg->{log}) {
      $gl->{LogValue} = {}; $gl->{LogExValue} = {};
      $bn->app->get_log($arg->{log},'',$gl->{LogValue}, $gl->{LogExValue});
      if ($cfg_pass == 1 || ($cfg_pass == 2 && $arg->{continue} eq 'rep') ) {
        $in->{name} = $arg->{name} unless exists $in->{name};
        $in->{password} = $arg->{password};
        $bn->check_password( $in->{password}, $gl->{LogValue}{password}, $bn->get( $cf, 'PaintPasswordAuth' ) )
          or $bn->error('PASSWORD_ERROR');
      }
      $bn->{flag}{ReplaceContinue} = 1 if $arg->{continue} eq 'rep' && $cfg_rep;

    } elsif($arg->{pmid}) {
      $gl->{PAINT_TEMP_REP} =
        $pm->check_pool(0, $arg->{pmid})
          or $bn->error('ERR_DATA_NOTFOUND', $arg->{pmid});
    }
  }

}

sub captor_spa {
  my( $pm, $mode ) = @_;
  my $cf = $bn->{cfg};
  my $gl = $bn->{global};
  my $err = $pm->{error};
  my $obj = $gl->{object};
  my $obj_len = $ENV{CONTENT_LENGTH};


  $obj_len--;
  # Expansion Param
  my $data_size;
  $bn->read(\$data_size, 8);
  $data_size = int $data_size;
  $obj_len -= $data_size + 8;

  $bn->read(\$obj->{param}, $data_size);

  $obj->{arg}{timer} = $1 if $obj->{param} =~ s/timer=(\d+)&//;
  $obj->{arg}{count} = $1 if $obj->{param} =~ s/count=(\d+)&//;

  $obj->{param} = $bn->decrypt($obj->{param}) if $bn->get($cf, 'UseCrypt');
  $bn->unescape(\$obj->{param});
  $obj->{param} =~ s/\t//g;

  for (split /&/, $obj->{param}) {
    my($name, $val) = split /=/;
    $obj->{arg}{$name} = $val;
  }
  $pm->captor_continue($obj->{arg});

  my $limit_data = $bn->get($cf, 'LimitPaintData');
  my $limit_anime = $bn->get($cf, 'LimitAnimeData');
  my $limit_thumb = $bn->get($cf, 'LimitThumbnailData');
  my $limit_width = $bn->get($cf, 'LimitImageWidth');
  my $limit_height = $bn->get($cf, 'LimitImageHeight');

  my $app_cfg = $bn->get($cf, 'Config' . $mode);


  # Main Image
  $bn->read(\$data_size, 8);
  $bn->read(\$_, 2);
  $data_size = int $data_size;
  $obj_len -= $data_size + 10;
  if ($data_size > $limit_data) {
    if ($bn->get($cf, 'UsePaintDataOverConvert')) {
      my $img = "$bn->{sys}{DirSys}/$gl->{IP}.tmp";
      my $fh = $bn->open($img, '>');
      if ($fh) {
        binmode $fh;
        $pm->get_obj('Image', $data_size);
        $obj->{Image}{path} = $img;
        print $fh $obj->{Image}{data};
        close $fh;
        my $abt = "$bn->{sys}{DirSys}/resume.$bn->{sys}{Exe}";
        my($resume, $ip);
        if (-e $abt && (my $fh_res = $bn->open($abt)) ) {
          $ip = <$fh_res>; $resume = <$fh_res>; close $fh_res;
          chomp $ip; undef $resume and unlink $abt if $ip ne $gl->{IP} }
        my($path, $re) = $bn->po->image_match_size($obj->{Image}, $limit_data, $resume);
        if (!-e $path) {
          unlink $path; unlink $img;
          if (my $fh_res = $bn->open($abt, '>')) { print $fh_res "$gl->{IP}\n$re"; close $fh_res }
          $bn->error('ERR_CAPTOR_SIZE_REJUME', $data_size, $limit_data, $re);
        }
        unlink $abt if -e $abt;
        if (my $fh = $bn->open($path)) {
          binmode $fh;
          delete $obj->{Image}{data};
          while(<$fh>){ $obj->{Image}{data} .= $_ };
          close $fh;
          @{$obj->{Image}}{'mime', 'width', 'height', 'size'}
           = $bn->po->file_analyze(\$obj->{Image}{data});

          unlink $path; unlink $img;
          $err->{image_over} = 1;
        }
      }
    } else {
      $bn->error('ERR_CAPTOR_SIZE', $data_size, $limit_data);
    }
  } else {
    $pm->get_obj('Image', $data_size);
  }

  if ( $limit_width < $obj->{Image}{width} || $limit_height < $obj->{Image}{height}) {
    $bn->error('ERR_CAPTOR_PIXEL_SIZE', $obj->{Image}{width}, $obj->{Image}{height}, $limit_width, $limit_height);
  }

  # EX Thumbnail Image or Anime Data
  if ($obj_len > 0) {
    $bn->read(\$data_size, 8);
    $data_size = int $data_size;
    if ($data_size) {
      $obj_len -= $data_size + 8;
      $pm->get_obj('Obj', $data_size);
      # ShiPainter Anime Format
      if ($obj->{Obj}{mime} eq $app_cfg->{anime_ext}){
        if ( $data_size > $limit_anime ) {
          $err->{anime_over} = 1;
          $obj->{PoolAnime} = $obj->{Obj}
           if $data_size <= $bn->get($cf, 'PaintPoolMaxAnime');
        } else {
          $obj->{Anime} = $obj->{Obj};
        }
      # ShiPainter Thumbnail Image Format
      } else {
        if ($data_size > $limit_thumb){
          $err->{thumbnail_over} = 1;
        } elsif($bn->get($cf, 'UseThumbnail')) {
          $obj->{Thumb} = $obj->{Obj};
        }
      }
    }

    # EX Thumbnail Image
    $bn->read(\$data_size, 8);
    $data_size = int $data_size;
    if ($data_size) {
      $obj_len -= $data_size + 8;
      if ($data_size > $limit_thumb){
        $err->{thumbnail_over} = 1;
      } elsif($bn->get($cf, 'UseThumbnail')) {
        $pm->get_obj('Thumb', $data_size);
      }
    }
  }

}

sub captor_pic {
  my $pm = $_[0];
  my $cf = $bn->{cfg};
  my $obj = $bn->{global}{object};
  my $obj_len = $ENV{CONTENT_LENGTH};
  my $limit_data = $bn->get($cf, 'LimitPaintData');
  $bn->read(\$_, 2);
  return unless /(\x6E\x67|\x70\x67)/;

  my $data_size;
  $bn->read(\$data_size, 8);
  $data_size = int $data_size;
  if ($data_size > $limit_data) {
    $bn->error('ERR_CAPTOR_SIZE', $data_size, $limit_data);
  }

  $pm->get_obj('Image', $data_size);
  $obj_len -= $data_size + 170;
  $bn->read(\$_, 9); # PictureBBS APP Palette Data Delete
  $bn->read(\$obj->{param}, $obj_len);
  $bn->unescape(\$obj->{param});
  $obj->{param} = $bn->decrypt($obj->{param}) if $bn->get($cf, 'UseCrypt');
  $bn->unescape(\$obj->{param});
  $obj->{param} =~ s/\t//g;

  for (split /&/, $obj->{param}) {
    my($name, $val) = split /=/;
    $obj->{arg}{$name} = $val;
  }

}

sub get_obj {
  my( $pm, $obj, $len ) = @_;
  my $cf = $bn->{cfg};
  my $h = $bn->{global}{object}{$obj} = {};
  $bn->read(\$h->{data}, $len);
  @{$h}{'mime', 'width', 'height', 'size'}
   = $bn->po->file_analyze(\$h->{data});
}

sub stream {
  my $pm = $_[0];
  my $cf = $bn->{cfg};
  my $src = $bn->{in}{src};
  my $type;
  my $spa_ext = $bn->get($cf, 'ConfigShiPainter')->{anime_ext} if ref $bn->get($cf, 'ConfigShiPainter') eq 'HASH';
  my $sii_ext = $bn->get($cf, 'ConfigShiPaintBBS')->{anime_ext} if ref $bn->get($cf, 'ConfigShiPaintBBS') eq 'HASH';

  $src =~ s#[^\w\.\-]##g;

  $bn->error('BAD_REQUEST')
    unless (ref $bn->get($cf, 'ConfigApplet') eq 'HASH' && $bn->get($cf, 'ConfigApplet')->{stream}) || $src =~ /\.($spa_ext|$sii_ext)$/;

  if ($src =~ /\.($spa_ext|$sii_ext)$/) {
    $src = "$bn->{sys}{DirData}/$src";
    $type = 'application/octet-stream';
  } elsif($src =~ /\.(zip|jar)$/) {
    $src = "$bn->{bn_dir}$src";
    $type = 'application/java-archive';
  } elsif($src =~ /\.(jpg|gif)$/) {
    $src = "$bn->{sys}{DirData}/$src";
    $type = 'image/' . ($1 eq 'gif'?'gif':'jpeg');
  } else {
    $bn->error('BAD_REQUEST');
  }

  $bn->error('ERR_DATA_NOTFOUND', $bn->{in}{src}) unless -e $src;

  my $fh = $bn->open($src);
  $fh or $bn->error('ERR_DATA_NOTOPEN', $bn->{in}{src});
  $bn->{temp}{fh}{bin} = $fh;
  binmode $fh; binmode STDOUT;
  $bn->send_http_header($type);
  while (<$fh>) { $bn->print($_) }
  delete $bn->{temp}{fh}{bin};
  close $fh;
  $bn->EXIT;
}


sub post_regist {
  my $pm = $_[0];
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my $sk = $bn->{skin};
  my $gl = $bn->{global};
  my $sys = $bn->{sys};

  $pm->{pmid} = $in->{pmid} ? $in->{pmid} : $bn->{cookie}{pmid};
  my $result = $pm->check_pool(0, $pm->{pmid});
  unless ($result) {
    undef %{$bn->{in}};
    $bn->open_page;
    $bn->EXIT;
  }

     if ($in->{mode} eq 'delete')   { $pm->delete_pool }
  elsif ($in->{mode} eq 'continue') { $pm->open_continue }

  my($ip, $id, $time, $args, $width, $height, $size, @images) = split /\t/, $result;
  my %app_arg; map{ my @a = split /=/; $app_arg{$a[0]} = $a[1] } split /&/, $args;
  $gl->{PM}{paint_time} = $pm->set_paint_time($app_arg{timer} ? int substr $app_arg{timer}, 0, -3 : $time - oct '0x' . $app_arg{'time'});
  $gl->{PM}{applet_name} = $app_arg{app};
  $gl->{LogExValue}{history} = $app_arg{history} if $app_arg{history};
  $gl->{LogExValue}{paint_timer} = $app_arg{timer};
  $gl->{LogExValue}{paint_count} = $app_arg{count};

  $pm->anime_alert( $result ) if exists $app_arg{anime_alert};

  $bn->call('PaintPostRegist');
  $pm->post_regist_hook($time, \@images, \%app_arg);
  $sys->{MODE} = 'PAINT';
  $bn->open_post;
  $bn->EXIT;

}

sub anime_alert {
  my( $pm, $result ) = @_;
  my $cf = $bn->{cfg};
  my $sys = $bn->{sys};
  my $item = $pm->item;
  my $spv_cfg = $bn->get($cf, 'ConfigShiPCHViewer');
  my($ip, $id, $time, $args, $width, $height, $size, @images) = split /\t/, $result;
  my %app_arg; map{ my @a = split /=/; $app_arg{$a[0]} = $a[1] } split /&/, $args;
  if ( $app_arg{anime_alert} == 2 ) {
    $result =~ s/(anime_alert=)2/$1\Q1\E/;
    $pm->check_pool(2, $id, $result);
  }

  $bn->send_http_header->head;
  if ( $images[0] && -e $sys->{DirData}.'/'.$images[0] ) {
    my @txt = map{$item->{'anime_alert_txt'.$_}}1..2;
    $_ = join '<br>', @txt;
    $bn->frame($item->{poollist}, '<table><tr><td nowrap>'.
      $bn->set_tag($bn->get($cf, 'TagTableFont'), {
        string => '<b>'.$item->{poollist_date}.'</b> : '. $bn->get_date($time).
        '<p><small>'.$item->{anime_over}.
        "$_<table><tr>". $pm->anime_dl_link( $images[0], $spv_cfg )."</tr></table>".
        '</small></p>'
      }). '</td></tr></table>');
  } else {
    $_ = $item->{anime_del}; s/\\n/<br>/g;
    $bn->frame( '<span style="font-size:11pt">'.$item->{anime_over}.'</span>',
     $bn->set_tag($bn->get($cf, 'TagTableFont'), {string => $_}));
  }
  $bn->print( '<center>', $bn->back_button, '</center>' );
  $bn->foot->EXIT;
}

sub paint_write {
  my $pm = $_[0];
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my $ck = $bn->{cookie};
  my $arg = $bn->{arg};
  $bn->{flag}{PaintWrite} = 1;

  $pm->{pmid} = $in->{pmid} ? $in->{pmid} : $ck->{pmid};
  my $result  = $pm->check_pool(0, $pm->{pmid});
  $bn->error('ERR_POOL_FAILED_ID', $pm->{pmid}) unless $result;

  my ($ip, $id, $time, $args, $width, $height, $size, @images) = split /\t/, $result;
  @{$bn->{data}}{'width', 'height', 'size'} = ($width, $height, $size);
  $arg->{paint_pool} = {};
  map{ my @a = split /=/,$_; $arg->{paint_pool}{$a[0]}=$a[1] }split /&/,$args;
  map{ $arg->{BackButton}{$_} = $in->{$_} }keys %$in;
  $in->{continue} = $arg->{paint_pool}{continue} if exists $arg->{paint_pool}{continue};
  $bn->call('PaintWriteBegin');
  $pm->check_paint_auth;
  $pm->post_regist_hook($time, \@images, $arg->{paint_pool});
  my $cfg_back = $bn->get($cf, 'NeedData');
  $bn->set_call('CheckInputInit', sub{ $bn->set($cf, 'NeedData', 0) });
  $bn->set_call('CheckInputEnd', sub{ $bn->set($cf, 'NeedData', $cfg_back) });
  $pm->paint_write_value($arg->{paint_pool}, \@images, $time);
  $bn->po->write;
  $bn->call('PaintWriteEnd');
  $bn->EXIT;
}

sub post_regist_hook {
  my( $pm, $time, $images, $app_arg ) = @_;
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my $item = $pm->item;
  my $data = {};
  my %img;

  delete $in->{mode};

  $bn->set_call('PostFormBegin', sub{
    if ($bn->get($cf, 'UseIcon')) {
      my $flag = $bn->{flag};
      $flag->{UseIcon} = $bn->get($cf, 'UseIcon');
      $bn->set($cf, 'UseIcon', 0) unless $bn->get($cf, 'IconViewForce');
      $bn->set_call('PostFormEnd', sub{ $bn->set($cf, 'UseIcon', $flag->{UseIcon}) });
    }
    $bn->set_call('SkinHeadBegin', sub{
      return if $bn->{flag}{post_regist_hook};
      $bn->{data}{title} = $item->{write_msg_title};
      $bn->{flag}{post_regist_hook} = 1;
    });
  });
  $bn->set_call('OpenPostInit', sub{$bn->{sys}{MODE} = 'PAINT'});

  $bn->set_call('PostFormTranslate', sub{
    my $data_dir = $bn->get($cf, 'DirFileUrl');
    $data->{post_time} = $bn->get_date($time);
    my %over; for(qw/image anime thumbnail/)
     { $over{$_} = $item->{$_.'_over'} if $app_arg->{$_.'_over'} }

    for my $i(@$images) {
      for (('Image','Anime','Thumb')) {
        my $head = $bn->get($cf, 'FileHead' . $_);
        if ($i =~ /^$head/) { $img{$_} = $i; last }
      }
    }

    my $js;
    if ( exists $app_arg->{anime_over} ) {
      $js = '<script type="text/javascript"><!--'."\n alert('". $item->{anime_over_alert}.'\\n';
      if ( $app_arg->{anime_over} == 1 ) {
        my $a = $item->{anime_del};
        $js .= $a; $a =~ s/\\n/<br>/g;
        $over{anime} .= "<p>$a</p>";
      } elsif( -e "$bn->{sys}{DirData}/$app_arg->{anime_over}" ) {
        my $spv_cfg = $bn->get($cf, 'ConfigShiPCHViewer');
        $spv_cfg->{anime_dl_type} = 'auto' if $spv_cfg->{anime_dl_type} eq 'none';
        my @txt = map{$item->{'anime_alert_txt'.$_}}1..3;
        $_ = join '<br>', @txt;
        $over{anime} .= "<p>$_<table><tr>". $pm->anime_dl_link( $app_arg->{anime_over}, $spv_cfg )."</tr></table></p>";
        $js .= join '\\n', @txt;
      }
      $js .= "')\n//-->\n</script>";
    }

    my $contents = '<table><tr><td width="90%" align="center"><img src="'.$data_dir.'/' .
    ($img{Thumb} ? $img{Thumb} : $img{Image}) . '"></td><td nowrap>'.
    $bn->set_tag($bn->get($cf, 'TagTableFont'), {
      string => '<b>'.$item->{poollist_date}.'</b> : '.$data->{post_time}.
      '<p><small>'.(join '',map $over{$_},qw/image anime thumbnail/).$item->{poolmenu_txt1}.'</small></p>'
    }). '</td></tr></table>'. $js;
    $bn->frame($item->{write_msg_title}, $contents);

  });

  $bn->{flag}{UPLOAD_ENABLE} = 0;
  $bn->set_call('PostFormInitBegin', sub{
    $bn->{global}{value}{fc} = 'paint_write';
    $bn->set($cf, 'UseUpload', 0);
    $bn->{flag}{UPLOAD_ENABLE} = 0;
    $bn->{flag}{POST_FORM_TITLE} = 1;
    $bn->{arg}{BackButton}{fc} = '';
    $bn->{arg}{PostForm}{pmid} = $pm->{pmid};
  });

}

sub pool_menu {
  my( $pm, $result, $flag ) = @_;
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my $sk = $bn->{skin};
  my $sys = $bn->{sys};
  my $item = $pm->item;
  my $data = {};
  my($ip, $id, $time, $args, $width, $height, $size, @images) = split /\t/, $result;
  my %app_arg;
  map{ my @a = split /=/; $app_arg{$a[0]} = $a[1] } split /&/, $args;

  if ( $flag && exists $app_arg{anime_alert} ) {
    $pm->anime_alert( $result ) if $app_arg{anime_alert} == 2;
    $pm->check_pool(1, $id); return;
  }

  my $bbsnoteurl = $bn->get($cf, 'BBSNoteUrl');
  my(%img, $radio_new_paint, $radio_continue, $txt_continue);
  $data->{post_time} = $bn->get_date($time);
  my $del_min = int ( ( $time + ( $bn->get($cf, 'PaintPoolMaxTime') * 60 ) - time ) / 60 );
  $data->{del_time} = $del_min > 0 ? $item->{remaine} . " $del_min" . $item->{ptime_min} : $item->{period};

  for my $i(@images) {
    for (('Image','Anime','Thumb')) {
      my $head = $bn->get($cf, 'FileHead' . $_);
      if ($i =~ /^$head/) { $img{$_} = $i; last }
    }
  }

  $bn->call('PoolMenuBegin');

  if ($in->{fc} =~ /^paint_/) {
    delete $in->{submit};
    map{ $bn->{arg}{PoolMenu}{$_} = $in->{$_} }keys %$in;
    $radio_new_paint = '<input type="radio" name="mode" value="new" id="r2"><label for="r2"> '.
     $item->{new_paint} . '</label><br>';
  } else {
    $bn->{arg}{PoolMenu}{fc} = 'paint_regist';
  }

  my $txt_new_paint = $item->{st} . $item->{new_paint} . $item->{ed};
  if ($bn->{module}{Paint}{layout}{continue} &&
      ($img{Anime} || $img{Image} =~ /\.(gif|jpg)$/ ||
        ( $img{Image} =~ /\.png$/ &&
           $bn->get($cf, 'UseImageMagick') &&
            $bn->get($cf, 'UsePaintContinueConvert') )
      )
  ) {
    $txt_continue = $item->{st} . $item->{continue} . $item->{ed};
    $radio_continue = '<input type="radio" name="mode" value="continue" id="r3"><label for="r3"> '.
     $item->{continue}. '</label><br>';
  }

  delete $in->{submit};
  my $arg = $bn->set_form_arg($bn->{arg}{PoolMenu}, { pmid => $bn->{cookie}{pmid} });
  my %over; for(qw/image anime thumbnail/)
     { $over{$_} = $item->{$_.'_over'} if $app_arg{$_.'_over'} }
  my $data_dir = $bn->get($cf, 'DirFileUrl');

  if ( exists $app_arg{anime_over} ) {
    if ( $app_arg{anime_over} == 1 ) {
      my $a = $item->{anime_del}; $a =~ s/\\n/<br>/g;
      $over{anime} .= "<p>$a</p>";
    } elsif( -e "$sys->{DirData}/$app_arg{anime_over}" ) {
      my $spv_cfg = $bn->get($cf, 'ConfigShiPCHViewer');
      $spv_cfg->{anime_dl_type} = 'auto' if $spv_cfg->{anime_dl_type} eq 'none';
      my @txt = map{$item->{'anime_alert_txt'.$_}}1..2;
      $_ = join '<br>', '<b>'.$item->{anime_over_alert}.'</b>', @txt;
      $over{anime} = "<p>$_<table><tr>". $pm->anime_dl_link( $app_arg{anime_over}, $spv_cfg )."</tr></table></p>";
    }
  }

  my $img_tag = '<td width="90%" align="center"><img src="'.$data_dir.'/' .
    ($img{Thumb} ? $img{Thumb} : $img{Image}) . '"></td>' if exists $img{Image} || exists $img{Thumb};

  my $contents = '<table><tr>'. $img_tag. '<td nowrap>'.
  $bn->set_tag($bn->get($cf, 'TagTableFont'), {string => <<_HTML_
  <b>$item->{poollist_date}</b> : $data->{post_time}<br>
  <b>$item->{poollist_term}</b> : $data->{del_time}<br>
  <br><small>
  $over{image}$over{anime}$over{thumbnail}
  $item->{poolmenu_txt1}
  $txt_new_paint$txt_continue
  $item->{poolmenu_txt2}
  </small><p>
  <form method="post" action="$bbsnoteurl">$arg
    <input type="radio" name="mode" value="regist" id="r1" checked><label for="r1"> $item->{write_message}</label><br>
    $radio_new_paint $radio_continue
    <input type="radio" name="mode" value="delete" id="r4"><label for="r4"> $item->{delete_image}</label><br>
    <br><center><input type="submit" class="submit" style="width:50%" value="$item->{submit}"></center>
  </form></p>
_HTML_
  }) . '</td></tr></table>';

  if ( $in->{fc} =~ /^paint/ ) {
    $bn->frame($item->{poolmenu_caption}, $contents);
  } else {
    $bn->set_call('OpenPageMenu',
     sub{$bn->frame($item->{poolmenu_caption}, $contents)});
  }
}

sub pool_object_rename {
  my $pm = $_[0];
  my $cf = $bn->{cfg};
  my $gl = $bn->{global};
  my $ex = $gl->{LogExValue};

  my $h = $gl->{FILES};
  my $data = $bn->{data};
  my $dir = $bn->{sys}{DirData};
  my $po = $bn->po;

  $po->set_filename($h->{Image});
  rename "$dir/$h->{Image}{name}", $h->{Image}{path};

  $h->{file}{size} = $data->{size};
  $h->{file}{width} = $data->{width};
  $h->{file}{height} = $data->{height};
  $h->{file}{filename} = $h->{Image}{filename};

  if ($h->{Anime}{name} && $h->{Thumb}{name}) {
    $po->set_filename($h->{Anime});
    $po->set_filename($h->{Thumb}, $bn->get($cf, 'FileHeadThumb'));
    $h->{object}{filename} = $h->{Anime}{filename};
    $ex->{thumbsrc}= $h->{Thumb}{filename};
    rename "$dir/$h->{Anime}{name}", $h->{Anime}{path};
    rename "$dir/$h->{Thumb}{name}", $h->{Thumb}{path};

  } elsif($h->{Thumb}{name}) {
    $po->set_filename($h->{Thumb}, $bn->get($cf, 'FileHeadThumb'));
    rename "$dir/$h->{Thumb}{name}", $h->{Thumb}{path};
    $h->{object}{filename} = $h->{Thumb}{filename};

  } elsif($h->{Anime}{name}) {
    $po->set_filename($h->{Anime});
    rename "$dir/$h->{Anime}{name}", $h->{Anime}{path};
    $h->{object}{filename} = $h->{Anime}{filename};
  }

  if (exists $h->{Ex}) {
    $po->set_filename($h->{Ex});
    rename "$dir/$h->{Ex}{name}", $h->{Ex}{path};
    $gl->{LogExValue}{imagesrc}= $h->{Ex}{filename};
  }
}


sub anime_analyze {
  my $pm = $_[0];
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my $gl = $bn->{global};
  my $fl = $gl->{file};
  return if $fl->{mime};
  my $data = $gl->{data};
  my $obj = $gl->{object};
  if ($$data =~ /^\x1F\x8B\x08\x00.+/) {
    my $app_cfg = $bn->get($cf, 'ConfigShiPaintBBS');
    $fl->{mime} = $app_cfg->{anime_ext};
    if ($obj->{Image}{width}) {
      my $s = pack("v",0);
      my $w = pack("v",int $obj->{Image}{width});
      my $h = pack("v",int $obj->{Image}{height});
      $fl->{width} = $obj->{Image}{width};
      $fl->{height} = $obj->{Image}{height};
      $$data =~ s/^(\x1F\x8B\x08\x00).{6}(.+)/$1$s$w$h$2/s
    } elsif($$data =~ /^\x1F\x8B\x08\x00(.)(.)(.)(.)(.)(.).+/s) {
      $fl->{width} = ord($4)*256 + ord($3);
      $fl->{height} = ord($6)*256 + ord($5);
    }
    $bn->set_call('OpenPageBegin', sub{
       $pm->open_anime_size }
    ) unless $fl->{width} || $fl->{height};
  } else {
    my $p = index $$data, "\x0D\x0A\x0D\x0A";
    if ($p > 0) {
      my $head = substr $$data, 0, $p;
      my %hash;
      map{ my @p = split /=/; $hash{$p[0]} = $p[1] }split /\x0D\x0A/, $head;
      if ($hash{layer_count} && $hash{image_width} && $hash{image_height}) {
        my $app_cfg = $bn->get($cf, 'ConfigShiPainter');
        $fl->{mime} = $app_cfg->{anime_ext};
        $fl->{width} = $hash{image_width};
        $fl->{height} = $hash{image_height};
      }
      $$data = "\x00\x0D\x0A".$$data if $$data !~ /^\x00\x0D\x0A/;
    }
  }
}

sub check_file {
  my $pm = $_[0];
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my $gl = $bn->{global};
  my $err = $gl->{error};

  my $h = $gl->{FILES}{file};
  my $sii_ext = $bn->get($cf, 'ConfigShiPaintBBS')->{anime_ext};
  my $spa_ext = $bn->get($cf, 'ConfigShiPainter')->{anime_ext};

  if ($h->{mime} =~/$sii_ext|$spa_ext/) {
    $bn->{flag}{check_mime} = 1;
    if ($bn->get($cf, 'LimitAnimeData') < $h->{size}) {
      if ($bn->{flag}{PAINT_CAPTOR}) {
        $bn->error('ERR_CAPTOR_SIZE', $h->{size}, $bn->get($cf, 'LimitAnimeData'));
      } else {
        push @$err,$bn->info('CHECK_UPDATASIZEOVER', $bn->get($cf, 'LimitAnimeData'), $h->{size});
        return;
      }
    }
  }

  # BBSPainter Thumbnail
  for (@{$bn->{module}{Paint}{applets}}) {
    if ($_->{applet} eq 'pai' && $_->{key} eq $bn->{in}{app}) {
      $bn->set_call('WritePostValues',sub{
        $gl->{PM}{paint_time} = $pm->set_paint_time(time - oct '0x' . $in->{'time'}) if $in->{'time'};
        $gl->{PM}{applet_name} = $in->{app};
        $gl->{LogExValue}{history} = $in->{history} if $in->{history};
      });

      $bn->set_call('WritePostModePost',sub{
        my $o = $gl->{FILES}{object};
        @{$o}{'mime', 'width', 'height', 'size'}
         = $bn->po->file_analyze(\$in->{'bbspainter_thumb'});

        if ($bn->get($cf, 'LimitThumbnailData') < $o->{size}) {
          delete $in->{'bbspainter_thumb'};
        } else {
          $o->{data} = \$in->{'bbspainter_thumb'};
          $bn->po->set_filename($o, $bn->get($cf, 'FileHeadThumb'));
        }
      });
      last;
    }
  }
}

sub check_regist {
  my $pm = shift;
  my $sk = $bn->{skin};
  my $result = $pm->check_pool(0, $bn->{cookie}{pmid});
  return if !$result;
  $bn->send_http_header->head;
  $pm->pool_menu($result);
  $bn->foot;
  $bn->EXIT;
}

sub check_open_page_pool {
  my $pm = $_[0];
  my $result = $pm->check_pool(0, $bn->{cookie}{pmid});
  return if !$result;
  $pm->pool_menu($result, 1);
}


sub check_pool {
  my( $pm, $flag, $pmid, $add_pool ) = @_;
  my $cf = $bn->{cfg};
  my $gl = $bn->{global};

  my $ip_str = join '',map {sprintf("%02X", $_)} split '\.', $gl->{IP};
  my $t = time;
  my $path = "$bn->{sys}{DirSys}/pool.$bn->{sys}{Exe}";
  if ( !-e $path ) {
    my $fh = $bn->open($path, '>');
    $fh or $bn->error('ERR_SYS_NOTWRITE', $path);
    close $fh;
  }
  return if !-e $path;
  my $fh = $bn->open($path);
  $fh or $bn->error('ERR_SYS_NOTOPEN', $path);

  $bn->{temp}{fh}{pool} = $fh;

  my($i, @r, $fh_tmp, $tmp);

  if ($flag) {
    ($fh_tmp, $tmp) = $bn->get_temp_file;
    if ($flag == 1 && $add_pool) { print $fh_tmp "$add_pool\n"; $i++ }
  }

  while (<$fh>) {
    my($ip, $id, $time, $arg, $width, $height, $size, @file) = split /\t/;
    $i++;
    if ( $ip_str eq $ip || $pmid eq $id ) {
      push @r, $_;
      if ($flag == 1) { $bn->app->delete_files(@file); next }
      elsif ($flag == 2) { print $fh_tmp "$add_pool\n"; next }
    }
    if ($flag) {
      if ( $time + ($bn->get($cf, 'PaintPoolMaxTime') * 60) < $t) { $bn->app->delete_files(@file); next }
      if ($i > $bn->get($cf, 'PaintPoolMaxData')) { $bn->app->delete_files(@file); next }
      print $fh_tmp $_;
    }
  }
  delete $bn->{temp}{fh}{pool};
  close $fh;
  unlink $path unless defined $i;
  if ($flag) { close $fh_tmp; rename $tmp, $path }
  chomp $r[0];
  return $r[0];

}

sub delete_pool {
  my $pm = $_[0];
  undef $bn->{in}{mode};
  my $result = $pm->check_pool(1, $bn->{cookie}{pmid});
  $bn->error('ERR_DATA_NOTFOUND', $bn->{cookie}{pmid}) unless $result;
  $bn->reset_javascript;
  $bn->open_page;
  $bn->EXIT;
}

sub replace_continue {
  my( $pm, $obj ) = @_;
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my $gl = $bn->{global};
  my $sys = $bn->{sys};
  my $arg = $obj->{arg};
  $bn->{flag}{PaintWrite} = 1;

  # user : cookie auto login
  if ($bn->get($cf, 'UseNameCap')) {
    $bn->usr->cap($in->{name}, $in->{password}, {});
  }

  utime time,time,$0 if $bn->get($cf, 'UseMetaCookie');

  my $DATE = $bn->get_date;
  $gl->{LogFile} = $bn->filelog($arg->{log});

  $bn->po->reply_index($arg->{log}, 1);
  my $val = $gl->{LogValue} = {};
  my $ex = $gl->{LogExValue} = {};
  $bn->app->get_log($arg->{log},'', $val, $ex);

  $bn->call('ReplaceContinueBegin');

  $bn->app->delete_files(@{$val}{'file_name','object'},@{$ex}{'thumbsrc','animesrc'});

  if ($val->{file_name} =~ /_(\d+)_?(\d+)?\.\w+$/) {
    my $num = $1; my $inc = $2; $inc++;
    for (('Image','Anime','Thumb')) {
      next if !exists $obj->{$_} || !$obj->{$_}{mime};
      $obj->{$_}{filename} = $bn->get($cf, 'FileHead' . $_) . "\_$num\_$inc.$obj->{$_}{mime}";
      $obj->{$_}{path} = $sys->{DirData}.'/'.$obj->{$_}{filename};
    }
  }

  # ex edit info
  if (!$bn->get($cf, 'NotEditRecord')) {
    $ex->{edit} .= ",$val->{date}@" . ($val->{iphost} ? $val->{iphost} : "$val->{ip}($val->{host})");
    $ex->{edit} =~ s/^\,//;
  }

  my $ip_str = join '', map {sprintf("%02X", $_)}split '\.',
   ( exists $val->{iphost} && $val->{iphost} =~ /(\d+\.\d+\.\d+\.\d+)/ ? $1 : $val->{ip} );
  my $ptime_sec = ($pm->get_paint_time($val->{paint_time}))[4];
  $ex->{history} .= '+' if $ex->{history} ne '';
  $ex->{history} .= "$val->{date}%$ptime_sec%$ip_str";
  $val->{applet} = (split /\+/, $arg->{app}, 2)[0].
   ( $val->{applet} ne '' ? "+$val->{applet}" : '' );

  $val->{ip} = $gl->{IP};
  $val->{host} = $gl->{HOST};
  $val->{iphost} = "$gl->{IP}($gl->{HOST})";

  $val->{date} = $DATE;
  $val->{agent} = $arg->{agent};
  $val->{file_name} = $obj->{Image}{filename};
  $val->{file_width} = $obj->{Image}{width};
  $val->{file_height} = $obj->{Image}{height};
  $val->{file_length} = $obj->{Image}{size};
  $val->{paint_time} = $pm->set_paint_time($obj->{paint_time} + $arg->{painttime});
  $val->{object} = $obj->{Anime}{size} ? $obj->{Anime}{filename} : $obj->{Thumb}{size} ? $obj->{Thumb}{filename} : '';

  $ex->{thumbsrc} = $obj->{Anime}{size} && $obj->{Thumb}{size} ? $obj->{Thumb}{filename} : '';
  $ex->{paint_timer} = $arg->{timer};
  $ex->{paint_count} = $arg->{count};

  $sys->{MODE} = 'EDIT_POST';
  $bn->po->write_log_value($gl->{LogFile}, $val, $ex);
  $sys->{MODE} = 'WRITE_PAINT_REPLACE';

  $bn->set_call('SkinHeadFormat', sub{$bn->set_applet_form_script});
  $bn->app->reflesh;

}

sub paint_write_value {
  my( $pm, $arg, $images, $time ) = @_;
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my $gl = $bn->{global};
  my $ck = $bn->{cookie};

  $bn->set_call('WritePostValues', sub{
    my $h = $gl->{FILES};
    my $ex = $gl->{LogExValue};
    for (@$images) {
      for my $o('Image','Anime','Thumb') {
        my $head = $bn->get($cf, 'FileHead' . $o);
        next if !/^$head/;
        my $obj = exists $h->{$o} ? 'Ex' : $o;
        $h->{$obj}{name} = $_;
        $h->{$obj}{size} = 1;
        $h->{$obj}{mime} = $1 if /\.(\w*)$/;
        last;
      }
    }

    $gl->{PM}{paint_time} = $pm->set_paint_time(
      $arg->{timer} ? int substr $arg->{timer}, 0, -3 : $time - oct '0x'.$arg->{'time'});

    $gl->{PM}{applet_name} = $arg->{app};
    $ex->{history} = $arg->{history} if $arg->{history};
    $ex->{paint_timer} = $arg->{timer};
    $ex->{paint_count} = $arg->{count};

    $pm->pool_object_rename;
    $pm->check_pool(1, $pm->{pmid});
    $ck->{pmf} = 0;
    $ENV{HTTP_COOKIE} =~ s/(pmf:)1/$1\0/;
  });

  $bn->set_call('WriteHistoryBegin',sub{
    $bn->{data}{mode} = 'WRITE_PAINT_MESSAGE';
    $bn->{data}{pmid} = $in->{pmid};
  });

  $bn->set_call('OpenPageBegin',sub{ delete $in->{fc} });

}

sub continue_script {
  my( $pm, $image, $anime, $ap ) = @_;
  my $sk = $bn->{skin};
  my $ck = $bn->{cookie};
  my $item = $pm->item;

  my( @app, @type, @key );
  for ( @{$bn->{module}{Paint}{applets}} ) {
    if ( $_->{applet} =~ /spa|sii/ ) {
      push @app, '"' . $_->{name} . '"';
      push @type,'"' . ($_->{anime} eq 'spa' ? 1 : $_->{anime} eq 'sii' ? 2 : 0) . '"';
      push @key, '"' . $_->{key} . '"';
    }
  }
  my $a = join ',', @app; my $t = join ',', @type; my $k = join ',', @key;
  $bn->set_call('SkinHeadFormat',sub{$bn->{data}{javascript} .= <<_SCRIPT_;
  var App=new Array($a);
  var Type=new Array($t);var Key=new Array($k);
  var s1='$item->{continue_src1}';var s2='$item->{continue_src2}';
  var Img=$image;var Anime=$anime;
function PM_appInit(){
  var d=document.form_continue;
  var pma='$ck->{pma}';var p='$ap';var a=d.app;var s=d.src;n=0;
  while(n<App.length){a.options[n]=new Option(App[n]);a.options[n].value=Key[n];n++}n=0
  if(Img){s.options[0]=new Option(s1);s.options[0].value='image';n++}
  if(Anime){s.options[n]=new Option(s2);s.options[n].value='anime'}n=App.length
  for(i=0;i<n;i++){if(p&&Key[i]==p)d.app.selectedIndex=i}
  if(pma){if(Anime&&Img){d.src.selectedIndex=1}else if(Anime){d.src.selectedIndex=0}}
  PM_appChange(0);
  if(Img&&Anime) PM_appChange(1);
}
function PM_appChange(f){
  if(!document.form_continue)return
  var d=document.form_continue;var a=d.app;var s=d.src;n=App.length;i=0
  if(f){while(n>0){n--;if(s.selectedIndex){if(Type[n]==Anime){if(!a.options[n])a.options[n]=new Option(App[n]);
  a.options[n].text=App[n];a.options[n].value=Key[n]}else{a.options[n]=null}}
  else{if(!a.options[i])a.options[i]=new Option(App[i]);a.options[i].text=App[i];a.options[i].value=Key[i]}i++}}
  else{if(Img){s.options[0].text=s1;s.options[0].value='image';i++}else{s.options[0]=null;while(n>0){n--;
  if(Type[n]==Anime){if(!a.options[n])a.options[n]=new Option(App[n]);a.options[n].text=App[n];a.options[n].value=Key[n]}
  else{a.options[n]=null}}}if(a.selectedIndex!=-1){v=a.options[a.selectedIndex].value;n=Key.length;
  while(n>0){n--;if(Key[n]==v)break}}if(Type[n]==Anime){if(!s.options[i])s.options[i]=new Option(s2)
  s.options[i].text=s2;s.options[i].value='anime'}else{s.options[i]=null;s.selectedIndex=0}}
}

_SCRIPT_
});

}

sub open_pool_list{
  my $pm = $_[0];
  my $cf = $bn->{cfg};
  my $sk = $bn->{skin};
  my $gl = $bn->{global};
  my $item = $pm->item;

  my $contents;
  my $out = $bn->get($sk, 'TagTableOut');
  my $in = $bn->get($sk, 'TagTableIn');

  my $table_caption .= '<table style="font-size:10pt;text-align:center" cellspacing="1" cellpadding="4">'.
  '<tr style="color:'.$in->{bgcolor}.';font-weight:bold" bgcolor="'.$out->{bgcolor}.'">'.
  '<td>'.$item->{poollist_date}.'</td><td> IP </td><td nowrap>'.$item->{width}.' x '.$item->{height}.' : '.$item->{size}.'</td><td colspan="2">'.$item->{poollist_data}.'</td></tr>';

  my $path = "$bn->{sys}{DirSys}/pool.$bn->{sys}{Exe}";
  unless (-e $path) {
    my $fh = $bn->open($path, '>');
    $fh or $bn->error('ERR_SYS_NOTWRITE', $path);
    close $fh;
  }
  my $fh = $bn->open($path);
  $fh or $bn->error('ERR_SYS_NOTOPEN', $path);
  $bn->{temp}{fh}{pool} = $fh;

  my $cnt;
  my $data_dir = $bn->get($cf, 'DirFileUrl');
  my $bbsnoteurl = $bn->get($cf, 'BBSNoteUrl');
  my $arg = $bn->set_form_arg($bn->{arg}{'PoolMenu'});

  while (<$fh>) {
    my($ips, $id, $time, $args, $width, $height, $size, @file) = split /\t/;
    $cnt++;
    my @ips;
    for (my $i = 0; $i < 7; $i += 2) { push @ips,hex substr $ips,$i,2 }
    my $ip = join '.',@ips;
    my $DATE = $bn->get_date($time);
    my $fmt = '<a href="'.$data_dir.'/'.$file[0].'" target="_blank">'.(uc $1).'</a>' if $file[0] =~ /\.([^\.]+)$/;
    $contents .= $table_caption if $cnt == 1;
    $contents .= '<tr><form action="'.$bbsnoteurl.'" method="post">'.$arg.'<input type="hidden" name="fc" value="paint_regist"><input type="hidden" name="pmid" value="'.$id.'">'.
      '<td nowrap>'.$DATE.'</td><td>'.$ip.'</td><td nowrap>'.$width.' x '.$height.' : '.$size.' byte</td><td>'.$fmt.'</td><td><input class="submit" type="submit" value="'.$item->{submit}.'"></td></form></tr>';

  }
  delete $bn->{temp}{fh}{pool};
  close $fh;

  $contents .= "<h3>$item->{poollist_no_data}</h3>" unless $cnt;

  $bn->send_http_header->head($item->{poollist});

  $bn->{arg}{BackButton}{fc} = 'admin';
  $bn->{arg}{BackButton}{password} = $bn->{in}{password};
  delete $bn->{in}{mode};
  $contents .= $bn->back_button;
  $bn->frame($item->{poollist}, $contents)->foot;
  $bn->EXIT;
}


sub open_anime {
  my $pm = $_[0];
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my $sk = $bn->{skin};
  my $item = $pm->item;

  $bn->call('OpenAnimeInit');

  if ( $bn->get( $cf, 'LimitViewPaintAnime' ) ) {
    $bn->check_authority;
    $bn->error('ERR_FUNCTION') if $bn->{flag}{AUTHORITY} !~ /ADMIN/;
  }

  my $src = exists $in->{src} ? $in->{src} :
    exists $in->{log} ? $pm->get_log_anime_src($in->{log}): '' ;

  my $path = "$bn->{sys}{DirData}/$src";
  my $src_url = $bn->get($cf, 'DirFileUrl') . "/$src";

  $bn->error('ERR_DATA_NOTFOUND',
    ($path =~ /([^\/\\]+)$/ ? $1 : $path) ) unless -e $path;

  my($format, %param);
  my $item = $pm->item;
  my $spv_cfg = $bn->get($cf, 'ConfigShiPCHViewer');
  my $spa_cfg = $bn->get($cf, 'ConfigShiPainter');
  my $sii_cfg = $bn->get($cf, 'ConfigShiPaintBBS');
  my $bbsnoteurl = $bn->get($cf, 'BBSNoteUrl');
  $bn->set_app_cfg('AppletColorShiPCHViewer', $sk, $spv_cfg);
  $bn->tag_init($spv_cfg);
  $bn->{rf} = $spv_cfg;

  my $set_txt = sub {
    my $a = $bn->get($cf, 'TxtSpv' . $_[0]);
    $bn->define($cf, $_[1], undef, '@');
    for (@$a) { $bn->set($cf, 'Txt' . $_[1], $_) }
  };

  &$set_txt('Head', 'Head');
  &$set_txt('Top', 'BbsTop');
  &$set_txt('Bottom', 'MsgBottom');

  $bn->call('OpenAnimeBegin');


  # ShiPainter SPCH Format
  if ($path =~ /\.$spa_cfg->{anime_ext}$/) {
    $format = 'pch2';
    my $fh = $bn->open($path);
    $fh or $bn->error('ERR_DATA_NOTOPEN', $path);
    binmode $fh;
    $bn->{temp}{fh}{pch} = $fh;

    $param{image_size} = (stat $fh)[7];
    my($head, $pos, $flag);
    for (my $i = 0; $i < $param{image_size}; $i += 16) {
      read $fh, $_, 16;
      $head .= $_;
      $pos = index $head, "\x0D\x0A\x0D\x0A", $i - 2;
      if ($pos > 0) {
        $head = substr $head, 0, $pos;
        for (split /\x0D\x0A/,$head){
          my($name, $v) = split /=/;
          $bn->unescape(\$v);
          $param{$name} = $v;
        }
        $flag = 1;
      }
    }
    delete $bn->{temp}{fh}{pch};
    close $fh;

    $bn->error('UNKNOWN_FORMAT') unless $flag;

    $pm->{applet_height} = $param{image_height} + 27;
    $pm->{applet_width} = $param{image_width} + 0;

  # ShiPaintBBS PCH Format
  } elsif($path =~ /\.$sii_cfg->{anime_ext}$/) {
    $format = 'pch';
    $param{image_width} = $in->{width};
    $param{image_height} = $in->{height};
    $param{image_size} = (stat $path)[7];

    unless ($param{image_width}) {
      my $fh = $bn->open($path);
      $fh or $bn->error('ERR_DATA_NOTOPEN', $path);
      binmode $fh;
      $bn->{temp}{fh}{pch} = $fh;
      read $fh, $_, 4; read $fh, $_, 2;
      read $fh, $param{image_width}, 2;
      read $fh, $param{image_height}, 2;
      close $fh;
      $param{image_width} = unpack "v", $param{image_width};
      $param{image_height} = unpack "v", $param{image_height};
      unless ($param{image_width}) {
        $param{image_width} = $bn->get($cf, 'DefaultCanvasWidth');
        $param{image_height} = $bn->get($cf, 'DefaultCanvasHeight');
      }
      my $def_speed = unpack "v", $_;
      $spv_cfg->{speed} = int $def_speed if $def_speed > 0;
      $spv_cfg->{speed} = -1 if $spv_cfg->{speed} >= 65535;
    }

    $pm->{applet_height} = $param{image_height} + 27;
    $pm->{applet_width} = $param{image_width};
  }

  my $app_archive = $spv_cfg->{archive};
  my $app_code = "$format.$spv_cfg->{code}";
  my $app_codebase = $spv_cfg->{codebase} ? $spv_cfg->{codebase} : './';

  $src_url = "$bbsnoteurl?fc=stream&src=$src" if $spv_cfg->{cgi_stream};


  my %PARAM = (
    'pch_file'         =>  $src_url,
    'viewer'           =>  'true',
    'image_width'      =>  $param{image_width},
    'image_height'     =>  $param{image_height},

    'run'              =>  $spv_cfg->{run} ? 'true' : 'false',
    'speed'            =>  $in->{speed} ? int $in->{speed} : $spv_cfg->{speed},
    'progress'         =>  $spv_cfg->{progress} ? 'true' : 'false',
    'buffer_progress'  =>  $spv_cfg->{buffer_progress} ? 'true' : 'false',
    'buffer_canvas'    =>  $spv_cfg->{buffer_canvas} ? 'true' : 'false',
    'tt_size'          =>  $spv_cfg->{tt_size},
    'dir_resource'     =>  $spv_cfg->{resource},
    'tt.zip'           =>  $spv_cfg->{resource} . '/' . $spv_cfg->{texture},
    'res.zip'          =>  $spv_cfg->{resource} . '/' . $spv_cfg->{res},
    'layer_count'      =>  $param{layer_count} ? $param{layer_count} : $spv_cfg->{layer_count},

    'color_back'       =>  $spv_cfg->{color_back},
    'color_text'       =>  $spv_cfg->{color_text},
    'color_icon'       =>  $spv_cfg->{color_icon},
    'color_bar'        =>  $spv_cfg->{color_bar},
    'color_frame'      =>  $spv_cfg->{color_frame},
    'color_bar_select' =>  $spv_cfg->{color_bar_select},
    %{$bn->{arg}{Param_PCHViewer}},
  );

  for(qw/color_back:tagbodybgcolor color_text:tagbodytext color_icon:tagbodybgcolor
    color_bar:tagbodytext color_bar_select:tagformastmarkcolor color_frame:tagbodytext/)
   { my @a = split /:/; $PARAM{$a[0]} = $spv_cfg->{$a[1]} unless defined $PARAM{$a[0]} }
  my %js = ( 'app' => 'pchviewe', 'name' => 'app', 'code' => $app_code, 'archive' => $app_archive,
    'width' => $pm->{applet_width}, 'height' => $pm->{applet_height}, 'mayscript' => 'true' );
  my $j = $pm->paint_param_js_array( \%js, \%PARAM );
  $bn->set_call( 'SkinHeadFormat', sub{ my $data = $bn->{data};  $data->{javascript} .= $j });

  $bn->send_http_header->head;
  my $appelt_js = $bn->get( $cf, 'AppletJsUrl' ) ? $bn->get( $cf, 'AppletJsUrl' ) : undef;
  $appelt_js = $spv_cfg->{resource}. ( $spv_cfg->{resource} !~ m{/$} ? '/' : '' ). 'applet.js' unless $appelt_js;

  $bn->print( "\n", $item->{'NOT_ENABLE_JAVASCRIPT'}, "\n",
   '<script type="text/javascript" src="', $appelt_js, '"></script>', "\n",
   "<center>$param{image_width} x $param{image_height} ($param{image_size} byte)",
   '<table><tr>', $pm->anime_dl_link( $src, $spv_cfg ));

  if ($format eq 'pch') {
    my $a = $bn->{arg}{PaintAnimeSizeForm};
    $a->{num} = $in->{num}; $a->{log} = $in->{log}; $a->{fc} = 'paint_anime_size';
    my $arg = $bn->set_form_arg($a);
    $bn->print('<form action="'.$bbsnoteurl.'" method="post">'.$arg.'<td><input class="submit" type="submit" value="'.$item->{anime_txt1}.'"></td></form>'."\n");
  }
  $bn->print('<form><td><input class="button" type="button" value="'.$item->{close}.'" onclick="window.close()"></td></form></tr></table></center>');

  $bn->call('OpenAnimeEnd');

  $bn->foot;
  $bn->EXIT;
}

sub anime_dl_link {
  my( $pm, $src, $spv_cfg ) = @_;
  my $cf = $bn->{cfg};
  my $item = $pm->item;
  my $bbsnoteurl = $bn->get($cf, 'BBSNoteUrl');
  my $type = $spv_cfg->{anime_dl_type};
  my $fm;
  if ($type =~ /(^$|auto)/) {
#    $type = $gl->{UserBrowser} =~ /NN|FireFox/ ? 'post' : 'get';
    $type = 'get';
  }
  if ($type eq 'post') {
    $src =~ /(\.\w+)$/;
    $fm = '<form action="'.$bbsnoteurl.'?'.$src.'" method="post">'.
      '<input type="hidden" name="fc" value="stream"><input type="hidden" name="src" value="'.$src.'">'.
      '<td><input class="submit" type="submit" value="'.$item->{anime_download}.'"></td></form>';
  } elsif($type eq 'get') {
    $src = $spv_cfg->{cgi_stream} ? "$bbsnoteurl?fc=stream&src=$src" : $bn->get($cf, 'DirFileUrl') . "/$src";
    $fm = '<td class="button"><a href="'.$src.'">'.$item->{anime_download}.'</a></td>';
  } elsif($type eq 'none') {

  }
  $fm;
}

sub get_log_anime_src {
  my( $pm, $log, $password ) = @_;
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my $gl = $bn->{global};
  my $path = $gl->{LogFile} = $bn->filelog( $log );
  my $data = {};
  my $num = $in->{num} ? $in->{num} : undef;

  $bn->error('ERR_DATA_NOTFOUND',
    ($path =~ /([^\/\\]+)$/ ? $1 : $path) ) unless -e $path;

  my $fh = $bn->open($path);
  $fh or $bn->error('ERR_DATA_NOTOPEN', $path);
  my $n;
  while (<$fh>) {
    my $val = {}; my $ex = {};
    !$n ? $bn->get_log_main_value($_, $val, $ex) : $bn->get_log_reply_value($_, $val, $ex);
    $bn->get_src_value($data, $val, $ex);
    $$password = $val->{password} if ref $password eq 'SCALAR';
    last if !$num || $data->{num} eq $num;
    $n++;
  }
  close $fh;
  my $spa_ext = $bn->get($cf, 'ConfigShiPainter')->{anime_ext};
  my $sii_ext = $bn->get($cf, 'ConfigShiPaintBBS')->{anime_ext};
  my $src = $data->{anime_src} =~ /\.$spa_ext|$sii_ext$/ ? $data->{anime_src} :
    $data->{object_src} =~ /\.$spa_ext|$sii_ext$/ ? $data->{object_src} : '';
  $bn->error('BAD_REQUEST') unless $src;
  return $src;
}

sub open_anime_size {
  my $pm = $_[0];
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my $gl = $bn->{global};
  my $item = $pm->item;
  my $log = $in->{log} ? $in->{log} : $gl->{count}{log};

  $bn->error('BAD_REQUEST') unless $log;
  my $pass;
  my $src = "$bn->{sys}{DirData}/" . $pm->get_log_anime_src( $log, \$pass );
  my $ex = $gl->{LogExValue};

  if ($in->{width} || $in->{height} || $in->{speed}) {

    $bn->check_password( $in->{password}, $pass )
      or $bn->error('PASSWORD_ERROR');

    $bn->filelock;
    $ex->{file_width} = $in->{width};
    $ex->{file_height} = $in->{height};
    $bn->{sys}{MODE} = 'EDIT_REPLY';
    $bn->po->write_log_value($gl->{LogFile}, $gl->{LogValue}, $gl->{LogExValue});

    map{$in->{$_} = int $in->{$_}}qw/width height speed/;

    $pm->open_anime_size_form($in->{width}, $in->{height}, $in->{speed}, $item->{anime_txt3})
      if $in->{width} < 1 || $in->{height} < 1 ||
         $in->{width} > 655535 || $in->{height} > 655535;

    if ($src !~ /\.swf$/) {
      my $fh = $bn->open($src, '+<');
      $fh or $bn->error('ERR_DATA_NOTOPEN', $src);
      $bn->{temp}{fh}{pch} = $fh;
      binmode $fh;
      seek $fh, 4, 0;
      print $fh pack("v",$in->{speed});
      seek $fh, 6, 0;
      print $fh pack("v",$in->{width});
      seek $fh, 8, 0;
      print $fh pack("v",$in->{height});
      delete $bn->{temp}{fh}{pch};
      close $fh;
    }

    $bn->fileunlock;
    $bn->open_page;
    $bn->EXIT;
  }

  my ($width, $height, $etc);
  $width = $ex->{file_width};
  $height = $ex->{file_height};

  if ($src !~ /\.swf$/) {
    my $fh = $bn->open($src);
    $fh or $bn->error('ERR_DATA_NOTOPEN', $src);
    $bn->{temp}{fh}{pch} = $fh;
    binmode $fh;
    my($pch_head, $pch_speed, $pch_width, $pch_height);
    read $fh, $pch_head, 4; read $fh, $pch_speed, 2;
    read $fh, $pch_width, 2; read $fh, $pch_height, 2;
    delete $bn->{temp}{fh}{pch}; close $fh;

    $bn->error('BAD_REQUEST') if $pch_head !~ /\x1F\x8B\x08\x00/;
    $width = unpack "S", $pch_width;
    $height = unpack "S", $pch_height;
    $etc = unpack "S", $pch_speed;
  }
  $pm->open_anime_size_form($width, $height, $etc, $item->{anime_txt2});
}

sub open_anime_size_form {
  my( $pm, $width, $height, $etc, $txt ) = @_;
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my $sk = $bn->{skin};
  my $ck = $bn->{cookie};
  my $gl = $bn->{global};
  my $item = $pm->item;
  my $form_name = $bn->get($sk, 'FormName');
  my $tag_form_items = $bn->get($sk, 'TagFormItems');
  my $fr = $sk->{form} = {};
  my $contents;

  $bn->reset_javascript;
  $bn->send_http_header->head($item->{anime_txt1});

  $fr->{FORMS} = [[[
    [ { TAG => 'input', type => 'hidden', name => 'fc', value => 'paint_anime_size' } ],
    [ { TAG => 'input', type => 'hidden', name => 'log', value => ($in->{log} ? $in->{log} : $gl->{count}{log}) } ],
    [ { TAG => 'input', type => 'hidden', name => 'num', value => ($in->{num} ? $in->{num} : $gl->{count}{num})} ],
  ]],[
    [
    [ { TAG => 'TD' } ],
    [ $tag_form_items, { string => " $item->{width} " } ],
    [ { TAG => 'input', name => 'width', type => 'text', class => 'input', size => 7, value => $width } ]
    ],[
    [ $tag_form_items, { string => " $item->{height} " } ],
    [ { TAG => 'input', name => 'height', type => 'text', class => 'input', size => 7, value => $height } ]
    ]
  ],[[
    [ { TAG => 'TD', align => 'center', colspan => '*' } ],
    [ $tag_form_items, { string => " $form_name->{password} " } ],
    [ { TAG => 'input', type => 'password', name => 'password', class => 'input', size => 7, value => exists $in->{password} ? $in->{password} : $ck->{password} } ],
    [ { string => ' ' } ],
    [ { TAG => 'input', type => 'submit', name => 'submit', class => 'input', value => $item->{submit} } ]
  ]]];

  $bn->set_init_arg($fr->{FORMS}, $bn->{arg}{AnimeSizeForm});

  $fr->{table} = { TAG => 'TABLE', cellpadding => '2', cellspacing => '2' };
  $fr->{form} = { TAG => 'FORM', action => $bn->get($cf, 'BBSNoteUrl'), name => 'cgiform', method => 'post', target => '_self' };

  $contents .= "<p>$txt</p>";
  $contents .= $bn->create_form($fr->{FORMS}, $fr->{form}, $fr->{table});
  $bn->frame($item->{anime_txt1}, $contents);
  $bn->foot->EXIT;
}

sub open_continue {
  my $pm = $_[0];
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my $sk = $bn->{skin};
  my $ck = $bn->{cookie};
  my $fl = $bn->{flag};
  my $fr = $sk->{form} = {};
  my $item = $pm->item;
  my $item_size = $bn->form_size_init;
  my $data = $bn->{data} = {};

  my $resorce;

  if ($in->{log}) {
    $resorce = 'log';
    my $val = {}; my $ex = {};
    $bn->app->get_log($in->{log},'', $val, $ex);
    $bn->get_src_value($data, $val, $ex);
    $data->{ip} = $val->{ip};
    $data->{width} = $val->{file_width};
    $data->{height} = $val->{file_height};
    $data->{'time'} = $val->{date};
    $data->{applet} = $val->{applet};
    $data->{password} = $val->{password};
    $data->{paint_time} = ($pm->get_paint_time($val->{paint_time}))[4];
    $data->{history} = $ex->{history};

  } elsif($in->{pmid}) {
    $resorce = 'pool';
    my $result = $pm->check_pool(0, $ck->{pmid});
      $bn->error('ERR_POOL_NOTFOUND_ID', $ck->{pmid}) unless $result;
    my($ip, $id, $time, $arg, $width, $height, $size, @images) = split /\t/, $result;
    for my $i(@images){
      for (('Image','Anime','Thumb')) {
        my $head = $bn->get($cf, 'FileHead' . $_);
        if ($i =~ /^$head/) {
          $data->{lc $_ . '_src'} = $i;
          $data->{width} = $width;
          $data->{height} = $height;
          last;
        }
      }
    }
    # APP ARG
    my %app_arg;
    map{ my @a = split /=/; $app_arg{$a[0]}=$a[1] }split /&/,$arg;
    $data->{result} = $result;
    $data->{args} = \%app_arg;
    $data->{ip} = $ip;
    $data->{applet} = $app_arg{app};
    $data->{'time'} = $bn->get_date($time);
    $data->{history} = $app_arg{history};
    $data->{paint_time} = $app_arg{timer} ? int substr $app_arg{timer}, 0, -3 : $time - oct '0x' . $app_arg{'time'};

    $bn->set($cf, 'UsePaintContinuePassword', 0);
  }

  $bn->call('OpenContinueInit');
  $bn->end('ERROR', $bn->text('ERR_CONTINUE','paint')) unless $data->{image_src} || $data->{anime_src};
  $pm->paint_continue($data) if $in->{app} && $in->{src};

  $fl->{ok_image} = $data->{image_src} =~ /\.(jpg|gif)$/ ? 1: 0;
  my $fmt_png = 1 if $data->{image_src} =~ /\.png$/;
  my $spa_ext = $bn->get($cf, 'ConfigShiPainter')->{anime_ext};
  my $sii_ext = $bn->get($cf, 'ConfigShiPaintBBS')->{anime_ext};
  $fl->{ok_anime} = $data->{anime_src} =~ /$spa_ext$/ ? 1: $data->{anime_src} =~ /$sii_ext$/ ? 2 : 0;

  # ImageContinueConvert
  $fl->{ok_image} = 1
    if $fmt_png && $bn->get($cf, 'UsePaintContinueConvert') &&
      ($bn->get($cf, 'UseGD') || $bn->get($cf, 'UsePerlMagick') || $bn->get($cf, 'UseImageMagick'));

  my $tag_out = $bn->get($sk, 'TagTableOut');
  my $tag_in = $bn->get($sk, 'TagTableIn');
  my $tag_font = $bn->get($sk, 'TagTableFont');
  my $form_item = $bn->get($sk, 'FormName');
  my $continue = int $bn->get($cf, 'UsePaintContinue');
  my $replace = $continue == 1 || $continue == 3 ? 1 : 0 ;

  $fr->{form} = { TAG => 'FORM', name => 'form_continue', method => 'post', action => $bn->get($cf, 'BBSNoteUrl') };
  $fr->{table} = { TAG => 'TABLE', cellpadding => '0', cellspacing => '2' };

  $fr->{FORMS} = [[[
    [ $tag_font, { string => $item->{tool} } ]
  ],[
    [ { TAG => 'SELECT', class => 'select', name => 'app', onchange=> 'PM_appChange(0)', string => '<option></option>' } ]
  ]],[[
    [ { TAG => 'TD', colspan => '*' } ],
    [ { TAG => 'SELECT', class => 'select', name => 'src', onchange => 'PM_appChange(1)', string => '<option></option>' } ],
    [ ($resorce eq 'pool' || $continue == 3 ?
      { string => '<input type="hidden" name="continue" value="rep"><input class="button" type="button" value="'."$item->{continue_rep} $item->{continue_only}".'">' }:
      !$replace ? { string => '<input type="hidden" name="continue" value="new"><input class="button" type="button" value="'."$item->{continue_new} $item->{continue_only}".'">' }:
      { TAG => 'SELECT', class => 'button', name => 'continue', string =>
        ($replace ? '<option value="rep">'.$item->{continue_rep}.'</option>' : '') . '<option value="new">'.$item->{continue_new}.'</option>' }
      ) ],
    [ { TAG => 'input', type => 'submit', class => 'submit', value => $item->{submit} } ]
  ]]];

   if ($bn->get($cf, 'UsePaintContinuePassword')) {
     $fr->{pass} = [
      [ [ $tag_font, { string => $form_item->{password} } ] ],
      [ { TAG => 'input', type => 'password', name => 'paint_pass', class => 'input', size => 10, value => $ck->{password} } ]
    ];
    $bn->set_form($fr->{FORMS}, $fr->{pass}, 'insert', 'src');
  }

  my $data_dir = $bn->get($cf, 'DirFileUrl');
  my $img;
  if (!$fl->{ok_image} && $fmt_png) {
    $img = $data->{thumbnail_src} ?
    '<img src="'."$data_dir/$data->{thumbnail_src}".'" alt="'."$data->{width} x $data->{height}".'"><br>'.$item->{png_only} : $item->{png_only};
  } else {
    $img = $fl->{ok_image} ?
    '<img src="'."$data_dir/$data->{image_src}".'" alt="'."$data->{width} x $data->{height}".'">' : $item->{anime_only};
  }

  my $contents;

  $contents .= "<noscript><h3>PLEASE JAVA SCRIPT ON</h3></noscript><div align=\"center\"><p>$img</p>";

  my $val = $in->{log} ? 'log' : 'pmid';
  $bn->{arg}{ContinueForm}{$val} = $in->{$val};
  $bn->{arg}{ContinueForm}{fc} = 'continue';
  $bn->{arg}{ContinueForm}{res} = $in->{res};
  $bn->{arg}{ContinueForm}{palette} = $ck->{pmp};

  $bn->call('OpenContinueBegin');

  $bn->set_init_arg($fr->{FORMS}, $bn->{arg}{ContinueForm});
  $contents .= $bn->create_form($fr->{FORMS}, $fr->{form}, $fr->{table});

  my $flag_admin = $bn->check_authority($bn->get_admin_pass);

  $data->{applet} = 'upload' unless $data->{applet};

  my $pflag = $bn->get($cf, 'ViewPaintTime');
  my @appz = split /\+/, $data->{applet};
  my $last_app = $appz[0];

  if ( $bn->get($cf, 'ViewPaintContinueHistory') ) {
    my @h = split /\+/, $data->{history};
    my %app = (upload => $form_item->{upload});
    for (@{$bn->{module}{Paint}{applets}}) { $app{$_->{key}} = $_->{name} }
    my @ipa = split /\./, $data->{ip};
    my $ip = $#ipa ? join '', map {sprintf("%02X", $_)} split '\.', $data->{ip} : $data->{ip};
    push @h, $data->{'time'}.'%'.$data->{paint_time}.'%'.$ip;
    my ( $i, $pt, @ptime_dif, $hist );

    for ( @h ) {
      my( $date, $ptime, $ip ) = split '%', $_;
      $pt = defined $pt ? $ptime - $pt : $ptime;
      if ($flag_admin) {
        $ip =~ /(..)(..)(..)(..)/;
        $ip = join '.',map{oct '0x'.$_}$1,$2,$3,$4;
      } else { undef $ip }

      my $line = '<tr style="color:'.$tag_out->{bgcolor}.';background-color:'.$tag_in->{bgcolor}.'"><td>';
      $line .= @h + $i - $#h;
      $line .= '</td><td nowrap>'.$app{@appz[$#h - $i]}.'</td><td nowrap>'.$date.'</td>';

#      $line .= '<td align="center" nowrap>'. ($ptime ? join '', $pm->set_paint_time($ptime) : '-') .'</td>' if $pflag;
      $line .= '<td align="center" nowrap>'. ($pt ? ($i&&$pt>0?'+':'').join '', $pm->set_paint_time($pt>0?$pt:$ptime) : '-') .'</td>' if $pflag;

      $line .= '<td>'.$ip.'</td>' if $flag_admin;
      $line .= '</tr>';
      $hist = $line. $hist;
      $pt = $ptime;
      $i++;
    }
    $contents .= '<table><tr><td style="background-color:'.$tag_out->{bgcolor}.'">';
    $contents .= '<table style="font-size:10pt" cellpadding="4" cellspacing="1"><tr style="color:'.$tag_in->{bgcolor}.';background-color:'.$tag_out->{bgcolor}.';font-weight:bold"><td>&nbsp;</td><td nowrap>'.$item->{tool}.'</td><td nowrap>'.$item->{poollist_date}.'</td>';
    $contents .= '<td nowrap>'.$item->{paint_time}.'</td>' if $pflag;
    $contents .= '<td align="center">IP</td>' if $flag_admin;
    $contents .= '</tr>';
    $contents .= $hist;
    $contents .=  '</table></td></tr></table>' if $i;
    $contents .= $item->{admin_ip_view} if $i && $flag_admin;
  }

  $contents .= $bn->back_button;
  $contents .=  '</div>';
  $pm->continue_script($fl->{ok_image}, $fl->{ok_anime}, $last_app);
  $bn->set($sk, 'TagBody', 'onload PM_appInit()');
  $bn->get($sk, 'FormType', 0);

  $bn->send_http_header->head;
  $bn->frame($item->{continue}, $contents)->foot->EXIT;
}
sub login {
  my ( $pm, $add_text ) = @_;
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my $sk = $bn->{skin};
  my $ck = $bn->{cookie};
  my $fr = $sk->{form} = {};
  my $tag_form_items = $bn->get($sk, 'TagFormItems');

  my @text = $bn->info('LOGIN_TEXT');

  unless ($bn->{flag}{COOKIE}) {
    delete $ck->{adminuser};
    delete $ck->{adminpass};
    $bn->write_cookie($ck);
  }

  $bn->send_http_header->head($bn->get($cf, 'BbsTitle') . ' : ' . $text[0]);
  $bn->{flag}{MENUFORM} = 'LOGIN';
  $bn->{arg}{LoginForm} = $in;
  $bn->create_menu_form('login',
    "<h2>$text[0]</h2>$add_text$text[1]<br>", 'LoginForm');
  $bn->foot('NotPageLink')->EXIT;
}
sub check_paint_auth {
  $bn->check_limit_post('Paint') or $_[0]->login();
}

sub paint {
  my( $pm, $rf ) = @_;
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my $ck = $bn->{cookie};
  my $gl = $bn->{global};
  my $item = $pm->item;
  my $data = $bn->{data} = {};
  $bn->{rf} = $rf;
  $pm->{dyn_cfg} = {};
  $bn->{flag}{PaintWrite} = 1;

  my $key = $rf->{key};
  my $applet = $rf->{applet};

  $bn->call('PaintBegin');
  $pm->check_paint_auth;

  if($in->{mode} eq 'regist'){ $pm->post_regist }
  elsif($in->{mode} eq 'new'){ $ck->{pmf} = 0 }
  elsif($in->{mode} eq 'delete'){ $pm->delete_pool }
  elsif($in->{mode} eq 'continue'){ $pm->open_continue }

  $pm->check_regist if $ck->{pmf};

  # user : cookie auto login
  if ($bn->get($cf, 'UseNameCap')) {
    $bn->usr->cap(defined $in->{name} ? $in->{name} : $ck->{name},
       defined $in->{password} ? $in->{password} : $ck->{password}, {})}

  # limit post range
  my %c;
  for( split ';', $bn->get( $cf, 'LimitPostRange' ) ) {
    my @a = split ':', $_, 2; next if $a[0] ne 'new';
    for ( split ',', $a[1] ) { my @v = split '=', $_, 2; $c{$v[0]} = $v[1] if $v[1] } }
  if ( $c{log} && $c{day} || $c{hour} ) {
    $bn->app->check_post_range( 'PAINT' )
     if !( $in->{fc} eq 'continue' && $in->{continue} eq 'rep' )
  }

  $ck->{pmid} = $pm->set_pmid unless $ck->{pmid};
  @{$ck}{'pmf','pmapp','pmp','pma','pmcw','pmch'} =
  (1,$key,@{$in}{'palette','anime','width','height'});
  for (qw/name password/) { $ck->{$_} = $in->{$_} if defined $in->{$_} }

  $pm->paint_init_size( $rf );

  $bn->{arg}{applet} = {
    pmid     => $ck->{pmid},
    agent    => $gl->{UserAgent},
    app      => $key,
    name     => $in->{name} ? $in->{name} : $ck->{name},
    password => $in->{password} ? $in->{password} : $ck->{password},
    'time'   => sprintf("%X",time + $bn->get($cf, 'TimeDiffSec') ),
  };

  $bn->call('PaintAppletArg');
  $pm->paint_init( $rf, $data );

  $bn->send_http_header->head;
  my $appelt_js = $bn->get( $cf, 'AppletJsUrl' ) ? $bn->get( $cf, 'AppletJsUrl' ) : undef;
  if ( !$appelt_js ) {
     my $spv_cfg = $bn->get($cf, 'ConfigShiPCHViewer');
     $appelt_js = $spv_cfg->{resource}. ( $spv_cfg->{resource} !~ m{/$} ? '/' : '' ). 'applet.js';
  }

  $bn->print( "\n", $item->{'NOT_ENABLE_JAVASCRIPT'}, "\n",
   '<script type="text/javascript" src="', $appelt_js, '"></script>', "\n",
   '<center>', $bn->back_button, '</center>' );
  $bn->foot;
}

sub paint_init_size {
  my( $pm, $rf ) = @_;
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my $data = $bn->{data};
  my $applet = $rf->{applet};
  my( $min_width, $min_height ) = ( 400, 400 );

  if ( $bn->get( $cf, 'CanvasMode' ) eq 'fix' ) {
    $pm->{canvas_width} = $bn->get( $cf, 'DefaultCanvasWidth' );
    $pm->{canvas_height} = $bn->get( $cf, 'DefaultCanvasHeight' );
  } else {
    $pm->{canvas_width} = exists $in->{width} && int $in->{width} ? int $in->{width} : $bn->get( $cf, 'DefaultCanvasWidth' );
    $pm->{canvas_height} = exists $in->{height} && int $in->{height} ? int $in->{height} : $bn->get( $cf, 'DefaultCanvasHeight' );
  }
  $pm->{canvas_width} = $bn->get( $cf, 'LimitImageWidth' ) if $pm->{canvas_width} > $bn->get( $cf, 'LimitImageWidth' );
  $pm->{canvas_height} = $bn->get( $cf, 'LimitImageHeight' ) if $pm->{canvas_height} > $bn->get( $cf, 'LimitImageHeight' );

  if ( $applet eq 'spapro' ) {
    $pm->{applet_width} = int( ( $pm->{canvas_width} * 4 ) / 3 + 200 );
    $pm->{applet_height} = $pm->{canvas_height} + 250;
    $min_width = 600;
    $min_height = 400;
  } elsif( $applet eq 'spanormal' ) {
    $pm->{applet_width} = $pm->{canvas_width} + 220;
    $pm->{applet_height} = $pm->{canvas_height} + 150;
    $min_height = 500;
  } elsif( $applet eq 'sii' ) {
    $pm->{applet_width} = $pm->{canvas_width} + 150;
    $pm->{applet_height} = $pm->{canvas_height} + 150;
  } elsif( $applet eq 'pic' ) {
    $pm->{applet_width} = $pm->{canvas_width} + 250;
    $pm->{applet_height} = $pm->{canvas_height} + 150;
  } elsif( $applet eq 'pai' ) {
    $pm->{applet_width} = int(($pm->{canvas_width} * 5) / 3 + 200);
    $pm->{applet_height}= $pm->{canvas_height} + 100;
    $pm->{applet_width} = 600 if $pm->{applet_width} < 600;
  }

  if ( $bn->get( $cf, 'UseAppletFit' ) ) {
    my $w = int $in->{applet_width};
    my $h = int $in->{applet_height};
    $data->{applet_width} = $w if $w;
    $data->{applet_height} = $h if $h;
    $pm->{applet_width} = $w if $w;
    $pm->{applet_height} = $h if $h;
  }

  $pm->{applet_width} = $min_width if $pm->{applet_width} < $min_width;
  $pm->{applet_height} = $min_height if $pm->{applet_height} < $min_height;

}

sub paint_init {
  my( $pm, $rf, $data ) = @_;
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my $sk = $bn->{skin};
  my $applet = $rf->{applet};
  my $item = $pm->item;
  $bn->{flag}{write_cookie} = 1;

  $bn->set_app_cfg('AppletSetting:' . $rf->{applet}, $cf, $rf);

  if ($applet eq 'spapro' || $applet eq 'spanormal') {
    $bn->set_app_cfg('AppletColorShiPainter', $sk, $rf);
    $bn->set_app_cfg('ConfigShiApplet', $cf, $rf);
  } elsif($applet eq 'sii') {
    $bn->set_app_cfg('AppletColorShiPaintBBS', $sk, $rf);
    $bn->set_app_cfg('ConfigShiApplet', $cf, $rf);
  } elsif($applet eq 'pic') {
    $bn->set_app_cfg('AppletColorPictureBBS', $sk, $rf);
  } elsif($applet eq 'pai') {
    $bn->set_app_cfg('AppletColorBBSPainter', $sk, $rf);
  }

  $bn->set_app_cfg('ConfigApplet', $cf, $rf);

  my $app_txt = ucfirst $1 if $applet =~ /(\w\w\w)/;
  my $set_txt = sub {
    my $a = $bn->get($cf, 'Txt' . $app_txt . $_[0]);
    my $b = $bn->get($cf, 'TxtPaint' . $_[0]);
    $bn->define($cf, 'Txt' . $_[1], undef, '@');
    for (@$a,@$b) { $bn->set($cf, 'Txt' . $_[1], $_) }
  };

  &$set_txt('Head', 'Head');
  &$set_txt('Top', 'BbsTop');
  &$set_txt('Bottom', 'MsgBottom');

  $bn->tag_init($rf);
  $pm->paint_init_js( $rf );

  $pm;
}

sub paint_init_js {
  my( $pm, $rf ) = @_;
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my $gl = $bn->{global};
  my $app = $rf->{applet};
  my $item = $pm->item;
  my $arg = $bn->{arg};

  # Mac and MacOSX : iCab, Safari, Mozilla 1.0.x, NN 7.0.x, Firefox 1.5 over, exception don't use dynamic palette
  $rf->{dynamic_palette} = 0
    if $gl->{UserOS} =~ /Mac/ && $gl->{UserBrowser} !~ /iCab/ &&
      !($gl->{UserBrowserVer} =~ /Safari ([\d\.]+)/ && $1 >= 1.2) &&
      !($gl->{UserBrowserVer} =~ /Firefox ([\d\.]+)/ && $1 >= 1.5) &&
       $gl->{UserBrowserVer} !~ /NN 7\.0|Mozilla 1\.0/;

  $bn->call('PaintAppletRun');

  my $js =
    $app eq 'spapro' ? $pm->paint_spa( $rf ):
    $app eq 'spanormal' ? $pm->paint_spa( $rf ):
    $app eq 'sii' ? $pm->paint_sii( $rf ):
    $app eq 'pic' ? $pm->paint_pic( $rf ):
    $app eq 'pai' ? $pm->paint_pai( $rf ): undef;

  my %txt = ( bbsnote_url => $bn->get( $cf, 'BBSNoteUrl' ) );
  if ( $bn->get( $cf, 'UseAppletFit' ) ) {
    for (keys %{$bn->{in}}) { $arg->{AppletFitForm}{$_} = $bn->{in}{$_}}
    $arg->{AppletFitForm}{applet_width} = $pm->{applet_width};
    $arg->{AppletFitForm}{applet_height} = $pm->{applet_height};
    delete $arg->{AppletFitForm}{submit};
    $txt{appfit_arg} = $bn->set_text_arg($arg->{AppletFitForm});
    $txt{appfit_alert} = $item->{appfit_alert};
    $txt{appfit_button} = $item->{appfit_button};
    $txt{appfit_confirm} = $item->{appfit_confirm};
  }
  if ($rf->{animation} eq 'true' || ($rf->{animation} eq 'user' && $in->{anime}) )
   { $txt{record_anime} = $item->{record_anime} }
  $txt{noapplet} = $item->{JAVA_VM_RESORCE};
  for ( keys %txt ) { $txt{$_} =~ s/\'/\\'/g;
    $js .= "app.$_='".$txt{$_}."';\n" }

  $pm->paint_dyn_palette( $rf, \$js );
  $bn->set_call( 'SkinHeadFormat', sub{
    my $data = $bn->{data};
    $data->{javascript} .= '//'. ('-' x 20). ' Applet Init '. ('-' x 20). "\n". $js;
  });

}

sub paint_dyn_palette {
  my( $pm, $rf, $js ) = @_;
  my $cf = $bn->{cfg};
  my $sk = $bn->{skin};
  my $gl = $bn->{global};

  return unless $rf->{dynamic_palette};

  my $item = $pm->item;
  $bn->set_app_cfg( 'AppletColorDynPalette', $sk, $pm->{dyn_cfg} );

  my( @p_name, $i ,$n );
  my $palettes = $bn->get_palette( 'all', \@p_name );
  $$js .= 'var Palettes = new Array();'. "\n".
  "Palettes[0]\t= '#000000\\n#FFFFFF\\n#B47575\\n#888888\\n#FA9696\\n#C096C0\\n#FFB6FF\\n#8080FF\\n#25C7C9\\n#E7E58D\\n#E7962D\\n#99CB7B\\n#FCECE2\\n#F9DDCF';\n";

  $$js .= join "\n",map{ $n++; @_ = split /,/;
    "Palettes[$n]\t= '".(join '\n',map{$_ = '000000'if!$_;"\#$_"}
     @_[0,6,1,7,2,8,3,9,4,10,5,11..$rf->{palette} - 1])."';" }@$palettes;

  $$js .= "\n"."var dynplt = new Array();\n";
  $$js .= "dynplt.pcolor = 1;\n" if $rf->{dynamic_pcolor};
  $$js .= "dynplt.max_palette = $rf->{palette};\n";

  if ( ( $gl->{UserBrowserVer} =~ /NN (\d)/ && $1 > 4 ) ||
      $gl->{UserBrowser} =~ /Mozilla/ ) {
    $$js .= "dynplt.grad_return = 1;\n";
    $$js .= "dynplt.grad_offset1 = 0;\n";
    $$js .= "dynplt.grad_offset2 = -1;\n";
    $$js .= "dynplt.grad_check = 0;\n";
  } else {
    $$js .= "dynplt.grad_offset1 = -1;\n";
    $$js .= "dynplt.grad_offset2 = -2;\n";
    $$js .= "dynplt.grad_check = 1;\n";
  }

  # dynpalette text
  for (qw/st ed submit palette palette_name palette_num matrix gradation dyn_gradation_st dyn_gradation_ed
  dyn_palette_txt1 dyn_palette_txt2 dyn_palette_txt3 dyn_palette_txt4
  dyn_palette_txt5 dyn_palette_txt6 dyn_palette_txt7 dyn_palette_txt8 dyn_palette_txt9/) {
    my $s = $item->{$_}; $s =~ s/\'/\\'/g;
    $$js .= "dynplt.$_ = '$s';\n" }
  { my @str; for ( 1..13 ) {
    my $s = $item->{'dyn_palette_str'.$_}; $s =~ s/\'/\\'/g;
    push @str, "'$s'" }
    $$js .= 'dynplt.str = new Array('. ( join ',', @str ). ");\n" }

  # dynpalette colors
  my $dyn_cfg = $pm->{dyn_cfg};
  my $limit_palette_list = $bn->get($cf, 'ViewLimitPaletteList');
  my $palette_names = $bn->get($cf, 'PaletteNames');
  @$palette_names[0] = "\t" . $item->{dyn_palette_str1} . $item->{palette};
  my $palette_list = join ',', map{ my $p = (split /\t/)[1];
    $p =~ s/\'/\\'/g; "'$p'" } @$palette_names;
  $$js .= "dynplt.palette_list = new Array($palette_list);\n";

  $dyn_cfg->{palette_select_size} = $#$palette_names + 1 > $limit_palette_list ? $limit_palette_list : $#$palette_names + 1;
  $dyn_cfg->{gradation_text_size} = $gl->{UserBrowser} =~ /NN/ ? 5 : 9;

  for (qw/palette_font palette_border gradation_font gradation_border/)
   { $dyn_cfg->{$_} = $rf->{tagbodytext} unless $dyn_cfg->{$_} }
  for (qw/palette_back gradation_back/)
   { $dyn_cfg->{$_} = $rf->{tagbodybgcolor} unless $dyn_cfg->{$_} }
  for ( sort keys %$dyn_cfg )
   { $$js .= "dynplt.$_ = '$dyn_cfg->{$_}';\n" }
}

sub paint_spa {
  my( $pm, $c ) = @_;
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my $sk = $bn->{skin};
  my $ck = $bn->{cookie};
  my $arg = $bn->{arg};
  my $bbsnoteurl = $bn->get($cf, 'BBSNoteUrl');
  my $item = $pm->item;
  my $tool = $c->{applet} eq 'spapro' ? 'pro' : 'normal';

  my @param = (
    'image_size',
    'image_jpeg',
    'image_bk',
    'image_bkcolor',
    'undo',
    'undo_in_mg',

    'color_bk',
    'color_bk2',

    'color_text',
    'color_icon',
    'color_frame',

    'color_iconselect',
    'color_bar',
    'color_bar_hl', 		# 1.102
    'color_bar_shadow', 	# 1.102
    'color_bar_select',

    'tool_color_bk',
    'tool_color_button',
    'tool_color_button_hl', 	# 1.102
    'tool_color_button_dk', 	# 1.102

    'tool_color_button2',
    'tool_color_text',
    'tool_color_bar',
    'tool_color_frame',
    'tool_advance',

    'pro_menu_color_text',
    'pro_menu_color_off',
    'pro_menu_color_off_hl',
    'pro_menu_color_off_dk',
    'pro_menu_color_on',
    'pro_menu_color_on_hl',
    'pro_menu_color_on_dk',

    'bar_color_bk',
    'bar_color_frame',
    'bar_color_off',
    'bar_color_off_hl',
    'bar_color_off_dk',
    'bar_color_on',
    'bar_color_on_hl',
    'bar_color_on_dk',
    'bar_color_text',

    'window_3',
    'window_3_color',
    'window_3_T',
    'window_color_text',
    'window_color_bk',

    'window_color_frame',
    'window_color_bar',
    'window_color_bar_hl',
    'window_color_bar_text',

    'dlg_color_bk',
    'dlg_color_text',

    'l_m_color',
    'l_m_color_text',

    'compress_level',
    'thumbnail_compress_level',

    'send_advance',
    'send_header_timer',
    'send_header_count',

    'security_click',
    'security_timer',
    'security_url',
    'jp',
  );

  # Anime Param
  my $anime_param = ($c->{animation} eq 'true' || ($c->{animation} eq 'user' && $in->{anime}))?1:0;

  $arg->{Param_Spa}{thumbnail_type} = 'animation' if $anime_param;

  # Thumbnail Param
  if ($bn->get($cf, 'UseThumbnail')) {
    my $cw = $pm->{canvas_width};
    my $ch = $pm->{canvas_height};
    my $w = $bn->get($cf, 'ThumbnailWidth');
    my $h = $bn->get($cf, 'ThumbnailHeight');
    $w = int ($cw * $1 / 100) if $w =~ /(\d+)\%/;
    $h = int ($ch * $1 / 100) if $h =~ /(\d+)\%/;
    my $x = ($w / $cw) < ($h / $ch) ? $w / $cw : $h / $ch;
    $w = int($x * $cw + 0.5); $h = int($x * $ch + 0.5);
    $arg->{Param_Spa}{thumbnail_width} = $w;
    $arg->{Param_Spa}{thumbnail_height} = $h;
    $arg->{Param_Spa}{'thumbnail_type' . ($anime_param ? '2' : '')} = $c->{image_jpeg} ? 'jpg' : 'png';
  }
  my $sendheader = $bn->set_text_arg($arg->{paint_spa}, $arg->{applet});
  $bn->escape(\$sendheader);
  $sendheader = $bn->get($cf, 'UseCrypt') ? $bn->encrypt($sendheader) : $sendheader;
  $c->{resource} .= '/' if $c->{resource} ne '' && $c->{resource} !~ m#[/\\]$#;

  $c->{archive} = "$bbsnoteurl?fc=stream&src=$c->{archive}" if $c->{cgi_stream};
  $c->{resource} = "$bbsnoteurl?fc=stream&src=$c->{resource}" if $c->{cgi_stream} && $c->{resource};
  $c->{jp} = $c->{jp} ? 'true' : 'false' ;
  $c->{image_jpeg} = $c->{image_jpeg} ? 'true' : 'false' ;
  $c->{tool_advance} = $c->{tool_advance} ? 'true' : 'false' ;
  $c->{send_advance} = $c->{send_advance} ? 'true' : 'false' ;
  $c->{send_header_timer} = $c->{send_header_timer} ? 'true' : 'false' ;
  $c->{send_header_count} = $c->{send_header_count} ? 'true' : 'false' ;
  $c->{security_post} = $c->{applet_security_url} ne '' ? 'false' : '' ;

  my $archive = $c->{resource} ? "$c->{archive},$c->{resource}$c->{$tool}" : $c->{archive};
  my $arg_exit = $bn->set_text_arg($arg->{paint_spa_exit});

  my %PARAM = (
    scriptable    => 'true',
    mayscript     => 'true',
    send_language => $bn->{sys}{Charset} =~ /shift.jis/ ? 'sjis' : $bn->{sys}{Charset},
    send_header   => $sendheader,
    poo           => 'false',
    image_width   => $pm->{canvas_width},
    image_height  => $pm->{canvas_height},
    url_save      => $bbsnoteurl.'?fc=paint_captor',
    url_exit      => $bbsnoteurl.'?fc=paint_regist&pmid=' . $ck->{pmid} . ($arg_exit?'&'.$arg_exit:''),

    dir_resource  => $c->{resource},
    'tt.zip'      => $c->{resource} . $c->{texture},
    'res.zip'     => $c->{resource} . 'res_' . $c->{$tool},
    layer_count   => $c->{layer_count},
    quality       => $c->{quality},
    dynamic_palette => $c->{dynamic_palette},
    tools         => $tool,
    %{$arg->{Param_Spa}},
    %{$arg->{Param_All}},
  );

  @PARAM{@param} = @$c{@param};

  my @pcfg = qw/
    pro_menu_color_on:tagbodybgcolor
    pro_menu_color_on_hl:tagbodybgcolor
    pro_menu_color_on_dk:tagbodybgcolor
  / if $tool eq 'pro';
  for(qw/
    color_bk:tagbodybgcolor
    color_bk2:tagbodybgcolor
    color_text:tagbodytext
    color_bar:tagbodytext
    color_bar_hl:tagbodybgcolor
    color_bar_shadow:tagbodybgcolor
    color_frame:tagbodytext
    color_icon:tagbodybgcolor
    color_iconselect:tagformastmarkcolor

    bar_color_text:tagbodytext
    bar_color_bk:tagbodybgcolor
    bar_color_frame:tagbodybgcolor
    bar_color_off:tagbodybgcolor
    bar_color_off_hl:tagbodybgcolor
    bar_color_off_dk:tagbodytext
    bar_color_on:tagbodybgcolor
    bar_color_on_hl:tagformastmarkcolor
    bar_color_on_dk:tagformastmarkcolor

    l_m_color:tagbodytext
    l_m_color_text:tagbodybgcolor

    window_color_frame:tagbodytext
    window_color_bar:tagbodytext
    window_color_bar_hl:tagbodytext
    window_color_bar_bk:tagbodytext
    window_color_bar_text:tagbodybgcolor

    tool_color_button:tagbodybgcolor
    tool_color_button2:tagbodybgcolor
    tool_color_text:tagbodytext
    tool_color_bar:tagbodybgcolor
    tool_color_bk:tagbodybgcolor
    tool_color_frame:tagbodytext

  /,@pcfg) {
     my @a = split /:/;
     $PARAM{$a[0]} = $c->{$a[1]} unless defined $PARAM{$a[0]};
  }

  ## continue : not security
  if ( exists $arg->{applet}{continue} ) {
    for ( qw/click timer url/ ) { delete $PARAM{'security_'.$_} };
  }

  my %js = (
    'app' => 'spa',
    'name' => 'paintbbs',
    'code' => $c->{code},
    'archive' => $archive,
    'width' => $pm->{applet_width},
    'height' => $pm->{applet_height},
    'mayscript' => 'true',
  );

  my( @palettes, @p_name, $i );
  $bn->get_palette( $in->{palette}, \@p_name, \@palettes );

  for ( my $n = 1; $n < 12; $n++ ){
    $i = $n % 2 ? int($n / 2) : $n / 2 + 5;
    $i = $n - 1 if($n > 12);
    $js{'color_'.$n} = '#'. $palettes[$i] if $palettes[$i];
  }
  $pm->paint_param_js_array( \%js, \%PARAM );
}

sub paint_sii {
  my( $pm, $c ) = @_;
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my $sk = $bn->{skin};
  my $ck = $bn->{cookie};
  my $arg = $bn->{arg};
  my $bbsnoteurl = $bn->get($cf, 'BBSNoteUrl');
  my $item = $pm->item;

  my @param = qw/image_size image_jpeg image_bk image_bkcolor undo undo_in_mg
    color_text color_bk color_bk2 color_icon color_iconselect color_bar  color_bar_hl color_frame color_bar_frame_hl
    tool_color_button tool_color_button2 tool_color_text tool_color_bar tool_color_frame tool_advance
    compress_level thumbnail_compress_level
    send_advance send_header_timer send_header_count
    security_click security_timer security_url jp/;

  # Anime Param
  my $anime_param = ($c->{animation} eq 'true' || ($c->{animation} eq 'user' && $in->{anime})) ? 1 : 0;

  if ($anime_param) {
    $arg->{Param_Sii}{thumbnail_type} = 'animation';
  }

  # Thumbnail Param
  if ($bn->get($cf, 'UseThumbnail')) {
    my $cw = $pm->{canvas_width};
    my $ch = $pm->{canvas_height};
    my $w = $bn->get($cf, 'ThumbnailWidth');
    my $h = $bn->get($cf, 'ThumbnailHeight');
    $w = int ($cw * $1 / 100) if $w =~ /(\d+)\%/;
    $h = int ($ch * $1 / 100) if $h =~ /(\d+)\%/;
    my $x = ($w / $cw) < ($h / $ch) ? $w / $cw : $h / $ch;
    $w = int($x * $cw + 0.5); $h = int($x * $ch + 0.5);
    $arg->{Param_Sii}{thumbnail_width} = $w;
    $arg->{Param_Sii}{thumbnail_height} = $h;
    $arg->{Param_Sii}{'thumbnail_type' . ($anime_param ? '2' : '')} = $c->{image_jpeg} ? 'jpg' : 'png';
  }

  my $sendheader = $bn->set_text_arg($arg->{paint_sii}, $arg->{applet});
  $bn->escape(\$sendheader);
  $sendheader = $bn->get($cf, 'UseCrypt') ? $bn->encrypt($sendheader) : $sendheader;
  my $arg_exit = $bn->set_text_arg($arg->{paint_sii_exit});
  $c->{jp} = $c->{jp} ? 'true' : 'false' ;
  $c->{image_jpeg} = $c->{image_jpeg} ? 'true' : 'false' ;
  $c->{tool_advance} = $c->{tool_advance} ? 'true' : 'false' ;
  $c->{send_advance} = $c->{send_advance} ? 'true' : 'false' ;
  $c->{send_header_timer} = $c->{send_header_timer} ? 'true' : 'false' ;
  $c->{send_header_count} = $c->{send_header_count} ? 'true' : 'false' ;
  $c->{security_post} = $c->{applet_security_url} ne '' ? 'false' : '' ;

  my %PARAM = (
    image_width   => $pm->{canvas_width},
    image_height  => $pm->{canvas_height},
    poo           => 'false',
    scriptable    => 'true',
    mayscript     => 'true',
    send_language => $bn->{sys}{Charset} =~ /shift.jis/ ? 'sjis' : $bn->{sys}{Charset},
    send_header   => $sendheader,
    url_save      => $bbsnoteurl . '?fc=paint_captor',
    url_exit      => $bbsnoteurl . '?fc=paint_regist&pmid=' . $ck->{pmid} . ( $arg_exit ? '&' . $arg_exit : ''),
    dynamic_palette => $c->{dynamic_palette},

    %{$arg->{Param_Sii}},
    %{$arg->{Param_All}},
  );

  @PARAM{@param} = @$c{@param};

  for(qw/
    color_bk:tagbodybgcolor
    color_bk2:tagbodybgcolor
    color_text:tagbodybgcolor
    color_icon:tagbodytext
    color_iconselect:tagformastmarkcolor
    color_bar:tagbodytext
    color_frame:tagbodytext
    tool_color_button:tagtableoutbgcolor
    tool_color_button2:tagtableoutbgcolor
    tool_color_bar:tagtableoutbgcolor
    tool_color_text:tagtableinbgcolor
  /) {
     my @a = split /:/;
     $PARAM{$a[0]} = $c->{$a[1]} unless defined $PARAM{$a[0]};
  }

  ## continue : not security
  if ( exists $arg->{applet}{continue} ) {
    for ( qw/click timer url/ ) { delete $PARAM{'security_'.$_} };
  }

  $c->{archive} = "$bbsnoteurl?fc=stream&src=$c->{archive}" if $c->{cgi_stream};

  my %js = ( 'app' => 'sii', 'name' => 'paintbbs', 'mayscript' => 'true',
    'code' => $c->{code}, 'archive' => $c->{archive},
    'width' => $pm->{applet_width}, 'height' => $pm->{applet_height} );

  my( @palettes, @p_name, $i );
  $bn->get_palette( $in->{palette}, \@p_name, \@palettes );

  for ( my $n = 1; $n < 15; $n++ ){
    $i = $n % 2 ? int($n / 2) : $n / 2 + 5;
    $i = $n - 1 if($n > 12);
    $js{'color_'.$n} = '#'. $palettes[$i] if $palettes[$i];
  }
  $pm->paint_param_js_array( \%js, \%PARAM );
}

sub paint_pic {
  my( $pm, $c ) = @_;
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my $sk = $bn->{skin};
  my $ck = $bn->{cookie};
  my $arg = $bn->{arg};
  my $item = $pm->item;
  my $bbsnoteurl = $bn->get($cf, 'BBSNoteUrl');
  my @param = qw/_WINDOWCOLOR _CAPTIONCOLOR _BGCOLOR/;

  my $sendheader = $bn->set_text_arg($arg->{paint_pic}, $arg->{applet});
  $bn->escape(\$sendheader);
  $sendheader = $bn->get($cf, 'UseCrypt') ? $bn->encrypt($sendheader) : $sendheader;
  my $arg_exit = $bn->set_text_arg($arg->{paint_pic_exit});

  my %PARAM = (
    '_PICWIDTH'    => $pm->{canvas_width},
    '_PICHEIGHT'   => $pm->{canvas_height},
    '_DEFAULTJPEG' => 'true',
    '_PASSWORD'    => $sendheader,
    '_MOVETARGET'  => '_self',
    '_MOVEURL'     => $bbsnoteurl . '?fc=paint_regist&pmid=' . $ck->{pmid} . ($arg_exit ? '&' . $arg_exit : ''),
    '_POSTURL'     => $bbsnoteurl . '?fc=paint_captor',
    '_READURL'     => $bbsnoteurl . '?fc=paint_captor',

    %{$arg->{Param_Pic}},
    %{$arg->{Param_All}},
  );

  @PARAM{@param} = @$c{@param};
  for(qw/
    _BGCOLOR:tagbodybgcolor
    _WINDOWCOLOR:tagbodytext
    _CAPTIONCOLOR:tagtableoutbgcolor
  /) {
     my @a = split /:/;
     $PARAM{$a[0]} = $c->{$a[1]} unless defined $PARAM{$a[0]};
  }


  $c->{archive} = "$bbsnoteurl?fc=stream&src=$c->{archive}" if $c->{cgi_stream};
  $c->{gradation_begin} =~ s/^\#//;
  $c->{gradation_end} =~ s/^\#//;

  my %js = ( 'app' => 'pic', 'name' => 'picturebbs',
    'code' => $c->{code}, 'archive' => $c->{archive},
    'width' => $pm->{applet_width}, 'height' => $pm->{applet_height} );

  my( @palettes, @p_name, $i );
  $bn->get_palette( $in->{palette}, \@p_name, \@palettes );
  if ( @palettes )
   { $js{'_PALETTE'} = join ' ',( @palettes[6,0,7,1,8,2,9,3,10,4,11,5,13,12],@$c{'gradation_begin','gradation_end'} ) }

  $pm->paint_param_js_array( \%js, \%PARAM );

}

sub paint_pai {
  my( $pm, $c ) = @_;
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my $sk = $bn->{skin};
  my $ck = $bn->{cookie};
  my $arg = $bn->{arg};
  my $bbsnoteurl = $bn->get($cf, 'BBSNoteUrl');

  my $item = $pm->item;
  my $form_item = $bn->{item} = $bn->get($sk, 'FormName');

  $arg->{paint_pai}{fc} = 'write';
  my %h = $bn->set_global_arg(2,$arg->{paint_pai}, $arg->{applet});
  my($i,%param);
  for (keys %h) {
    $i++;
    $bn->escape(\$h{$_});
    $param{'param' . $i} = "$_=$h{$_}" if $h{$_} ne '';
  }

  if ($bn->get($cf, 'UseThumbnail')) {
    my $cw = $pm->{canvas_width};
    my $ch = $pm->{canvas_height};
    my $w = $bn->get($cf, 'ThumbnailWidth');
    my $h = $bn->get($cf, 'ThumbnailHeight');
    $w = int ($cw * $1 / 100) if $w =~ /(\d+)\%/;
    $h = int ($ch * $1 / 100) if $h =~ /(\d+)\%/;
    my $x = ($w / $cw) < ($h / $ch) ? $w / $cw : $h / $ch;
    $w = int($x * $cw + 0.5); $h = int($x * $ch + 0.5);
    $param{'image.prev'} = 'bbspainter_thumb';
    $param{'size.prev'} = "$w,$h";
  }

  my $args = $bn->set_text_arg($sk->{menu}{reload}{arg});

  my %PARAM = (
    'comment'    => "message=$form_item->{message}",
    'form1'      => "name=$form_item->{name}:=" . ($bn->get($cf, 'NeedName') ? '!' : '') . "=$ck->{name}",
    'form2'      => "mail=$form_item->{mail}:=" . ($bn->get($cf, 'NeedMail') ? '!' : '') . "=$ck->{mail}",
    'form3'      => "url=$form_item->{url}:=" . ($bn->get($cf, 'NeedUrl') ? '!' : '') . "=$ck->{url}",
    'form4'      => "title=$form_item->{title}:=" . ($bn->get($cf, 'NeedTitle') ? '!' : '') . "=",
    'form5'      => "password=$form_item->{password}:=" . ($bn->get($cf, 'NeedPassword') ? '!' : '') . "?=$ck->{password}",

    'enctype'    => 'multipart/form-data',
    'image'      => 'file',
    'size'       => "$pm->{canvas_width},$pm->{canvas_height}",
    'lineterm'   => '\n',
    'action'     => $bbsnoteurl,
    'return.URL' => $bbsnoteurl . ($args ? '?' . $args : ''),
    %param,
    %{$arg->{Param_Pic}},
    %{$arg->{Param_All}},
  );

  $c->{archive} = "$bbsnoteurl?fc=stream&src=$c->{archive}" if $c->{cgi_stream};

  my %js = ( 'app' => 'pai', 'name' => 'bbspainter',
    'code' => $c->{code}, 'archive' => $c->{archive},
    'width' => $pm->{applet_width}, 'height' => $pm->{applet_height} );
  $pm->paint_param_js_array( \%js, \%PARAM );

}

sub paint_param_js_array(){
  my( $pm, $js, $param ) = @_;
  for ( sort keys %$param ) {  $js->{$_} = $param->{$_} if $param->{$_} ne '' }
  my $j = join( "\n", map{ ( $_ =~ /\./ ? "app['$_']" : "app.$_" ). '='. ( $js->{$_} =~ /\D/ ? "'$js->{$_}'" : $js->{$_}). ';' } sort keys %$js);
  $j = 'var app = new Array();'. "\n". $j. "\n";
}

sub paint_continue {
  my( $pm, $data ) = @_;
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my $gl = $bn->{global};
  my $arg = $bn->{arg};
  my $cfg_pass = $bn->get($cf, 'UsePaintContinuePassword');
  my $cfg_rep = int $bn->get($cf, 'UsePaintContinue');
  $cfg_rep = $cfg_rep == 1 || $cfg_rep == 3 ? 1 : 0 ;

  if ($cfg_pass == 1 || ($cfg_pass == 2 && $in->{continue} eq 'rep') ) {
    $in->{password} = $in->{paint_pass} unless exists $in->{password};
    $bn->check_password( $in->{paint_pass}, $data->{password}, $bn->get( $cf, 'PaintPasswordAuth' ) )
      or $bn->error('PASSWORD_ERROR');
  }

  my $data_dir = $bn->get($cf, 'DirFileUrl');
  my $bbsnoteurl = $bn->get($cf, 'BBSNoteUrl');
  my $src = $data->{$in->{src} .'_src'};
  my $spa_ext = $bn->get($cf, 'ConfigShiPainter')->{anime_ext};
  my $sii_ext = $bn->get($cf, 'ConfigShiPaintBBS')->{anime_ext};

  if ($src =~ /\.$spa_ext$/) {
    my $path = "$bn->{sys}{DirData}/$src";
    my $fh = $bn->open($path);
    $fh or $bn->error('ERR_SYS_NOTOPEN', $path);
    $bn->{temp}{fh}{src} = $fh;
    binmode $fh;
    my %h;
    my $cr = $/; $/ = "\x0D\x0A";
    while (<$fh>) {
      chomp;
      last unless $_;
      my($n, $v) = split /=/;
      $h{$n} = $v;
    }
    $/ = $cr;
    delete $bn->{temp}{fh}{src};
    close $fh;

    $data->{width} = $h{image_width} if $h{image_width};
    $data->{height} = $h{image_height} if $h{image_height};
    $arg->{Param_Spa}{quality} = $h{quality} if $h{quality};
    $arg->{Param_Spa}{layer_count} = $h{layer_count} if $h{layer_count};
  } elsif ($src =~ /\.$sii_ext$/) {
    my $path = "$bn->{sys}{DirData}/$src";
    my $fh = $bn->open($path);
    $fh or $bn->error('ERR_SYS_NOTOPEN', $path);
    $bn->{temp}{fh}{src} = $fh;
    my($w, $h);
    binmode $fh;
    seek $fh, 6, 0; read $fh, $w, 2; read $fh, $h, 2;
    delete $bn->{temp}{fh}{src};
    close $fh;

    $w = unpack "v", $w;
    $h = unpack "v", $h;
    $data->{width} = $w if $w;
    $data->{height} = $h if $h;

  } elsif ($src =~ /\.png$/ && $bn->get($cf, 'UsePaintContinueConvert')) {
    $src = $pm->continue_convert($src, $data);
  }

  $bn->set_call('PaintBegin', sub{ $bn->{cookie}{pmf} = 0 });
  $bn->set_call('PaintAppletArg', sub{
    if ($src) {
      $arg->{Param_All}{ $in->{src} eq 'anime' ? 'pch_file' : 'image_canvas' } =
        $bn->{rf}{cgi_stream} ? "$bbsnoteurl?fc=stream&src=$src" : "$data_dir/$src";
      my $_a = $arg->{applet};
      $_a->{continue} = $in->{continue} if $cfg_rep;
      $_a->{log} = $in->{log};
      $_a->{password} = $in->{paint_pass};
      $_a->{painttime} = $data->{paint_time};
      if ( $in->{continue} eq 'new' ) {
        $_a->{app} .= '+'. ($data->{applet} eq '' ? 'upload' : $data->{applet});
        $_a->{history} .= $data->{history}.'+' if $data->{history} ne '';
        $_a->{history} .= join '%', $data->{'time'}, $data->{paint_time},
          ( join '', map {sprintf("%02X", $_)}split '\.', $data->{ip} );
      }
   }
  });
  @{$in}{'width','height','anime'} = ($data->{width}, $data->{height},($in->{src} eq 'anime' ? 1 : 0));
  for(@{$bn->{module}{Paint}{applets}}){ $pm->paint($_) if $in->{app} eq $_->{key} }
  $bn->EXIT;
}

sub continue_convert {
  my( $pm, $src, $data ) = @_;
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my $gif = $src; $gif =~ s/png$/gif/i;
  my $gif_path = "$bn->{sys}{DirData}/$gif";
  my $path = "$bn->{sys}{DirData}/$src";

  $bn->error('ERR_DATA_NOTFOUND',
    ($path =~ /([^\/\\]+)$/ ? $1 : $path)) unless -e $path;

  unlink $gif_path if -e $gif_path && (stat $gif_path)[9] < (stat $path)[9];

  return $gif if -e $gif_path;

  my $hfl = { path => $path, size => -s $path, mime => 'png', width => $data->{width}, height => $data->{height} };
  my $hobj = { path => $gif_path };
  $bn->po->image_resize($hfl, $hobj, $data->{width}, $data->{height}, 'gif', 1);
  $bn->error('BAD_WRITE', $gif_path) unless -e $gif_path;

  if ($in->{log}) {
    my $val = {}; my $ex = {};
    $bn->app->get_log($in->{log}, $in->{res}, $val, $ex);
    my $log_imagesrc = "$bn->{sys}{DirData}/$ex->{imagesrc}";
    unlink $log_imagesrc
     if exists $ex->{imagesrc} && $gif_path ne $log_imagesrc;
    $ex->{imagesrc} = $gif;
    $bn->{sys}{MODE} = $in->{res} ? 'EDIT_REPLY' : 'EDIT_POST';
    $bn->po->write_log_value($bn->filelog($in->{log}), $val, $ex);
  } elsif($in->{pmid}) {
    my @result = split /\t/, $data->{result};
    $result[10] = $gif;
    $pm->check_pool(2, $in->{pmid}, join "\t", @result);
  }

  $gif;
}

sub get_paint_time {
  my( $pm, $t ) = @_;
  my $item = $pm->item;
  if ( $t =~ /(\d+$item->{ptime_day})?(\d+$item->{ptime_hour})?(\d+$item->{ptime_min})?(\d+$item->{ptime_sec})?/ ) {
    return ($1, $2, $3, $4, ( ($1 * 86400) + ($2 * 3600) + ($3 * 60) + $4 ));
  }
}

sub set_paint_time {
  my( $pm, $t ) = @_;
  my $item = $pm->item;
  my $day = int $t / 86400; $t -= $day * 86400;
  my $hour = int $t/ 3600; $t -= $hour * 3600;
  my $min = int $t/ 60; $t -= $min * 60;
  my $sec = $t; undef $t;
  $t = "$day$item->{ptime_day}" if $day;
  $t.= "$hour$item->{ptime_hour}" if $hour;
  $t.= "$min$item->{ptime_min}" if $min;
  $t.= "$sec$item->{ptime_sec}" if $sec;
  return $t;
}

sub set_pmid {
  return $bn->crypt_string( (join '',map {sprintf("%02X", $_)} split '\.', $ENV{REMOTE_ADDR}), 1 ).
  $bn->crypt_string( sprintf("%08X", time), 1 );
}

1;

__END__
