#=============================================================================
# BBS Note Comet 1.x 
# Copyright(C) WonderCatStudio. All rights reserved.
# This code cannot be redistributed without
# permission from wondercatstudio.com
# LastModify : 2008/04/23
# Version : 0.06.001 build 1
# Warning!! Use Only Japanese Language
#=============================================================================
package BN::Panic;
use strict;
use vars qw( $bn $VERSION );

$VERSION = '0.06.001';

my $limit_tag = 0;
my $limit_list = 500;
my $limit_after = 30;
my $limit_before = 30;
my $limit_conf   = 30;
my $view_limit_list = 10;

sub new {
  my $pa = bless {}, $_[0];
  $bn = $_[1];
  $pa;
}

sub panic {
  my $pa = shift;
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my $str = $_[0];

  my $path = "$bn->{sys}{DirSys}/panic.$bn->{sys}{Exe}";
  my $fh = $bn->open($path);
  $fh or $bn->error('ERR_DATA_NOTOPEN', $path);

  my @bit;
  $pa->analyse($str, \@bit);

  my($plen, $before, $after, $conf, $tagpre, $tagpost);
  my @c = split /,/, $bn->get($cf, 'PanicColor');
  $pa->{pac_array} = ();

  $plen = $#c + 1;
  srand;
  while ( $before = <$fh> ) {
    next unless defined ($after = <$fh>);
    next unless defined ($conf = <$fh>);
    next unless (<$fh>);
    chomp($before, $after, $conf);
    my @tag;
       if($conf eq "brand")  { @tag=("<b><font color=\"$c[rand $plen]\">", '</font></b>')}
    elsif($conf eq "bbrand") { @tag=("<b><font color=\"$c[rand $plen]\" size=\"+1\">", '</font></b>')}
    elsif($conf eq "rand")   { @tag=("<font color=\"$c[rand $plen]\">", '</font>')}
    elsif($conf eq "")       { @tag=('', '')}
    elsif($conf eq "irand")  { @tag=("<i><font color=\"$c[rand $plen]\">", '</font></i>')}
    elsif($conf eq "b")      { @tag=('<b>', '</b>')}
    elsif($conf eq "i")      { @tag=('<i>', '</i>')}
    elsif($conf eq "Bbrand") { @tag=("<b><font color=\"$c[rand $plen]\" size=\"+2\">", '</font></b>')}
    elsif($conf eq "Birand") { @tag=("<i><font color=\"$c[rand $plen]\" size=\"+2\">", '</font></i>')}
    elsif($conf eq "birand") { @tag=("<i><font color=\"$c[rand $plen]\" size=\"+1\">", '</font></i>')}
    else { @tag=("<font color=\"$conf\">", '</font>') }
    $pa->convert($str, $before, $after, @tag, \@bit);
  }
  close $fh;

  my $pac = join ',', @{$pa->{pac_array}} if ref $pa->{pac_array} eq 'ARRAY' && @{$pa->{pac_array}};

  $bn->set_call('WritePostLog', sub {
    $bn->{cookie}{panic} = $in->{panic} ? 1 : 0;
    $bn->{global}{LogExValue}{panic} = $pac;
  }) if defined $pac;

}

sub convert {
  my $pa = shift;
  my $in = $bn->{in};
  my($str, $before, $after, $tagpre, $tagpost, $bit) = @_;
  my($pos,$result,$pac_stream,@pos_array);

  while ($result > -1) {
    $result = index $$str, $before, $pos;
    last if $result < 0;
    # bit check
    if ($bit->[$result] == 3) { $pos = ++$result; next }

    my $len = length $before;
    my $replen = (length $tagpre) + (length $after) + (length $tagpost);
    $pac_stream = (unpack "H*",$before).':'.(sprintf "%x",$replen);

    my $s = substr $$str, 0, $result;
    my $b = $tagpre . $after . $tagpost;
    my @bitz;
    $pa->analyse(\$b, \@bitz);

    $$str = $s . $b . (substr $$str, $result+$len);
    splice @$bit, $result, $len, @bitz;

    $pos = $result + $replen;
    unshift @pos_array, sprintf "%x", $result;

  }

  unshift @{$pa->{pac_array}}, join ':', $pac_stream, @pos_array if @pos_array;
  $pa;
}

sub depanic {
  my $pa = shift;
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my($str,$pac) = @_;
  return unless defined $pac;

  for (split /,/, $$pac) {
    my($s, $len, @pos) = split /:/;
    $s = pack "H*", $s;
    ($len,@pos) = map{ hex }$len, @pos;
    for (@pos) { $$str = (substr $$str, 0, $_) . $s . (substr $$str, $_ + $len) }
  }
}

sub analyse {
  my $pa = shift;
  my($str, $bit) = @_;
  return unless $bn->{sys}{Charset} =~ /shift.jis/i;
  undef @$bit;
  my($i,$f);
  my $max = length $$str;
  for ($i = 0; $i < $max; $i++) {
    $_ = substr $$str,$i,1;
    if ($f>1) { $f = /[\x40-\xFC]/ ? 3 : 0 }
    elsif (/[\x81-\x9F\xE0-\xEA\xED-\xEE\xFA-\xFB\xFC]/) { $f = 2 }
    elsif (/[\x20-\x7E\xA1-\xDF]/) { $f = 1 }
    else { $f = 0 }
    $bit->[$i] = $f;
    $f = 0 if $f == 3;
  }
}

sub editor {
  my $pa = shift;
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my $sk = $bn->{skin};
  my $cms = $bn->{sys}{CMS};
  my $str = $_[0];
  my $arg = $bn->{arg}{PanicEditor} = {};

  my $path = $pa->{path} = "$bn->{sys}{DirSys}/panic.$bn->{sys}{Exe}";
  my $item = $pa->{item} = $bn->text(undef, 'panic');

  my $page = (int $in->{page}) -1;
  my $page_pos = $in->{page_pos};

  $pa->{error} = [];

  if (exists $cms->{LIMIT_NUM}{panic_editor}) {
    my $ue = $cms->{LIMIT_NUM}{panic_editor};
    $limit_list = $ue->{limit_list} if exists $ue->{limit_list};
    $view_limit_list = $ue->{view_limit_list} if exists $ue->{view_limit_list};
    $limit_before = $ue->{limit_before} if exists $ue->{limit_before};
    $limit_after = $ue->{limit_after} if exists $ue->{limit_after};
    $limit_tag = $ue->{limit_tag} if exists $ue->{limit_tag};
  }

  my @t = localtime(time + $bn->get($cf, 'TimeDiffSec'));
  ++$t[4]; $t[5] += 1900;
  $pa->{DATE} = sprintf( "%4d/%02d/%02d",$t[5],$t[4],$t[3]);
  $pa->{DATEINT} = int sprintf( "%4d%02d%02d%02d%02d%02d",$t[5],$t[4],$t[3],$t[2],$t[1],$t[0]);
  $pa->{TIME} = sprintf( "%4d/%02d/%02d %02d:%02d:%02d",$t[5],$t[4],$t[3],$t[2],$t[1],$t[0]);

  $page = 0 if $page < 0;
  my $wide = $1 if $in->{edit} =~ /(delete|edit)wide$/;

  # write
  if($in->{edit} =~ /^(?:add|edit|editwide|delete|deletewide)$/)
   { $pa->write }

  my $mod = (stat $path)[9];

  my @list_pos;
  $pa->get_pos_page($mod, \$page_pos, \@list_pos);
  my $pagelink = $pa->page_link($mod, $page, $page_pos, \@list_pos);
  my $bbsnoteurl = $bn->get($cf, 'BBSNoteUrl');
  my $args = $bn->set_form_arg($arg);
  my $list_num;
  my $form = '<form action="'.$bbsnoteurl.'" method="post">'.$args;
  my $table_in = $bn->get($sk, 'TagTableIn');
  my $table_out = $bn->get($sk, 'TagTableOut');
  my($line, $last_modify, $after, $conf, $ex, $ne, $pos, $prev_page, $next_page);
  my @s = ('rand','rep','b','brand','bbrand','Bbrand','i','irand','birand','Birand');

  my $fh = $bn->open($path);
  if ($fh) {
  seek $fh, $list_pos[$page], 0 if $page;
  my $now_pos = tell $fh;
  my $i;

  while ( my $before = <$fh> ) {
    last unless defined ($after = <$fh>);
    last unless defined ($conf = <$fh>);
    last unless defined ($ex = <$fh>);
    chomp($before, $after, $conf, $ex);
    $before =~ s/>/&gt;/g;
    $before =~ s/</&lt;/g;
    $before =~ s/"/&#34;/g;
    $after =~ s/>/&gt;/g;
    $after =~ s/</&lt;/g;
    $after =~ s/"/&#34;/g;

    if ($before =~ /^FlowerPanic!/) {
      $last_modify = $before;
      next;
    }
    $i++;

    my($info, $panic_cf);
    if ($wide eq 'delete') {
      my $f;
      for (@s) { if ($conf eq $_ || $conf eq '' && $_ eq 'rep' ) { $f = 1; last } }
      $panic_cf = $f ? $item->{$conf} : $conf;
      $info = '<input type="checkbox" name="item'.$i.'" value="'.$before.'">';

    } else {
      my($f, $dateint, $new_flag);
      $panic_cf = '<select name="conf'.($wide eq 'edit' ? $i : '0').'" class="select">';
      for (@s) {
        $panic_cf .= '<option value="'.$_.'"';
        if ($conf eq $_ || $conf eq '' && $_ eq 'rep' )
          { $panic_cf .= ' selected'; $f = 1 }
        $panic_cf .= ">$item->{$_}</option>" 
      }
      $panic_cf .= '</select>';
      $panic_cf = '<input style="width:100%" type="text" name="conf'.($wide eq 'edit' ? $i : '0').'" value="'.$conf.'" class="input">' unless $f;

      if ($wide eq 'edit') {
        $info = '<input type="checkbox" name="item'.$i.'" value="'.$before.'">';
      } else {
        if ($ex) {

          if ($ex=~/ADD:(\d+\/\d+\/\d+ \d+:\d+:\d+)\;/) {
            $info = "$item->{add_date}:$1";
            $dateint = $1;
            $dateint =~ s/\D//g;
            $new_flag = 1 if $pa->{DATEINT} < ((int $dateint) + 86400);
          }

          if ($ex=~/EDIT:(\d+\/\d+\/\d+ \d+:\d+:\d+)\;/) {
            $info .= ($info ? ' / ' : '')."$item->{edit_date}:$1";
            $dateint = $1;
            $dateint =~ s/\D//g;
            $new_flag = 1 if $pa->{DATEINT} < ((int $dateint) + 86400);
          }

          $info = '<font title="'.$info.'" style="cursor:help" onmouseover="status=\''.$info.'\'"'.
          ($new_flag ? ' color=red' : ''). ">$item->{mark}</font>";

        } else {
          $info = '&nbsp;';
        }
      }
    }

    # item list
    if ($wide eq 'delete') {
      $line .= 
      '<tr style="background-color:'.$table_in->{bgcolor}.'">'.
      '<td>'.$info.'</td>'.
      '<td style="font-size:10pt">'.$before.'</td>'.
      '<td style="font-size:10pt">'.$after.'</td>'.
      '<td style="font-size:10pt" colspan="2">'.$panic_cf.'</td>'.
      '</tr>'."\n";
    } elsif ($wide eq 'edit') {
      $line .= '<tr style="background-color:'.$table_in->{bgcolor}.'">'.
      '<td>'.$info.'</td>'.
      '<td><input type="text" name="before'.$i.'" value="'.$before.'" class="input"></td>'.
      '<td><input type="text" name="after'.$i.'" value="'.$after.'" class="input"></td>'.
      '<td colspan="2">'.$panic_cf.'</td>'.
      '</tr>'."\n";
    } else {
      $line .= '<tr style="background-color:'.$table_in->{bgcolor}.'">'.$form.
      '<input type="hidden" name="item0" value="'.$before.'">'.
      '<input type="hidden" name="page" value="'.$in->{page}.'">'.
      '<td>'.$info.'</td>'.
      '<td><input type="text" name="before0" value="'.$before.'" class="input"></td>'.
      '<td><input type="text" name="after0" value="'.$after.'" class="input"></td>'.
      '<td>'.$panic_cf.'</td>'.
      '<td><select name="edit" class="select">'.
      '<option value="edit">'.$item->{edit}.'</option>'.
      '<option value="delete">'.$item->{delete}.'</option>'.
      '</select><input class="ConfigBtn" type="submit" value="'.$item->{submit}.'"></td>'.
      '</form></tr>'."\n";
    }

    $list_num++;
    if ($list_num > $view_limit_list) {
        $pos = tell $fh;
        $ne = <$fh>;
        last;
    }
  }

  close $fh;

  }

  # page button
  my $edit = $wide ? $in->{edit} : 1;
  if ($page) {
  $page = $page;
  $prev_page =
    $form .'<input type="hidden" name="page" value="'.$page.'">'.
    '<input type="hidden" name="edit" value="'.$edit.'">'.
    '<td><input class="ConfigBtn" type="submit" value="'.$item->{page_back}.'"></td></form>';
  }

  if ($ne) {
  $page = $page + 2;
  $next_page = 
    $form.'<input type="hidden" name="page" value="'.$page.'">'.
    '<input type="hidden" name="edit" value="'.$edit.'">'.
    '<td><input class="ConfigBtn" type="submit" value="'.$item->{page_next}.'"></td></form>';
  }

  # error
  my $err;
  if (@{$pa->{error}})
   { $err = '<tr><td colspan="2"><b>' . (join '<br>', @{$pa->{error}}) . '</b></td></tr>' }

  # menu commands
  my @menu_cmd;
  if ($in->{edit} =~ /wide/) {
    push @menu_cmd, $form.
    '<input type="hidden" name="page" value="'.$in->{page}.'">'.
    '<input type="hidden" name="edit" value="normal">'.
    '<td><input class="ConfigBtn" type="submit" value="'.$item->{normal}.'">'.
    '</td></form>';
  }
  if ($in->{edit} ne 'editwide') {
    push @menu_cmd, $form.
    '<input type="hidden" name="page" value="'.$in->{page}.'">'.
    '<input type="hidden" name="edit" value="editwide">'.
    '<td><input class="ConfigBtn" type="submit" value="'.$item->{editwide}.'">'.
    '</td></form>';
  }
  if ($in->{edit} ne 'deletewide') {
    push @menu_cmd, $form.
    '<input type="hidden" name="page" value="'.$in->{page}.'">'.
    '<input type="hidden" name="edit" value="deletewide">'.
    '<td><input class="ConfigBtn" type="submit" value="'.$item->{deletewide}.'">'.
    '</td></form>';
  }

  # caption
  $bn->print($err,
  '</form><tr><td colspan="2"><table><tr>',
  $prev_page, $pagelink, $next_page,@menu_cmd, 
  '</tr></table>',
  '<table width="540" style="background-color:'.$table_out->{bgcolor}.'" cellpadding="0" cellspacing="0"><tr><td>',
  '<table width="100%" cellpadding="2" cellspacing="1">',
  '<tr style="background-color:',$table_in->{bgcolor},'" align="center">',
  ( $wide ? $pa->wide_chbox($item->{corner_mark}) : '<th width="1%">'.$item->{corner_mark}.'</th>'),
  '<th width="25%">',$item->{before},'</th>',
  '<th width="25%">',$item->{after},'</th>',
  ( $wide ? '<th width="41%">'.$item->{conf} :
    '<th width="40%">'.$item->{conf}.'</th><th width="9%">&nbsp;' ),
  '</th></tr>', ( $wide ? '<form action="'.$bbsnoteurl.'" method="post" name="wide">'.$args : undef ), $line
  );

  # foot
  if ($wide) {
    $bn->print('<tr style="background-color:'.$table_in->{bgcolor}.'">',
    '<td colspan="5" align="right"><small>&nbsp;'.$last_modify.'</small></td></tr>',
    '<tr><td style="background-color:'.$table_out->{bgcolor}.'" colspan="3" style="color:'.$table_in->{bgcolor}.'">',
    '<b>&nbsp;'.$item->{$in->{edit}}.' : </b><small>',
    $item->{wide_inf},'</small></td><td style="background-color:',$table_in->{bgcolor},'">',
    '<input style="width:100%" class="ConfigBtn" type="submit" value="',$item->{$wide.'_submit'},'"></td>',
    '</tr><input type="hidden" name="edit" value="'.$in->{edit}.'">',
    '<input type="hidden" name="page" value="'.$in->{page}.'"></form></tr></table>',
    '</td></tr></table></td></tr>'
    );

  } else {
    my $panic_cf = '<select name="conf0" class="select">';
    $panic_cf .= join '', map { '<option value="'.$_.'">'.$item->{$_}.'</option>' } @s;
    $panic_cf .= "</select>";

    $bn->print('<tr style="background-color:'.$table_in->{bgcolor}.'">',
    '<td colspan="5" align="right"><small>&nbsp;'.$last_modify.'</small></td></tr>',
    '<tr style="background-color:'.$table_out->{bgcolor}.'">',
    '<td colspan="5" style="color:'.$table_in->{bgcolor}.'"><b>&nbsp;'.$item->{add}.' : </b><small>',
    $item->{add_inf},'</small></td></tr><tr style="background-color:'.$table_in->{bgcolor}.'" align="center">',
    $form,'<input type="hidden" name="edit" value="add">',
    '<input type="hidden" name="page" value="'.$in->{page}.'">',
    '<td>&nbsp;</td><td><input type="text" name="before0" value="" class="input"></td>',
    '<td><input type="text" name="after0" value="" class="input"></td><td>'.$panic_cf.'</td>',
    '<td><input style="width:100%" class="ConfigBtn" type="submit" value="'.$item->{add_submit}.'"></td>',
    '</form></tr></table></td></tr></table></td></tr>'
    );

  }

}

sub get_pos_page {
  my $pa = shift;
  my $in = $bn->{in};
  my($mod, $page_pos, $list) = @_;

  if ($page_pos ne '' && $mod eq $in->{mod}) {
  @$list = split /:/, $$page_pos;
  return;
  }

  my $fh = $bn->open($pa->{path});
  $fh or $bn->error('ERR_DATA_NOTOPEN',$pa->{path});

  my($list_num, $page);
  @$list = ();
  while (my $before = <$fh> ) {
    next unless ( <$fh> );
    next unless ( <$fh> );
    next unless ( <$fh> );
    chomp $before;
    next if $before =~ /^FlowerPanic!/;
    $list_num++;
    if ($list_num > $view_limit_list) {
      $page++;
      $$list[$page] = tell $fh;
      $list_num = 0;
    }
  }
  close $fh;
  $$page_pos = join ':', @$list;
  $pa;
}


sub write {
  my $pa = shift;
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my $item = $pa->{item};
  my $mode = $in->{edit};

  my(@add_items, @del_items, $n);

  # edit or delete wide
  if ($mode =~ /wide/) {
    for (keys %$in) {
       next unless /item(\d+)/;
       push @add_items, int $1 if $mode eq 'editwide';
       push @del_items, int $1;
    }
    return unless @del_items;

    if ($mode eq 'editwide') {
      for (@del_items)
      { $pa->check_strings($in->{'before'.$_}, $in->{'after'.$_}, $in->{'conf'.$_}, $in->{'item'.$_}, $mode) }
      return if @{$pa->{error}};
    }

  # add or delete
  } else {
    $pa->check_strings($in->{'before0'}, $in->{'after0'}, $in->{'conf0'}, $in->{'item0'}, $mode);
    return if @{$pa->{error}};
    push @add_items, 0 if $mode =~ /^(?:add|edit)$/;
    push @del_items, 0 if $mode =~ /^(?:delete|edit)$/;
  }

  # not use tag
  if ( $limit_tag == 2 ) {
    $pa->esc_tag( \@add_items );
    return if @{$pa->{error}};
  } elsif ( $limit_tag ) {
    for ( @add_items ) { $pa->check_tag( $_ ) }
    for ( @del_items ) { $pa->check_tag( $_ ) }
  }

  $bn->filelock;

  my($fh_tmp, $tmp) = $bn->get_temp_file;
  my $fh = -e $pa->{path} ? $bn->open($pa->{path}) : $bn->open($pa->{path}, '>');
  $fh or $bn->error('ERR_SYS_NOTWRITE',$pa->{path});

  $bn->{temp}{fh}{panic} = $fh;

  my($hflag, $aflag, $before, $after, $conf, $ex);
  while ($before = <$fh>) {
  last unless defined ($after = <$fh>);
  last unless defined ($conf = <$fh>);
  last unless defined ($ex = <$fh>);
  chomp $before;

  # header
  if (!$hflag && $before=~/^FlowerPanic!/) {
    print $fh_tmp "FlowerPanic!:$pa->{DATE}\n\n\n\n";
    $hflag = 1;
    next;
  }

  # check add item already exists
  if ($mode eq 'add' && !$aflag && $before eq $in->{'before0'}) {
    close $fh_tmp; close $fh;
    delete $bn->{temp}{fh}{panic};
    $bn->fileunlock;
    $pa->err('ERR_REP');
    return;
  }

  # add items
#  if (@add_items && $before ne "\x81\x5B" && $before ne "\x81\x5C") {
  if (@add_items) {
    my $l = length $before;
    my @adds;
    for (my $i = 0; $i < @add_items; $i++) {
      $_ = $add_items[$i];
      my $len = length $in->{"before$_"};
      if ($l < $len) {
        print $fh_tmp $in->{"before$_"}."\n".$in->{"after$_"}."\n".$in->{"conf$_"}."\nEDIT:$pa->{TIME}\;\n";
        push @adds, $i;
        $aflag = 1;
        $n++;
      }
    }
    for (sort {$b <=> $a} @adds) { splice @add_items, $_, 1 }
  }

  # delete items
  if (@del_items) {
    my $f;
    for (my $i = 0; $i < @del_items; $i++) {
      next if $before ne $in->{'item' . $del_items[$i]};
      splice @del_items, $i, 1;
      $f = 1;
      $n--;
      last;
    }
    next if $f;
  }

  print $fh_tmp "$before\n$after$conf$ex";
  $n++;

  }

  if (@add_items) {
    for (my $i = 0; $i < @add_items; $i++) {
      $_ = $add_items[$i];
      print $fh_tmp $in->{"before$_"}."\n".$in->{"after$_"}."\n".$in->{"conf$_"}."\nEDIT:$pa->{TIME}\;\n";
      $n++;
    }
  }

  close $fh_tmp;
  close $fh;
  delete $bn->{temp}{fh}{panic};


  if ($n > $limit_list) {
    $pa->err('ERR_LIST', $limit_list);
    $bn->fileunlock;
    unlink $tmp; return;
  }

  rename $tmp, $pa->{path}
  or unlink $tmp && $bn->error('ERR_SYS_NOTWRITE', $pa->{path});

  $bn->fileunlock;

}
sub check_tag {
  my $pa = shift;
  my $in = $bn->{in};
  my $i = $_[0];
  for (qw/before after conf item/) {
    $in->{"$_$i"} =~ s/>/&gt;/g;
    $in->{"$_$i"} =~ s/</&lt;/g;
  }
}
sub esc_tag {
  my $pa = shift;
  my $in = $bn->{in};
  my $items = $_[0];
  my $ok_tags = $bn->{sys}{CMS}{LIMIT_TAG};
  require BN::Write;
  my $wri = new BN::Write( $bn );

  for my $i ( @$items ) {
    for (qw/before after/) {
      my $s = $in->{"$_$i"};
      $wri->esc_tag( "$_$i" , $pa );
    }
  }

}
sub check_strings {
  my $pa = shift;
  my $item = $pa->{item};
  my($befor, $after, $conf, $str, $mode) = @_;
  my $len = length $befor;
  $pa->err('ERR_UNENTRY', $item->{befror}) if $befor eq '';
  $pa->err('ERR_UNENTRY', $item->{after}) if $after eq '';
  $pa->err('ERR_STRNONE') if $mode ne 'add' && $str eq '';
  $pa->err('ERR_LIMIT_BEFORE', $limit_before) if $len > $limit_before;
  $pa->err('ERR_LIMIT_AFTER', $limit_after) if length $after > $limit_after;
  $pa->err('ERR_LIMIT_CONF', $limit_conf) if length $conf > $limit_conf;
  $pa;
}

sub page_link {
  my $pa = shift;
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my($mod, $page, $page_pos, $list) = @_;
  my $arg = $bn->{arg}{PanicEditor};

  my $bbsnoteurl = $bn->get($cf, 'BBSNoteUrl');
  $arg->{fc} = $in->{fc};
  $arg->{mod} = $mod;
  $arg->{name} = $in->{name};
  $arg->{mode} = $in->{mode};
  $arg->{edit} = $in->{edit} eq 'deletewide' ? $in->{edit} : 1;
  $arg->{page_pos} = $page_pos;
  $arg->{password} = $in->{password};
  my $args = $bn->set_form_arg($arg);
  delete $arg->{edit};
  return if @$list < 2;

  my $l = '<form name="pagelink" action="'.$bbsnoteurl.'" method="post">'.$args.
   '<td><select class="select" name="page" onchange="document.pagelink.submit()">';

  for (my $n=1; $n <= @$list; $n++) {
    my $sl = ($n == $page + 1) ? ' selected' : '';
    $l .= '<option value="'.$n.'"'.$sl.'>'.$n.'</option>'."\n";
  }
  $l .= '</select></td></form>';
  return $l;
}

sub wide_chbox {
  my $pa = shift;
  my $button = $_[0];
  return <<__JS__;
<script langage="javascript">
function rev_chbov(){d=document;if(d.wide){for(i=0;i<d.wide.length;i++)
{if(d.wide[i].type=='checkbox')d.wide[i].checked=!d.wide[i].checked}}}
</script><form><th width="1%"><input class="ConfigBtn" type="button" value="$button" onclick="rev_chbov()"></th></form>
__JS__
}

sub err {
  my $pa = shift;
  my $key = shift;
  my @arg = @_;
  my $t = $pa->{item}{$key};
  my $n = 1;

  if ( $key =~ /^ERR_(?:BRA|ELM|TAG)/ ) {
    $arg[-1] = $bn->{in}{$arg[-1]};
    $arg[-1] =~ s/>/&gt;/g;
    $arg[-1] =~ s/</&lt;/g;
  }

  for (@arg){
    $t =~ s/\[_$n\]/$arg[$n-1]/g;
    $n++;
  }
  push @{ $pa->{error} }, $t;
  $pa;
}

1;

__END__
