#=============================================================================
# BBS Note Comet 1.x
# Copyright(C) WonderCatStudio. All rights reserved.
# This code cannot be redistributed without
# permission from wondercatstudio.com
# LastModify : 2007/11/26
# Version : 0.17.000 build 1
#=============================================================================
package BN::Post;

use strict;
use vars qw( $bn $VERSION );

$VERSION = '0.17.000';

sub new {
  my $po = bless { }, $_[0];
  $bn = $_[1];
  $po;
}

sub write {
  my $po = $_[0];
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my $fl = $bn->{flag};
  my $sys = $bn->{sys};
  my $gl = $bn->{global};
  my $ck = $bn->{cookie};
  my $ap = $po->{ap} = $bn->app;
  my( $ip, $host ) = $bn->get_user_ip;

  $bn->call('WritePostInit');

  utime time, time, $0 if $bn->get($cf, 'UseMetaCookie');

  my $DATE = $bn->get_date;
  # log valiables
  my $val = $gl->{LogValue} = {};
  my $ex = $gl->{LogExValue} = {};
  my $bval = $gl->{BLogValue} = {};
  my $bex = $gl->{BLogExValue} = {};
  $gl->{out} = {};   # out hash
  $gl->{count} = {}; # count hash
  $gl->{error} = []; # error array
  $gl->{PM} = {};    # mo paint
  $gl->{FILES} = {}; # file hash

  $bn->error('BAD_REQUEST') if $ENV{'REQUEST_METHOD'} ne 'POST';

  # mode init
  if (exists $in->{edit}) {

    # limit edit
    $bn->check_limit_post('Edit')
      or push @{$gl->{error}}, $bn->text('CHECK_EDIT_POST_AUTHOR');

    $bn->check_password($in->{checkpass}, $ap->get_log_password($in->{log}, $in->{edit}))
      or $bn->error('PASSWORD_ERROR');

    $fl->{NO_COUNT} = 1;

    if ($in->{edit}) {
      $sys->{MODE} = 'EDIT_REPLY';
      $fl->{FILE_CAPTOR} = $bn->get($cf, 'UseReplyUpload');
      $fl->{POST_FORM_TITLE} = 1 if $bn->get($cf, 'UseReplyTitle');
    } else {
      $sys->{MODE} = 'EDIT_POST';
      $fl->{FILE_CAPTOR} = $bn->get($cf, 'UseUpload');
      $fl->{POST_FORM_TITLE} = 1;
    }

    # use date edit
    if ( $bn->get($cf, 'UseEditDate') &&
      ( exists $in->{date_year} || exists $in->{date_month} || exists $in->{date_day} ||
        exists $in->{date_hour} || exists $in->{date_min} || exists $in->{date_sec} )
       )
    {
      $po->check_auth($bn->get($cf, 'UseEditDate'))
        or push @{$gl->{error}},$bn->info('CHECK_DATE_EDITAUTHOR');
      my( %d, $yr, $mt );
      if ( $DATE =~ m#(\d+)/(\d+)/(\d+) \(\w+\) (\d+):(\d+):(\d+)?# )
       { %d = ( year => $1, month => $2, day => $3, hour => $4, min => $5, sec => $6 ) }
      for ( keys %d ) { $d{$_} = abs int $in->{'date_'. $_} if exists $in->{'date_'. $_} && $in->{'date_'. $_} ne '' }
      my $lt;
      require Time::Local;
      eval{ $lt = Time::Local::timelocal( $d{sec}, $d{min}, $d{hour}, $d{day}, $d{month} - 1, $d{year} ) };
      if ( $@ ) {
        my( $k, @val );
        if ( $@ =~ /(\w+) '[^']*' out of range (\d)..(\d+)/ ) {
          @val = ( $2, $3 );
          $k = $1 eq 'Minute' ? 'min' : $1 eq 'Second' ? 'sec' : lc $1;
          if ( $k =~ /year|month|day/ ) {
            my $item = $bn->get( $bn->{skin}, 'FormName' );
            if ( $k eq 'month' ) {for ( my $n = 0; $n < @val; $n++ ) { $val[$n]++ } }
            $k = $item->{'date_edit_'.$k};
          } else {
            $k = $bn->text( 'ptime_'. $k, 'paint' );
          }
        } elsif ( $@ =~ /Cannot handle date/ ) {
          @val = ( 0, 0x7fff );
          $k = $bn->get( $bn->{skin}, 'FormName' )->{date_edit_year};
        }
        push @{$gl->{error}},$bn->info( 'CHECK_DATE_OUT_OF_RANGE', $k, @val );
        $in->{number} = $in->{log};
        $in->{number} .= '-'.$gl->{res_num} if $gl->{res_num};
        $bn->set_call( 'OpenPostInit', sub{ $bn->open_edit; goto EXIT } );
        $bn->filelock;
      }
      my $li = $sys->{cookie_limit};
      $DATE = $bn->get_date( $lt );
      $sys->{cookie_limit} = $li;
    }
    $gl->{res_no} = $ap->get_log($in->{log}, $in->{edit}, $bval, $bex);

    # use html thread
    if ($bn->get($cf, 'UseHtmlThread')) {
      if (exists $in->{html}) {
        $po->check_auth($bn->get($cf, 'UseHtmlThread'))
          or push @{$gl->{error}},$bn->info('CHECK_HTML_THREAD');
        $bn->app;
      }
      unless (@{$gl->{error}}) {
        my $create_html = sub {
         my $cex = $bex;
         if ($in->{edit}) { $ap->get_log($in->{log}, undef, {}, $cex) }
         $bn->app->hook_create_html($cex) if $sys->{MODE} =~ /EDIT/;
        };
        $bn->set_call('WritePostModeReply', $create_html );
        $bn->set_call('WritePostModeEdit', $create_html );
      }
    }

  } elsif(exists $in->{log}) {

    # limit reply post
    $bn->check_limit_post('Reply')
      or push @{$gl->{error}}, $bn->text('CHECK_REPLY_POST_AUTHOR');

    $sys->{MODE} = 'WRITE_REPLY';
    $fl->{FILE_CAPTOR} = $bn->get($cf, 'UseReplyUpload');
    $fl->{POST_FORM_TITLE} = 1 if $bn->get($cf, 'UseReplyTitle');
    $fl->{reply_enable} = $bn->check_reply_enable($bn->get_reply_status($in->{log}))
      or $bn->error('ERR_REPLYPOST');

  } else {

    # limit new post
    if ( $in->{fc} ne 'paint_write' ) {
      $bn->check_limit_post('New')
        or push @{$gl->{error}}, $bn->text('CHECK_NEW_POST_AUTHOR');
    }

    $sys->{MODE} = 'WRITE_POST';
    $fl->{FILE_CAPTOR} = $bn->get($cf, 'UseUpload');
    $fl->{POST_FORM_TITLE} = 1;
  }

  
  { # limit post range
    my $cf_mode = $sys->{MODE} eq 'WRITE_POST' ? 'new' :
       $sys->{MODE} eq 'WRITE_REPLY' ? 'reply' : undef;
    if ( defined $cf_mode ) { my %c;
      for( split ';', $bn->get( $cf, 'LimitPostRange' ) ) {
      my @a = split ':', $_, 2; next if $a[0] ne $cf_mode;
      for ( split ',', $a[1] ) { my @v = split '=', $_, 2; $c{$v[0]} = $v[1] if $v[1] } }
      $bn->app->check_post_range;
    }
  };

  my $crypt_pass = $bn->crypt_string($in->{password});

  my $hfl = $gl->{FILES}{file} = {};
  my $hobj = $gl->{FILES}{object} = {};

  $po->check_input;

  %{ $gl->{out} } = %{ $bn->{in} };

  $gl->{out}{message} = $po->convert_message($in->{message});

  # panic
  if ( $bn->get($cf, 'UsePanic') eq '2' ||
    $bn->get($cf, 'UsePanic') eq '1' && $in->{panic} ) {
    $bn->pa->panic(\$gl->{out}{message});
  }

  # multi post check
  $po->check_history;

  $bn->call('WriteCheckInput');
  $bn->filelock;

  # counter
  $po->get_count($gl->{count});

  $gl->{LogFile} = $bn->filelog($in->{log});

  $bn->call('WritePostMode');
  if ($sys->{MODE} eq 'WRITE_POST') {
    # log number check
    my $try;
    my $max = $bn->get($cf, 'LogMax');
    while ($try < $max) {
      $gl->{count}{log} = 0 if $gl->{count}{log} > 65025;
      $gl->{LogFile} = $bn->filelog(++$gl->{count}{log});
      last unless -e $gl->{LogFile};
      $try++;
    }
    $bn->error('ERR_SYS_COUNTERROR') if $try >= $max;

    $bn->call('WritePostModePost');
    $po->add_index($gl->{count}{log}, 1);
    $bn->call('WriteFilesModePost');

  } elsif($sys->{MODE} =~ /REPLY/) {

    $bn->error('ERR_DATA_NOTFOUND') unless -e $gl->{LogFile};

    $bn->call('WritePostModeReply');

    $po->reply_index($in->{log}, 1) if $in->{mail} ne 'sage';

    # edit : upload filename increment
    if ($fl->{FILE_CAPTOR} && $hfl->{size}) {
      my $imagesrc = eval{ for ('file_name','filename') {
        return $bex->{$_} if exists $bex->{$_} } };

      $imagesrc =~ /_\d+(?:_R\d+)?_?(\d+)?/;
      my $inc = int $1;
      $gl->{INCREMENT} = 'R' . ($bval->{num} ? $bval->{num} : $gl->{count}{num} + 1);
      $gl->{INCREMENT}.= '_' . ++$inc if $imagesrc ne '';

      # delete before files and ex values
      # * thumbnail : v8 old value > became thumbsrc value in vC
      $ap->delete_files(@{$bex}{'filename','file_name','thumbnail','imagesrc','thumbsrc','animesrc'});
      for (qw/filename file_name file_width file_height file_length width height size
           paint_time paint_timer paint_count thumbnail imagesrc thumbsrc animesrc/) {
        delete $bex->{$_};
      }
    }

  } elsif($sys->{MODE} eq 'EDIT_POST') {

    $bn->error('ERR_DATA_NOTFOUND') unless -e $gl->{LogFile};
    $bn->call('WritePostModeEdit');
    $gl->{count}{log} = int $in->{log};
    $po->reply_index($in->{log}, 1) if $in->{mail} ne 'sage';

    # edit : upload filename increment
    if ($hfl->{size}) {
      $bval->{file_name} =~ /_\d+_?(\d+)?/;
      my $inc = int $1;
      $gl->{INCREMENT} = ++$inc if $bval->{file_name} ne '';

      # delete before files and ex values
      # * thumbnail : v8 old value > became thumbsrc value in vC
      $ap->delete_files(@{$bval}{'file_name','object'},
        @{$bex}{'filename','file_name','thumbnail','imagesrc','thumbsrc','animesrc'});
      for (qw/filename file_name file_width file_height file_length width height size
           paint_time paint_timer paint_count thumbnail imagesrc thumbsrc animesrc/) {
        delete $bex->{$_};
      }

    }

    $bn->call('WriteFilesModeEdit');

  }

  $po->set_filename($hfl, undef, undef, $gl->{INCREMENT});

  $po->write_files($gl->{FILES});

  $po->image_resize($hfl, $hobj) if $bn->get($cf, 'UseThumbnail');

  if($sys->{MODE} =~ /REPLY/){
    # reply upload : thumbnail src
    $ex->{thumbsrc} = $hobj->{filename} if $hobj->{size};
    # reply title
    $ex->{title} = $gl->{out}{title} if $bn->get($cf, 'UseReplyTitle');
    # tree : ex tree number
    if ( $sys->{MODE} =~ /EDIT/ && exists $bex->{tree} ) {
      $ex->{tree} = $bex->{tree};
    } elsif ( exists $in->{num} ) {
      $ex->{tree} = $in->{num};
    }
    # tree : ex spport check flag
    if ($bn->get($cf, 'UseTreeSppCheck')) {
      $in->{kaiketu} ? $ex->{kaiketu} = 1 : delete $ex->{kaiketu};
    }
  }


  $bn->call('WritePostValues');

  @{$val}{$bn->LOG_MAIN_VALUE} = (
    ++$gl->{count}{num},    # message count
    $gl->{out}{name},       # name
    $DATE,                  # post time
    $gl->{out}{title},      # title
    $gl->{out}{mail},       # mail
    $gl->{out}{url},        # URL
    $gl->{out}{message},    # message
    $gl->{HOST},            # host
    $gl->{IP},              # ip
    $gl->{UserAgent},       # user agent
    $hfl->{filename},       # file name
    $hfl->{width},          # image width
    $hfl->{height},         # image height
    $hfl->{size},           # image data size
    $crypt_pass,            # password
    $hobj->{filename},      # thumbnail or anime data or object data
    $gl->{PM}{paint_time},  # paint time
    $gl->{PM}{applet_name}, # applet info
  );

  $val->{iphost} = "$gl->{IP}($gl->{HOST})";
  $val->{browser} = $gl->{UserBrowserVer};
  $val->{os} = $gl->{UserOS};

  for ( qw/name mail url password icon panic/ ) { $ck->{$_} = $in->{$_} }

  $bn->call('WritePostLog');

  # mail notice
  if ($bn->get($cf, 'UseNoticeMail')) {
    $ex->{mail_notice} = $ck->{mail_notice} = int $in->{mail_notice};
  }

  # icon
  if ( $bn->get($cf, 'UseIcon') && exists $in->{icon} ) {
    $ex->{icon} = $ck->{icon} = '';
    my $list = $bn->get( $cf, 'IconList' );
    if ( ref $list eq 'ARRAY' ) {
      for my $h ( @$list ) {
        next if $h->{file_name} ne $in->{icon};
        $ex->{icon} = $ck->{icon} = $in->{icon};
        last;
      }
    }
  }

  # color
  if ( $bn->get($cf, 'UseColor') ) {
    my $dsn = $bn->mo( 'Design' );
    for ( qw/font title table/ ) {
      next unless exists $in->{$_.'_color'} && $in->{$_.'_color'} ne '';
      $ex->{$_.'_color'} = $ck->{$_.'_color'} = $dsn->get_color( $in->{$_.'_color'} );
    }
  }

  # reply upload
  if ($sys->{MODE} =~ /REPLY/ && $hfl->{size}) {
    @{$ex}{'file_name','file_width','file_height','file_length'}
       = @{$hfl}{'filename','width','height','size'};
  }
  # edit mode
  if($sys->{MODE} =~ /EDIT/){

    $val->{num} = $bval->{num};

    # edit : not upload
    unless ($hfl->{size}) {
      my @vals = qw/file_name file_width file_height file_length object paint_time applet/;
      @{$val}{@vals} = @{$bval}{@vals};
    }

    # edit : ex values succession
    for (keys %{$bex}) {
      $ex->{$_} = $bex->{$_} unless exists $ex->{$_};
    }

    # ex edit info
    unless ($bn->get($cf, 'NotEditRecord')) {
      $ex->{edit} .= ",$bval->{date}@" . ($bval->{iphost} ? $bval->{iphost} : "$bval->{ip}($bval->{host})");
      $ex->{edit} =~ s/^\,//;
    }

  }

  # nobr
  $in->{nobr} ? $ex->{nobr} = 1 : exists $ex->{nobr} ? $ex->{nobr} = 0 : delete $ex->{nobr};
  $in->{nobr} ? $ck->{nobr} = 1 : delete $ck->{nobr};

  # write log
  $po->write_log_value($gl->{LogFile}, $val, $ex);

  $po->write_history({
    'time'    => time(),
    mode      => $sys->{MODE},
    log       => $in->{log},
    ip        => $gl->{IP},
    host      => $gl->{HOST},
    name      => $in->{name},
    title     => $in->{title},
    message   => $in->{message},
    file_size => $hfl->{size},
  });

  # counter set
  $po->set_sys_item('count', "$gl->{count}{log}\t$gl->{count}{num}") unless $fl->{NO_COUNT};

  # index html reflesh
  $ap->reflesh;

  $bn->fileunlock;


  # mail notice
  if ( $bn->get($cf, 'UseAllPostNotice') || ($bn->get($cf, 'UseNoticeMail') &&
    $sys->{MODE} =~ /WRITE_POST|WRITE_REPLY/)
  ) {
    $po->mail_notice;
  }

  $bn->write_cookie($ck, 1);

  $sys->{MODE} = '';
  for ( qw/title message log/ ) { delete $in->{$_} }
  $bn->open_page;

  undef %{$gl->{PM}};
  delete $gl->{PM};
  for (keys %{ $gl->{FILES} }) {
    if (exists $gl->{FILES}{$_}) {
      undef %{ $gl->{FILES}{$_} };
      delete $gl->{FILES}{$_};
    }
  }
  delete $gl->{FILES};
}

sub check_input {
  my $po = $_[0];
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my $fl = $bn->{flag};
  my $gl = $bn->{global};
  my $sys = $bn->{sys};
  my $err = $gl->{error};

  $bn->call('CheckInputInit');

  $bn->error('ERR_DIR_NOTFOUND', $sys->{DirData}) unless -d $sys->{DirData};

  $po->escape_input(0, \$in->{name}, \$in->{title});
  $po->escape_input(1, \$in->{mail}, \$in->{url});
  $po->escape_input(2, \$in->{message});
  $po->check_string;

  $bn->call('CheckInputBegin');

  # user
  if ($bn->get($cf, 'UseNameCap') && !exists $fl->{no_name_cap}) {
    $bn->usr->cap($in->{name}, $in->{password}, $gl->{LogExValue});
  }
  if ($bn->get($cf, 'UseNameTrip') && $in->{name} =~ /\#/ ) {
    $bn->usr->trip(\$in->{name}, $gl->{LogExValue});
  }

  # icon
  if ($bn->get($cf, 'UseIcon') && $in->{icon} ne '') {
    $bn->ic->check_icon;
  }

  # BBSPainter
  if (exists $in->{app} && $in->{app} eq 'pai') {
    my $paint_applet = $bn->get($cf, 'UseApplet');
    if (ref $paint_applet eq 'ARRAY') {
      my $flag;
      for (@$paint_applet) {
        my $c = $bn->get($cf, 'AppletSetting:' . $_);
        if (ref $c eq 'HASH' && $c->{applet} eq 'pai') { $flag = 1; last }
      }
      $fl->{FILE_CAPTOR} = $bn->get($cf, 'LimitPostPaint') if $flag;
    }
  }

  if ($fl->{FILE_CAPTOR} && length $in->{file}) {
    if ($po->check_auth($fl->{FILE_CAPTOR})) {
      my $h = $gl->{FILES}{file};
      @{$h}{'mime', 'width', 'height', 'size'}
       = $po->file_analyze(\$in->{file});
      $bn->call('CheckInputFile');

      if ($h->{size}) {
        push @$err,$bn->info('CHECK_UPPIXELSIZEOVER',
          $bn->get($cf, 'LimitImageWidth'), $bn->get($cf, 'LimitImageHeight'), $h->{width}, $h->{height})
            if !$fl->{nocheck_size} && ($bn->get($cf, 'LimitImageWidth') < $h->{width} || $bn->get($cf, 'LimitImageHeight') < $h->{height});
        my $spa = $bn->get($cf, 'ConfigShiPainter');
        my $sii = $bn->get($cf, 'ConfigShiPaintBBS');
        my $limit = ( grep $h->{mime} eq $_, ( $spa->{anime_ext}, $sii->{anime_ext} ) )
         ? $bn->get($cf, 'LimitAnimeData') : $bn->get($cf, 'LimitUpLoadData');
        push @$err,$bn->info('CHECK_UPDATASIZEOVER', $limit, $h->{size})
          if !$fl->{nocheck_mime} && $limit < $h->{size};
        push @$err,$bn->info('UNKNOWN_FORMAT')
          if !$fl->{nocheck_format} && !grep $h->{mime} eq $_ ,split ',',$sys->{CaptorFormat};
        push @$err,$bn->info('UNKNOWN_FORMAT')
          if !$fl->{nocheck_format} && $h->{mime} =~ /jpg|gif|png/ && ( $h->{width} == 0 || $h->{height} == 0 );
        $in->{file_size} = $h->{size};
        $h->{data} = \$in->{file};
      } elsif($bn->get($cf, 'NeedData') && $sys->{MODE} !~ /^EDIT/) {
        push @$err,$bn->info('CHECK_UPCOMMENTONLY');
      }
    } else {
      push @$err,$bn->info('CHECK_UPAUTHOR')
    }

  } elsif ($bn->get($cf, 'NeedData') && $sys->{MODE} !~ /^EDIT/) {
    if ($bn->get($cf, ($sys->{MODE} =~ /REPLY/ ? 'UseReplyUpload' : 'UseUpload') )) {
      push @$err,$bn->info('CHECK_UPCOMMENTONLY');
    } elsif ($sys->{MODE} eq 'WRITE_POST') {
      $bn->error('ERR_FUNCTION');
    }
  }

  $po->check_error($err);
  $bn->call('CheckInputEnd');
}

sub check_string {
  my $po = $_[0];
  my $cf = $bn->{cfg};
  my $sk = $bn->{skin};
  my $gl = $bn->{global};
  my $in = $bn->{in};
  my $err = $gl->{error};
  my $len;

  $bn->call('CheckStringBegin');
  my $fx = $bn->get($sk, 'FormType') eq 'line' ? 0 : 1;

  push @$err, $bn->info('CHECK_TITLE')
    if $bn->{flag}{POST_FORM_TITLE} && $bn->get($cf, 'NeedTitle') && !$in->{title} && $fx;
  push @$err, $bn->info('CHECK_NAME') if $bn->get($cf, 'NeedName') && !$in->{name};
  push @$err, $bn->info('CHECK_MAIL') if $bn->get($cf, 'NeedMail') && !$in->{mail} && $fx;
  push @$err, $bn->info('CHECK_URL') if $bn->get($cf, 'NeedUrl') && !$in->{url} && $fx;
  push @$err, $bn->info('CHECK_PASSWORD') if $bn->get($cf, 'NeedPassword') && !$in-> {password} && $fx;
  push @$err, $bn->info('CHECK_MESSAGE') if $bn->get($cf, 'NeedMessage') && !$in->{message};

  $len = length $in->{name};
  push @$err, $bn->info('CHECK_NAMEOVER', $len, $bn->get($cf, 'LimitName')) if $len > $bn->get($cf, 'LimitName');
  $len = length $in->{mail};
  push @$err, $bn->info('CHECK_MAILFORMAT') if $len > 0 && $in->{mail} !~ /(.*)\@(.*)\.(.*)/ &&
  ( $in->{mail} ne 'sage' || exists $bn->{flag}{disable_sage} );
  push @$err, $bn->info('CHECK_MAILOVER', $len, $bn->get($cf, 'LimitMail')) if $len > $bn->get($cf, 'LimitMail');
  $len = length $in->{title};
  push @$err, $bn->info('CHECK_TITLEOVER', $len, $bn->get($cf, 'LimitTitle')) if $len > $bn->get($cf, 'LimitTitle');
  $len = length $in->{url};
  push @$err, $bn->info('CHECK_URLOVER',$len, $bn->get($cf, 'LimitUrl')) if $len > $bn->get($cf, 'LimitUrl');
  $len = length $in->{message};
  push @$err, $bn->info('CHECK_MESSAGEOVER', $len, $bn->get($cf, 'LimitMessage')) if $len > $bn->get($cf, 'LimitMessage');

  $po->check_filter;

  $bn->call('CheckStringEnd');
}

sub check_filter {
  my $po = $_[0];
  my $cf = $bn->{cfg};
  my $sk = $bn->{skin};
  my $in = $bn->{in};
  my $gl = $bn->{global};
  my $err = $gl->{error};

  my $f_string = $bn->get($cf, 'LimitFilterString');
  my $flag = 0;
  if ( ref $f_string eq 'ARRAY' ) {
    for my $str ( @$f_string ) {
      chomp $str;
      my $c = quotemeta $str;
      for ( qw/name title  message mail url/ ) {
        next unless exists $in->{$_};
        if ( $in->{$_} =~ /$c/ ) {
          my $item = $bn->get($sk, 'FormName');
          push @$err, $bn->info( 'CHECK_FILTER_STRING',
           ( ref $item eq 'HASH' ? $item->{$_} : $_ ) , $str );
          $flag = 1;
          last;
        }
      }
      last if $flag;
    }
  }

  if ( $bn->get($cf, 'LimitFilterEnChr') && length $in->{message} &&
    $in->{message} !~ /[^\011-\015|\040-\176]/ )
     { push @$err, $bn->info( 'CHECK_FILTER_ENCHR' ) }

  if ( $bn->get($cf, 'LimitFilterAddress') &&
   $in->{message} =~ /(h?ttps?:\/\/[-.!~*'()\w;\/?:\@&=+\$,%#]+)/
  ) {
    push @$err, $bn->info( 'CHECK_FILTER_ADDRESS', $1 );
  }

  $po->check_filter_spam if $bn->get($cf, 'LimitFilterSpam') && !$po->check_auth( 2 );

}

sub check_filter_spam {
  my $po = $_[0];
  my $in = $bn->{in};
  my $fl = $bn->{flag};
  my $gl = $bn->{global};
  my $err = $gl->{error};
  my $url_addr = $gl->{get_url_addr} = $po->get_url_addr( $in->{message} );
  my @deny_url = [];
  $fl->{spam} = 0;
  for ( @deny_url ) {
    if ( exists $url_addr->{$_} ) { $fl->{spam} = 2; last } }
  
  if ( ! $fl->{spam} ) {
    if ( exists $url_addr->{ 'http://'. $in->{url} } ) {
      $fl->{spam} = 1;
    } else {
      my $url_count;
      for my $u ( keys %$url_addr )
       { $url_count++; if ( $url_addr->{$u} > 1 ) { $fl->{spam} = 1; last } }
      my $enchr = 1 if $in->{message} !~ /[^\011-\015|\040-\176]/;
      if ( !$fl->{spam} && ( $enchr && ( $in->{mail} ne '' && $in->{url} ne '' ) ||
           $url_count > 6 ) || $url_count > 10 )
        { $fl->{spam} = 1 }
    }
  }
  $bn->call( 'CheckFilterSpam' );
  delete $gl->{get_url_addr};
  push @$err, $bn->info( 'CHECK_FILTER_SPAM' ) if $fl->{spam};
}

sub get_url_addr {
  my( $po, $s ) = @_;
  my( %url_addr, $buf_esc, $buf_url, $buf_raw, $f_esc, $f_raw, $f_url );
  return \%url_addr if index( $s, 'http://' ) == -1;
  my $add = sub {
    return if length $_[1] < 8 || $_[1] =~ /\.(?:jpg|png|gif|swf|php)$/;
    $_[0]->{$_[1]}++ };
  $s =~ s/&lt;/</g;
  my $pos = 0;
  my $len = length $s;

  while ( $pos < $len ) {
    my $t = substr $s, $pos, 1;
    if ( $f_esc ) {
      if ( $t eq '>' ) {


        $buf_esc =~ s/&nbsp;/ /g;
        $buf_esc =~ s/^ //; chomp $buf_esc;
        my( %elm, $e_pos, $e_key, $e_sep, $e_val );
        my $e_flag = 0;
        my $e_len = length $buf_esc;
        while ( $e_pos < $e_len ) {
          my $s = substr $buf_esc, $e_pos, 1;
          $e_pos++;
          if( $e_flag == 0 ) {
            if ( $s eq '=' ) { $e_flag = defined $e_key ? 1 : -1 }
             else { $e_key .= $s }
          } elsif( $e_flag == 1 ) {
            if ( $s =~ /['"]/ ) { $e_sep = $s }
             else { undef $e_sep; $e_val .= $s }
            $e_flag = 2;
          } elsif( $e_flag == 2 ) {
            if ( defined $e_sep ) {
              if ( $s eq $e_sep ) { $e_flag = 3 }
               else { $e_val .= $s }
            } else {
              if ( $s =~ /[\s'"]/ ) { $e_flag = 3 }
               else { $e_val .= $s }
            }
          }
          if ( $e_flag == 3 ) {
            $e_key =~ s/\s//g;
            $elm{lc $e_key} = $e_val;
            undef $e_key; undef $e_val; $e_flag = 0;
          }
        }
        if ( $e_flag == 2 && defined $e_key ) {
          $e_key =~ s/\s//g;
          $elm{lc $e_key} = $e_val;
        }
        &$add( \%url_addr, $elm{href} ) if exists $elm{href};
        undef $buf_esc;
        $f_esc = 0; $f_url = 8;
        $pos++; next;
      }
      $buf_esc .= $t;
    } elsif ( $f_raw ) {
      if ( $t =~ /[-\.!~*\w;\/?:\@&=+\$,%#]/ ) {
        $buf_url .= $t;
      } else {
        &$add( \%url_addr, $buf_url ) if defined $buf_url && !( $f_url && exists $url_addr{$buf_url} );
        $f_raw = $f_url = 0;
      }
    } else {
      if ( $t eq '<' ) {
        $t = substr $s, ++$pos, 7;
        $f_esc = 1 if $t =~ /^a(?: |&nbsp;)/i;
      } else {
        $buf_raw .= $t;
        $f_url-- if $f_url;
        if ( $buf_raw =~ m#(http://)$# ) {
          undef $buf_raw;
          $buf_url = $1;
          $f_raw = 1;
        }
      }
    }
    $pos++;
  }
  &$add( \%url_addr, $buf_url ) if $f_raw && defined $buf_url;
  return \%url_addr;
}

sub check_history {
  my $po = shift;
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my $sys = $bn->{sys};
  my $gl = $bn->{global};
  my $mode = $sys->{MODE};

  my $path = $sys->{DirSys} . '/history.' . $sys->{Exe};
  my $log = $bn->get( $cf, 'LimitPostMultiLog' );
  my $history = $bn->get( $cf, 'LimitPostMultiHistory' );

  my $fh = -e $path ? $bn->open( $path ) : $bn->open( $path, '>' );
  $fh or $bn->error( 'ERR_SYS_NOTWRITE', $path );
  $bn->{temp}{fh}{history} = $fh;

  my $h = $bn->get( $cf, 'LimitPostMulti' );
  my %ch;
  for ( @$h ){
    undef %ch;
    for ( split /\;/ ) { my @b = split /:/; $ch{$b[0]} = $b[1] if $b[1] }
    if ( exists $ch{mode} && $mode =~ /$ch{mode}/ )
     { delete $ch{mode}; last }
  }

  my %in_buf;
  for ( keys %$in ) {
    $in_buf{$_} = $in->{$_};
    $in_buf{$_} =~ s/([\t\n\r\=])/sprintf("%%%02X", unpack("C", $1))/eg;
  }
  $in_buf{num} = $in->{log} if exists $in->{log} && !exists $in->{num};

  my $checked;
  while ( <$fh> ) {
    chomp; my %data;
    for (split /\t/) { my @v = split /=/; $data{$v[0]} = $v[1] }
    $data{num} = $data{log} if exists $data{log} && !exists $data{num};
    if ( $data{mode} =~ /$mode/ ) {
      my( $i, $n ); $checked++;
      for ( keys %ch ) {
        next if !exists $data{$_};
        $n++;
        if ( $_ eq 'time' && $ch{$_} ) {
          $i++ if ( $data{$_} + $ch{$_} ) > time;
        } elsif( $_ eq 'ip' ) {
          $i++ if $data{$_} ne '' && $data{$_} eq $gl->{IP};
        } else {
          $i++ if $data{$_} ne '' && $data{$_} eq $in_buf{$_};
        }
      }
      $bn->error('ERR_MULTIPLEPOST') if $n && $i >= $n;
    }
    last if $checked >= $history;
  }
  delete $bn->{temp}{fh}{history};
  close $fh;
}

sub check_auth {
  my($po, $val, $pass) = @_;
  my $fl = $bn->{flag};

  $fl->{AUTHORITY} = undef;
  $bn->check_authority( $pass ? $pass : $bn->{in}{password} );
  return 1 if $val == 3;
  if ($val == 2) {
    return 1 if $fl->{AUTHORITY} =~ /ADMIN|SUB/;
    return 0;
  }
  if ($val == 1) {
    return 1 if $fl->{AUTHORITY} eq 'ADMIN';
    return 0;
  }
}

sub check_locked {
  my $po = shift;
  my $cf  = $bn->{cfg};
  return unless $bn->get($cf, 'UseThreadLock');

  my $log_file = $bn->filelog(unpack 'S', $_[0]);
  if (-e $log_file) {
    my $fh = $bn->open($log_file);
    $fh or $bn->error('ERR_DATA_NOTOPEN',$log_file);
    $_ = <$fh>;
    close $fh;
    my $val = {}; my $ex = {};
    $bn->get_log_main_value($_, $val, $ex);
    return 1 if $ex->{thread_lock};
  }
  return 0;
}

sub check_error {
  my( $po, $err ) = @_;
  my $in = $bn->{in};
  if (@$err) {
    my $errorstr;
    my $errormark = join '', $bn->info('ERR_MARK');
    $errormark ||= '&gt;';
    if ($bn->{flag}{PAINT_CAPTOR}) {
      map{$errorstr.="$errormark$_\n"}@$err;
      $bn->end('PAINT_POST','',$errorstr);
    } else {
      $bn->call('CheckInputError');
      map{$errorstr.="$errormark$_<br>"}@$err;
      $in->{no} = $in->{log} unless $in->{no};
      $bn->end('DEFAULTPOST', $bn->info('CHECK_POSTERROR', $errorstr));
    }
  }
}

sub file_analyze {
  my $po = shift;
  my $cf = $bn->{cfg};
  my $gl = $bn->{global};
  my $fl = $gl->{file} = {};
  my $data = $gl->{data} = $_[0];

  my $data_length = length $$data;
  return (0,0,0,0) unless $data_length;

  $fl->{width} = 0;
  $fl->{height} = 0;
  undef $fl->{mime};

  my $type = $bn->{in}{'file_Content-Type'};
  my $filename = $bn->{in}{'file_filename'};
  my $exe = $filename =~ /\.(\w+)/ ? lc $1 : '';

  # GIF
  if ($$data =~ /^GIF\d\d[a-z](.)(.)(.)(.).+/s) {
    $fl->{mime} = 'gif';
    $fl->{width}  = ord($2)*256 + ord($1);
    $fl->{height} = ord($4)*256 + ord($3);
  # PNG
  } elsif($$data =~ /^\x89\x50\x4E\x47\r\n\x1A\n.{10}(.)(.)..(.)(.).+/s) {
    $fl->{mime} = 'png';
    $fl->{width}  = ord($1)*256 + ord($2);
    $fl->{height} = ord($3)*256 + ord($4);
  # JPG
#  } elsif($$data =~ /^\xFF\xD8\xFF(\xE0|\xE1|\xC4).+/) {
  } elsif($$data =~ /^\xFF\xD8.+/) {
    $fl->{mime} = 'jpg';
    my $pos = 2;
    while () {
      my $jhead = substr($$data, $pos, 9);
      if ($jhead =~ /\xff(.)(.)(.)(.?)(.?)(.?)(.?)(.?)/s) {
        if ($1 eq "\xc0" || $1 eq "\xc1" || $1 eq "\xc2") {
          $fl->{width}  = ord($7) * 256 + ord($8);
          $fl->{height} = ord($5) * 256 + ord($6);
          last;
        } else {
          $pos += ord($2) * 256 + ord($3) + 2;
        }
      } else {
        $fl->{width}  = 0;
        $fl->{height} = 0;
        last;
      }
    }
  # TXT
  } elsif ($bn->get($cf, 'UseFileExText') && ($type eq 'text/plain' || $exe eq 'txt')) {
    $fl->{mime} = 'txt';

  # BMP
  } elsif ($bn->get($cf, 'UseFileExBmp') && $$data =~ /^BM(....)....(....)(....)/s ) {
    $fl->{mime} = 'bmp';
    my $file_size = unpack "L",$1;
    my $offbits = unpack "L",$2;
    my $header_byte = unpack "L",$3;
    my($bm_type,$width,$height,$bitcount,$compression);
    if ($header_byte == 40) {
      $bm_type = 'Windows';
      $fl->{width} = unpack "L",(substr $$data,18,4);
      $fl->{height} = unpack "L",(substr $$data,22,4);
      $bitcount = unpack "S",(substr $$data,28,2);
      $compression = unpack "L",(substr $$data,30,4);
    } elsif($header_byte == 12) {
      $bm_type = 'OS2';
      $fl->{width} = unpack "S",(substr $$data,18,2);
      $fl->{height} = unpack "S",(substr $$data,20,2);
      $bitcount = unpack "S",(substr $$data,24,2);
    }
    $gl->{LogExValue}{file_info} = "Type $bm_type/$bitcount bit".($compression?'/RLE':'');

  # MIDI
  } elsif ($bn->get($cf, 'UseFileExMidi') && $$data =~ /^MThd\x00\x00\x00\x06(..)(..)/s ) {
    $fl->{mime} = 'mid';
    my $format = unpack "S",$1;
    my $track = unpack "S",$2;
    my $p = index $$data, "\xFF\x03";
    if ($p) {
      my $len = unpack "C",(substr $$data,$p+2,1);
      my $s = substr $$data,$p+3,$len;
      $gl->{LogExValue}{file_info} = $s;
    }
  # SWF
  } elsif ($bn->get($cf, 'UseFileExSwf') && $$data =~ /^FWS(.)/s){
    $fl->{mime} = 'swf';
    my $version = unpack "C",$1;
    $gl->{LogExValue}{file_info} = "Flash $version File";
    $bn->set_call('OpenPageBegin', sub{
       $bn->pm->open_anime_size }
    );
  # ZIP
  } elsif($bn->get($cf, 'UseFileExZip') && $$data =~ /^PK\x03\x04/s){
    $fl->{mime} = 'zip';
  # LZH
  }elsif($bn->get($cf, 'UseFileExLzh') && $$data =~ /^..\x2D\x6C\x68.\x2D/s){
    $fl->{mime} = 'lzh';
  }

  $bn->call('FileAnalyzeInit');

  if (!$fl->{mime}) { delete $gl->{file}; return ('', 0, 0, $data_length) }

  $bn->call('FileAnalyzeEnd');
  my @r = ($fl->{mime}, $fl->{width}, $fl->{height}, $data_length);
  delete $gl->{file};
  return @r;
}


sub escape_input {
  my( $po, $f, @v ) = @_;
  for (@v) {
    if ( $f == 1 ) {
      1 while $$_ =~ s/^(\w+\:\/+)//o;
      $$_ =~ s/( |\x81\x40)//go;
    } else {
      $bn->convert( $_, $bn->{sys}{Charset} );
    }
    if ( $f < 3 ) {
      $$_ =~ s/\&(?!hearts\;|nbsp\;|\#\w+\;)/\&amp\;/go;
      $$_ =~ s/</\&lt\;/go;
    }
    if ( $f != 2 ) {
      $$_ =~ s/"/&#34;/go;
      $$_ =~ s/'/&#39;/go;
    }
  }
}

sub convert_message {
  my $po = shift;
  my $cf = $bn->{cfg};
  my $gl = $bn->{global};
  my $err = $gl->{error};
  $gl->{Message} = $_[0];

  $bn->call('ConvertMessageInit');

  # CR, LF -> \n
  $gl->{Message} =~ s/\x0D\x0A/\n/go;
  $gl->{Message} =~ s/\x0D/\n/go;
  $gl->{Message} =~ s/\x0A/\n/go;

  $bn->call('ConvertMessageBegin');

  # allowed tags
  my $errstr;
  my $flag_all_tags = $po->check_auth($bn->get($cf, 'UseAllTag'));
  if($flag_all_tags){
    $po->convert_tag(\$gl->{Message}, $bn->get($cf, 'OkTag'), $flag_all_tags);
  } else {
    $gl->{Message} =~ s/ /&nbsp;/go;
    $gl->{Message} =~ s/\t/&nbsp;&nbsp;&nbsp;&nbsp;/go;
    push @$err, $bn->info('CHECK_TAG',$errstr)
      if $bn->get($cf, 'UseTag') && ( $errstr = $po->convert_tag(\$gl->{Message}, $bn->get($cf, 'OkTag')) );
    # auto link
    $bn->call('ConvertMessageAutoLink');
    if ($bn->get($cf, 'UseAutoLinkUrl')) {$gl->{Message} =~ s/(https?:\/\/)([-.!~*'()\w;\/?:\@&=+\$,%#]+)/$po->convert_uri($1,$2)/eg}
    if ($bn->get($cf, 'UseAutoLinkMail')) {$gl->{Message} =~ s/mailto:([\w\.\?\#\_\:\;\/\%\&\$\"\!\'\(\)\=\~\^\-\+\|\@]*)/<A HREF="mailto:$1" target="_blank" class="autolinkmail" rel="nofollow">$1<\/A class="autolinkmail">/ig}
    $gl->{Message}  =~ s/(https?)%3A/$1:/g;
  }
  $gl->{Message} =~ s/\&amp;(lt|gt|quot);/\&$1;/g;


  # quotation
  if ($bn->get($cf, 'UseQuotation')) {
    $bn->call('ConvertMessageQuotation');
    my $m;
    my $link = sub{
      my($h,$q,$s,$e) = @_;
      if($q eq '>' && $s =~ />([\d\,\-]+)(:\d+)?/){
        my $num = $1;
        my $res = $2 =~ /(\d+)$/ ? '&res='. $1 : '';
        return $h.'<A href="'. $bn->get($cf, 'BBSNoteUrl') . "?fc=thread&log=$num".$res.'" id="threadjump" class="quot">'.$q.$s.'</A id="threadjump" class="quot">'.$e
      }else{
        return $h.'<SPAN class="quot">'.$q.$s.'</SPAN class="quot">'.$e
      }
    };
    for($m=0; $m<2; $m++){$gl->{Message} =~ s/(^|\n)([>#]|\x81\x84+)(.+)(\n|$)/&$link($1,$2,$3,$4)/eg}
  }

  $bn->call('ConvertMessageLineCheck');

  # line count check
  my $line = $bn->{in}{nobr} ? ($gl->{Message} =~ s/\n/<!br>/img) : ($gl->{Message} =~ s/\n/<BR>/img);
#  my $line = ($gl->{Message} =~ s/\n/<BR>/img);
  if ($bn->get($cf, 'LimitLine') < $line) {
    push @$err, $bn->info('CHECK_MESSAGELINEOVER', $line, $bn->get($cf, 'LimitLine'))
  }

  $po->check_error($err);

  $bn->call('ConvertMessageEnd');

  return $gl->{Message};


}

sub convert_tag {
  my($po, $str, $tag, $tag_all) = @_;
  my(%ok_tags, %check_tag);

  unless ($tag_all) {
    my @tags = ref $tag eq 'ARRAY' ? @$tag :
    ref $tag eq 'SCALAR' ? split ',', $$tag : split ',', $tag;
    $ok_tags{br}{noclose} = 1; $ok_tags{p}{noclose} = 1;
    for (@tags) {
      my($name, @element) = split /:/;
      $name = lc $name;
      $ok_tags{$name} = {};
      for (@element) { $ok_tags{$name}{lc $_} = 1 }
    }
    if (exists $ok_tags{font}) { my $f = $ok_tags{font};
      unless (keys %$f) { $f->{size} = 1; $f->{color} = 1; $f->{face} = 1 }
    }
    if (exists $ok_tags{div}) { my $f = $ok_tags{div}; unless (keys %$f) { $f->{align} = 1} }
    if (exists $ok_tags{img}) { $ok_tags{img}{noclose} = 1 }
  }

  while ($$str =~ /&lt;(\/)?(\w+)/g) {
    my $slash = $1;
    my $tag = lc $2;
    my $s = pos $$str;
    if ($tag_all || exists $ok_tags{$tag}) {
      my($element, $end_pos) = $po->_get_element($str);
      my @el;
      last unless $end_pos;
      unless ($tag_all) {
        $slash ? $check_tag{$tag}-- : $check_tag{$tag}++;
        for (keys %$element) { push @el, defined $element->{$_} ? qq/$_="$element->{$_}"/ : $_ if exists $ok_tags{$tag}{$_}}
      } else {
        for (keys %$element) { push @el, defined $element->{$_} ? qq/$_="$element->{$_}"/ : $_ }
      }
      my $e = join ' ', "<$slash$tag", @el;
      my $st = $s - (length $tag) - (length $slash) - 4;
      my $st_str = substr $$str, 0, $st if $st;
      my $ed_str = substr $$str, $end_pos -1;
      $$str = $st_str . $e . $ed_str;
      pos $$str = $st + length $e + 1
    }
  }

  unless ($tag_all) {
    my $errstr;
    for my $tag(keys %check_tag) {
      if (!exists $ok_tags{$tag}{noclose} && $check_tag{$tag} != 0) {
        my $s = join '', $check_tag{$tag} , $bn->info('CHECK_TAGPOINT') if $check_tag{$tag} > 1;
        $errstr .= "&lt;$tag&gt;$s ";
      }
    }
    return $errstr if $errstr;
  } else {
    my $p = 0;
    while ($p > -1) {
      $p = index $$str, '&lt;!--', $p;
      last unless $p > -1;
      my $e = index $$str, '-->', $p + 7;
      last unless $e;
      my $s = substr $$str, 0, $p;
      $$str = $s . '<' . substr $$str, $p + 4;
      $p = $e - 3;
    }
  }

  return 0;
}

sub _get_element {
  my($po, $str) = @_;
  my $len = length $$str;
  my(@elments, $elment_alias, $i, $buf , $alias_mark, $alias_hit, $alias_end);

  for ($i = pos $$str ; $i < $len; $i++) {
    $_ = substr $$str, $i, 1;
    if (!$elment_alias && ($_ eq ' ' || $buf =~ /&nbsp$/ && $_ eq ';') ) {
      $buf =~ s/(?:&nbsp| )$//;
      push @elments, $buf if $buf ne '' && !$alias_end;
      undef $buf;
      $alias_end = 1;
    } elsif (!$alias_mark && />/) {
      $i++;
      $buf =~ s/(?:&nbsp| )$//;
      push @elments, $buf if $buf ne '' && !$alias_end;
      last;
    } else {
      if (/$alias_mark/ && $buf !~ /\\$/) {
        $elment_alias = 0;
        $alias_mark = undef;
        push @elments, $buf if $buf ne '' && !$alias_end;
        undef $buf;
        next;
      }
      if ($alias_hit) {
        $alias_hit = 0;
        if (/('|")/ && $buf !~ /\\$/) {
          $alias_mark = $1;
          next;
        } else {
          $elment_alias = 0;
          $buf .= $_;
        }
      } else {
        $buf .= $_ unless /\s/ && !$alias_mark;
        if (/=/ && !$elment_alias){
          $elment_alias = 1;
          $alias_hit = 1;
        }
        $alias_end = 0;
      }
    }
  }
  return (0,0) unless (substr $$str, $i-1, 1) eq '>';

  my %element;
  for (@elments) {
    my($name, $val) = split /=/, $_, 2;
    $name = lc $name;
    $element{$name} = $val;
  }
  return (\%element, $i);

}

sub convert_uri {
  my($po, $prot, $uri) = @_;
  my $gl = $bn->{global};

  # under perl 5.004 fix
  my $q = substr $`, -1, 1;
  my $w = substr $', 0, 1;

  return $prot.$uri if $q =~ /\"|\'/ && $q eq $w;

  $uri =~ s/\&quot\;/\%22/g;
  my $e = '&lt;' . $2 if $uri =~ s/([-.!~*'()\w;\/?:\@&=+\$,%#]+)\&lt\;(.+)/$1/g;
  $e .= '"' if $uri=~s/\%22$//;
  return '<A href="' . $prot . $uri . '" target="_blank" class="autolinkurl" rel="nofollow">' . $prot . $uri . '</A class="autolinkurl">' . $e;
}

sub write_files {
  my($po, $r) = @_;
  if (ref $r eq 'HASH') {
    for (keys %$r) {
      my $h = $r->{$_};
      if (ref $h eq 'HASH' && exists $h->{path} && $h->{size} > 0) {
        my $fh = $bn->open($h->{path}, '>');
        binmode $fh;
        print $fh ref $h->{data} eq 'SCALAR' ? ${$h->{data}} : $h->{data};
        close $fh;
        $bn->{flag}{WriteFiles}{$h->{path}} = $h->{size};
      }
    }
  }
}

sub write_log_value {
  my($po, $logfile, $val, $ex) = @_;
  my $cf = $bn->{cfg};
  my $gl = $bn->{global};
  my $sys = $bn->{sys};

  my $add_format = join"\b",(map{
    $$ex{$_}=~s/\x08|\n//go;
    "$_=$$ex{$_}";
  }grep{$$ex{$_}ne''}keys %$ex);

  $add_format =~ s/\x08$//;

  map{$$val{$_}=~s/\t|\n//go}keys %$val;
  undef $gl->{Format};
  if ($sys->{MODE} =~ /WRITE/) {
    my $fh;
    if ($sys->{MODE} =~ /POST/ || !-e $logfile) {
      $fh = $bn->open($logfile, '>');
      $fh or $bn->error('BAD_WRITE', $logfile);
      $gl->{Format} = join "\t",@$val{$bn->LOG_MAIN_VALUE}, $add_format;
    } elsif($sys->{MODE} =~ /REPLY/) {
      if ($bn->get($cf, 'UseTree')) {
        $po->write_child($logfile, $val, $ex);
        return;
      } else {
        $fh = $bn->open($logfile, '>>');
        $fh  or $bn->error('BAD_WRITE',$logfile);
        $gl->{Format} = join "\t",@$val{$bn->LOG_REPLY_VALUE}, $add_format;
      }
    }
    $bn->call('WriteLogValuePrint');
    print $fh $gl->{Format} ."\n" if $gl->{Format};
    close $fh;

  } elsif($sys->{MODE} =~ /EDIT/) {
    my $fh = $bn->open($logfile);
    $fh or $bn->error('ERR_DATA_NOTOPEN', $logfile);
    my @data;
    while (<$fh>) { push @data, $_ }
    close $fh;
    $gl->{Data} = \@data;

    $fh = $bn->open($logfile, '>');
    $fh or $bn->error('BAD_WRITE', $logfile);

    if ($sys->{MODE} =~ /POST/) {
      $gl->{Format} = join "\t",@$val{$bn->LOG_MAIN_VALUE}, $add_format;
      $bn->call('WriteLogValuePrint');
      $data[0] = $gl->{Format} . "\n";
      for (@data) { print $fh $_ }
    } elsif($sys->{MODE} =~ /REPLY/) {
      $gl->{Format} = join "\t",@$val{$bn->LOG_REPLY_VALUE}, $add_format;
      for (@data) {
        if (/^(\d+)/ && $$val{num} eq $1) {
          print $fh $gl->{Format} . "\n";
          next;
        }
        print $fh $_;
      }
    }
    delete $gl->{Data};
    close $fh;
  }
  delete $gl->{Format};

  chmod oct $bn->get($cf, 'Permission'), $logfile;
}

sub write_child {
  my($po, $logfile, $val, $ex) = @_;
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my $gl = $bn->{global};
  my $sys = $bn->{sys};

  my $fh = $bn->open($logfile);
  $fh or $bn->error('ERR_DATA_NOTOPEN', $logfile);
  my(%tree, @data, $date, $res_num, $final, $flag, $back_no);
  while ( <$fh> ) {
    unless (exists $in->{num}) {
      my($num, $name, $date) = split /\t/, $_, 4;
      $date = sprintf "%04d%02d%02d%02d%02d%02d:%08d", $1,$2,$3,$4,$5,$6?$6:0,$num
          if $date =~ m#(\d+)/(\d+)/(\d+) \(\w+\) (\d+):(\d+):?(\d+)?#;
        $res_num = $date if $date gt $res_num;
    }
    push @data, $_;
  }
  my $num = exists $in->{num} ? $in->{num} : int((split /:/,$res_num, 2)[1]);
  $ex->{tree} = $num;
  close $fh;

  my $values = sub {
    my $add_format = join"\b",(map{
    $$ex{$_}=~s/\x08|\n//go;
    "$_=$$ex{$_}";
    }grep{$$ex{$_}ne''}keys %$ex);
    $add_format =~ s/\x08$//;
    return join "\t", @$val{$bn->LOG_REPLY_VALUE}, $add_format;
  };

  $fh = $bn->open($logfile, '>');
  $fh or $bn->error('BAD_WRITE', $logfile);

  for (my $n = 0; $n <= $#data; $n++) {
    unless ($final) {
      my $v = {}; my $e = {};
      $n ? $bn->get_log_reply_value($data[$n], $v, $e):
        $bn->get_log_main_value($data[0], $v, $e);
      $e->{tree} = $back_no unless exists $e->{tree};

      if ($flag) {
        my $t = $e->{tree};
        while ($t ne $num) {
          $t = $tree{$t};
          if ($t eq '') {
            print $fh (&$values)."\n";
            $final = 1;
            last;
          }
        }
      }

      $flag = 1 if $v->{num} eq $num;
      $tree{$v->{num}} = $e->{tree};
      $back_no = $v->{num};
    }
    print $fh $data[$n];
  }
  print $fh (&$values)."\n" unless $final;
  close $fh;

}

sub write_history {
  my $po = shift;
  my $cf = $bn->{cfg};
  my $gl = $bn->{global};
  my $data = $bn->{data} = $_[0];

  my $path = $bn->{sys}{DirSys} . '/history.' . $bn->{sys}{Exe};
  my $log = $bn->get($cf, 'LimitPostMultiLog');
  my $history = $bn->get($cf, 'LimitPostMultiHistory');

  $bn->error('ERR_SYS_NOTWRITE',$path) unless -w $path;

  my $fh = -e $path ? $bn->open($path) : $bn->open($path, '>');
  $fh or $bn->error('ERR_SYS_NOTWRITE', $path);
  $bn->{temp}{fh}{history} = $fh;

  $bn->call('WriteHistoryBegin');

  my($fh_tmp, $tmp) = $bn->get_temp_file;

  print $fh_tmp join "\t",map{
    my($name, $val) = ($_, $data->{$_});
    $name =~ s/([\t\n\r\=])/sprintf("%%%02X", unpack("C", $1))/eg;
    $val =~ s/([\t\n\r\=])/sprintf("%%%02X", unpack("C", $1))/eg;
    "$name=$val";
  }grep $data->{$_},keys %$data;
  print $fh_tmp "\n";

  my $i = 1;
  while (<$fh>) {
    $i++;
    last if $i > $log;
    print $fh_tmp $_;
  }

  close $fh_tmp; close $fh;
  delete $bn->{temp}{fh}{history};

  rename $tmp, $path
    or unlink $tmp && $bn->error('ERR_SYS_NOTWRITE', $path);

  $bn->call('WriteHistoryEnd');

}

sub set_sys_item {
  my($po, $item, $val) = @_;
  $bn->error('ERR_SYS_NOTITEM') unless $item;
  my $path = "$bn->{sys}{DirSys}/$item.$bn->{sys}{Exe}";
  unless (-e $path) { my $fh = $bn->open($path, '>'); close $fh }
    $bn->error('ERR_SYS_NOTWRITE', $path) unless -w $path;
  my($fh, $tmp) = $bn->get_temp_file;
  print $fh $val;
  close $fh;
  rename $tmp, $path
    or unlink $tmp && $bn->error('ERR_SYS_NOTWRITE', $path);
}

sub get_sys_item {
  my($po, $item, $val) = @_;
  my $path = "$bn->{sys}{DirSys}/$item.$bn->{sys}{Exe}";
  return 0 unless -e $path;
  my $s;
  my $fh = $bn->open($path);
  $fh or $bn->error('ERR_SYS_NOTOPEN', $path);
  read $fh, $s, -s $path;
  close $fh;
  $$val = $s;
  return 1;
}

sub add_index {
# /* under filelock */
  # try_count : auto recover try count
  my($po, $num, $try_count ) = @_;
  my $ap = $po->{ap};
  my $cf = $bn->{cfg};
  my $gl = $bn->{global};
  my $sys = $bn->{sys};

  my( $i, $s, $list, @del_no );
  my $path = "$sys->{DirSys}/index.$sys->{Exe}";
  my $bin = pack 'S', $num;
  my($fh_tmp, $tmp) = $bn->get_temp_file;
  my $fh_index = $bn->open_index;
  my $total = $bn->{sys}{index}{total};
  my $log_max = $bn->get($cf, 'LogMax');
  my $max = $total + 1 > $log_max ? $log_max : $total + 1;
  binmode $fh_tmp;

  if ( $total >= $log_max ) {
    my $t = $total;
    my $p = $bn->get($cf, 'LimitLogRemoved') ? 1 : 0;
    my $pmax = $t * 2 * $p;
    $p = ( 2 * $p + 2 ) * $t - 2;
    while ( $t >= $log_max && $p >= $pmax ) {
      seek $fh_index, $p, 0;
      read $fh_index, $s, 2;
      unless ( $po->check_locked( $s ) ) {
        push @del_no, $s;
        $t--;
      }
      $p -= 2;
    }
    $bn->error('ERR_SYS_LOCKEDINDEX') if $t >= $log_max;
  }

  print $fh_tmp $bin;

  $i = 1;
  seek $fh_index, 0, 0;
  POSTLOOP:while ( read $fh_index, $s, 2 ) {
    $i++;
    for ( @del_no ) { $i-- && next POSTLOOP if $_ eq $s }
    last if $i > $max;
    print $fh_tmp $s;
  }
  $i = 1;

  seek $fh_tmp, 2, 0;
  my $b;
  my $read_byte = ( $max - 1 ) * 2;
  while ( my $byte = read $fh_tmp, $b, ( $read_byte < 80000 ? $read_byte : 80000 ) )
   { $list .= $b; $read_byte -= $byte }
  undef $b;
  seek $fh_tmp, 0, 2;
  print $fh_tmp $bin;

  if ( $max > 1 ) {
    $i = 1;
    seek $fh_index, $total << 1, 0;
    SORTLOOP:while ( read $fh_index, $s, 2 ) {
      $i++;
      my $f;
      for ( @del_no ) { $i-- and $f = 1 and next SORTLOOP if $_ eq $s }

      print $fh_tmp $s;
      my $no;
      for ( my $n = 0; $n <= (length $list) >> 1; $n++ ) {
       $no = $max - $n -1 and last if ( $s eq substr $list, $n << 1, 2 ) }
      if ( $no ) {
        seek $fh_tmp, $max * 2 - 2, 1;
        print $fh_tmp pack 'S', $no;
        seek $fh_tmp, $max * -2, 1;
      } else {
        $bn->close_index;
        close $fh_tmp;
        unlink $tmp;
        # system index broken
        if ( $try_count ) {
          $bn->warn("add_index : system index broken. auto recover \(try $try_count\) $ENV{SCRIPT_FILENAME}");
          $bn->ad->recover_sys_index_silent;
          return $po->add_index( $num, --$try_count );
        } else {
          $bn->warn("add_index : system index broken. Fatal Damage ! $ENV{SCRIPT_FILENAME}");
          $bn->error('ERR_SYS_BROKENINDEX');
        }
      }
      last if $i >= $max;
    }
  }

  seek $fh_tmp, $max << 2, 0;
  print $fh_tmp pack 'S', $max;
  close $fh_tmp;
  $bn->close_index;

  my $try = 10;
  while( ! rename $tmp, $path ) {
    if ( $try-- ) {
      select undef, undef, undef, 0.5;
      next;
    } else {
      unlink $tmp;
      $bn->error( 'ERR_SYS_NOTWRITE', $path );
    }
  }

  if ( @del_no ) {
    $gl->{purge_logs} = [];
    for ( @del_no ) { push @{$gl->{purge_logs}}, unpack 'S', $_ }
    $bn->call('PurgeLogs');
    for ( @{$gl->{purge_logs}} ) { $ap->delete_log_main( $_ ) }
  }

  return 1;
}

sub reply_index {
# /* under filelock */
  # try_count : auto recover try count
  my($po, $num, $try_count) = @_;
  my $gl = $bn->{global};
  my($i, $s, $no, $list);
  my $bin = pack 'S', $num;
  my $path = "$bn->{sys}{DirSys}/index.$bn->{sys}{Exe}";
  my $fh_index = $bn->open_index;
  my $total = $bn->{sys}{index}{total};

  seek $fh_index, $total * 2, 0;
  read $fh_index, $s, 2;

  if ($s eq $bin) {
    $bn->close_index;
    utime time, time, $path;
    return 0
  }

  my($fh_tmp, $tmp) = $bn->get_temp_file;
  binmode $fh_tmp;

  seek $fh_index, 0, 0;
  read $fh_index, $list, $total * 2;
  print $fh_tmp $list.$bin;

  while ( read $fh_index, $s, 2 ) {
    $i++;
    last if $i > $total;
    next if $s eq $bin;

    print $fh_tmp $s;
    for (my $n = 0; $n < $total; $n++) {
      if ($s eq substr $list,$n*2,2) {
        $no = $total - $n;
        last;
      }
    }
    if ($no) {
      seek $fh_tmp, $total * 2 - 2 , 1;
      print $fh_tmp pack 'S', $no;
      seek $fh_tmp, $total * -2, 1;
    } else {
      $bn->close_index;
      close $fh_tmp;
      unlink $tmp;
      # system index broken
      if ( $try_count ) {
        $bn->warn("reply_index : system index broken. auto recover \(try $try_count\) $ENV{SCRIPT_FILENAME}");
        $bn->ad->recover_sys_index_silent;
        return $po->reply_index($num, --$try_count);
      } else {
        $bn->warn("reply_index : system index broken. Fatal Damage ! $ENV{SCRIPT_FILENAME}");
        $bn->error('ERR_SYS_BROKENINDEX');
      }
    }
  }

  for (my $n = 0; $n < $total; $n++) {
    if ($bin eq substr $list, $n * 2, 2) {
      $no = $total - $n;
      last;
    }
  }
  if ($no) {
    seek $fh_tmp, $total << 2, 0;
    print $fh_tmp pack 'S', $no;
  } else {
    $bn->warn("reply_index : system index broken. Fatal Damage ! $ENV{SCRIPT_FILENAME}");
    $bn->error('ERR_SYS_BROKENINDEX');
  }
  close $fh_tmp;
  $bn->close_index;

  my $try = 10;
  while( ! rename $tmp, $path ) {
    if ( $try-- ) {
      select undef, undef, undef, 0.5;
      next;
    } else {
      unlink $tmp;
      $bn->error( 'ERR_SYS_NOTWRITE', $path );
    }
  }

  return 1;
}

sub set_filename {
  my($po, $h, $ih, $num, $inc) = @_;
  my $cf = $bn->{cfg};
  my $gl = $bn->{global};
  my $mo = $bn->{module};
  return unless $h->{size};
  $ih = $bn->get($cf, 'FileHeadImage') unless $ih;
  $num = $gl->{count}{log} unless $num;
  my @mime = ($bn->get($cf, 'ConfigShiPainter')->{anime_ext},
    $bn->get($cf, 'ConfigShiPaintBBS')->{anime_ext}) if exists $mo->{Paint};

  my $head = (grep $h->{mime} eq $_, @mime) ? $bn->get($cf, 'FileHeadAnime') :
  (grep $h->{mime} eq $_, qw/jpg gif png bmp/) ? $ih : $bn->get($cf, 'FileHeadObject');
  $h->{path} = $bn->filelog($num, $head, $h->{mime}, $inc);
  $h->{filename} = $1 if $h->{path} =~ m#([^/\\]+)$#;
}

sub get_count {
  my($po, $ref) = @_;
  my $l_count;
  $po->get_sys_item('count', \$l_count) or $l_count = "0\t0";
  @$ref{'log','num','obj'} = split /\t/, $l_count;
  $$ref{log} = 0 if $$ref{log} > 65025;
  $$ref{num} = 0 if $$ref{num} > 65025;
}

sub default_post {
  my($po, $errorstr) = @_;
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my $sk = $bn->{skin};
  my $gl = $bn->{global};
  $bn->call('ErrDefaultPostInit');

  $bn->set($cf, 'UseTree', 0);
  $bn->set_call('PostFormInitBegin',sub{
    my @v = qw/fc mode sort page name mail url title message password/;
    @{$gl->{value}}{@v} = @{$in}{@v};
    if(exists $in->{edit}){
      $in->{number} = $in->{log};
      $in->{number} .= '-' . $in->{edit} if $in->{edit} ne '';
      $bn->{arg}{PostForm}{edit} = $in->{edit};
      $bn->{arg}{PostForm}{checkpass} = $in->{checkpass};
    }
  });
  $bn->set_call('PostFormInitEnd',sub{
    $sk->{form}{info} = [[
      [ { TAG => 'TD', colspan => '*', align => 'center', nowrap => 1 } ],
      [ { string => $errorstr } ]
    ]];
    $bn->set_form($sk->{form}{FORMS}, $sk->{form}{info}, 'insert', 'name');
  });

  $bn->open_post;

  $bn->EXIT;
}

sub mail_notice {
  my $in = $bn->{in};
  my $gl = $bn->{global};
  my $cf = $bn->{cfg};
  my $sys = $bn->{sys};
  my $data = {};
  my $mode = $bn->{sys}{MODE};
  my @send_addr;

  if ($bn->get($cf, 'UseNoticeMail') && $mode eq 'WRITE_REPLY') {
    my $fh = $bn->open($gl->{LogFile});
    $fh or $bn->error('ERR_DATA_NOTOPEN', $gl->{LogFile});
    my $n = 0;
    while (<$fh>) {
      my $val = {}; my $ex = {};
      $n ? $bn->get_log_reply_value($_, $val, $ex) : $bn->get_log_main_value($_, $val, $ex);
      if ($ex->{mail_notice} && $val->{mail} ne '') {
        my $f;
        for (@send_addr) { if ($_ eq $val->{mail}) { $f = 1; last } }
        push @send_addr, $val->{mail} unless $f;
      }
      $n++;
    }
    close $fh;
  }

  @send_addr = grep { $_ ne $in->{mail} } @send_addr;

  if ($bn->get($cf, 'UseAllPostNotice')) {
    my $f;
    for (@send_addr)
     { if ($_ eq $bn->get($cf, 'AdminMail')) { $f = 1; last } }
    push @send_addr, $bn->get($cf, 'AdminMail') if !$f && $bn->get($cf, 'AdminMail') ne '';
  }

  return unless @send_addr;

  $data->{ip} = $gl->{IP};
  $data->{host} = $gl->{HOST};
  $data->{name} = $in->{name};
  $data->{mail} = $in->{mail};
  $data->{url} = $in->{url};
  $data->{title} = $in->{title};
  $data->{message} = $in->{message};
  $data->{useragent} = $gl->{UserAgent};
  $data->{date} = $bn->get_date;
  $data->{thread} = int $1 if $gl->{LogFile} =~ /(\d+)\.$bn->{sys}{Exe}$/;
  $data->{mode} = $bn->text('NOTICE_' . $mode) if $mode;
  $data->{bbstitle} = $bn->get($cf, 'BbsTitle');
  $data->{homepageurl} = $bn->get($cf, 'HomePageUrl');
  $bn->date_init( $data, $data->{date} );
  my $subject = "$data->{bbstitle} No.$data->{thread} $data->{mode}";
  my $buffer;
  my $chr = $bn->get($cf, 'NoticeMailFormatCharset');
  my $enc = $bn->get($cf, 'NoticeMailFormatEncoding');
  $chr ||= 'ISO-2022-JP';
  $enc ||= '7bit';

  my $tmpl = {};
  $tmpl->{data} = join "\n", @{$bn->get($cf, 'NoticeMailFormat')};
  $bn->template_trans($tmpl);
  $bn->translate($tmpl, $data, undef, \$buffer);

  $buffer =~ s/<!?BR>/\n/ig;  $buffer =~ s/<P>/\n\n/ig;
  $buffer =~ s/\&lt\;/</g;  $buffer =~ s/\&gt\;/>/g;
  $buffer =~ s/\&quot\;/\"/g; $buffer =~ s/\&amp\;/&/g;
  $buffer =~ s/\&nbsp\;/ /g;

  # jp
  if ($bn->{sys}{Language} =~ /^jp$/i) {
    $bn->convert(\$subject, $chr, $bn->{sys}{Charset});
    $bn->convert(\$buffer, $chr, $bn->{sys}{Charset});
  }

  my @to_ = map { s/[^\w\@\.\-\,]//g; $_ } @send_addr;
  my $to = join ',', @to_;
  my $sendmail = $bn->get($cf, 'SendMailPath');
  my $netsmtp = 1 if $sendmail eq '' && $] >= 5.006;

  eval('require Net::SMTP') if $netsmtp;
  if ($netsmtp && !$@ && @to_) {
    my $smtp = Net::SMTP->new('localhost', Timeout => $bn->{sys}{Alarm} ? $bn->{sys}{Alarm} : 10);
      $bn->error('ERR_SMPT') unless $smtp;
    eval {
      my $admin_mail = $bn->get($cf, 'AdminMail');
      my $anon = $bn->get($cf, 'AdminAnonymous');
#    $smtp->auth($username, $password);
      $smtp->mail( $admin_mail && !$anon ? $admin_mail :
       'hogehoge@' . ( exists $ENV{SERVER_NAME} ? $ENV{SERVER_NAME} : 'localhost' ) );
#    $smtp->to(@to_, {SkipBad => 1});
#    $smtp->cc(@to_, {SkipBad => 1});
      $smtp->bcc(@to_, {SkipBad => 1});
      $smtp->data();
      $smtp->datasend("X-Mailer: BBSNote Notice Mail SMTP\n");
      $smtp->datasend("Mime-Version: 1.0\n");
      $smtp->datasend("Content-Transfer-Encoding: 7bit\n");
      $smtp->datasend("Content-type: text/plain; charset=". $chr ."; format=flowed\n");
      $smtp->datasend("Subject: $subject\n");
      $smtp->datasend($buffer);
      $smtp->dataend();
      $smtp->quit;
    };
    if ( $@ ) {
      print "Content-Type: text/html\n\n";
	  print "Got an error: $@";
	  $bn->EXIT;
	}
  } elsif($sendmail ne '' && $to ne '') {

    local *FH;

    # alarm on
    eval {
      local $SIG{ALRM} = sub{ die "alarm\n" };
      alarm $sys->{Alarm} if $sys->{Alarm};

      if (open FH, "| $sendmail -t") {
        print FH "BCC: $to\n";
        print FH "Mime-Version: 1.0\n";
        print FH "X-Mailer: BBSNote Notice Mail\n";
        print FH "Content-type: text/plain; charset=". $chr ."; format=flowed\n";
        print FH "Subject: $subject\n";
        print FH "Content-Transfer-Encoding: " . $enc . "\n\n";
#      print FH "Sender: $gl->{IP}($gl->{HOST})\n";
#      print FH "From: $from_addr\n" if $from_addr;
#      print FH "To: $send_addr\n";
        print FH $buffer;
        close FH;
      }

      # alarm off
      alarm 0;
    };
    $bn->Trace('ALRM') if $@ =~ /alarm\n/;
  }
}
sub new_gd_image {
  my( $po, $hfl, $truecolor ) = @_;
  my $image;
  eval {
    local $SIG{ALRM} = sub{ die "alarm\n" };
    alarm 2;
    ## fixed gd version : enable function
    $image = $hfl->{mime} eq 'png' ?
      GD::Image->newFromPng( $hfl->{path}, $truecolor ) :
        GD::Image->new( $hfl->{path} );
    $image->trueColor(1) if $truecolor;
   alarm 0;
  };
  return if $@ =~ /alarm\n/;
  $image;
}
sub image_resize {
  my( $po, $hfl, $hobj, $width, $height, $mime, $truecolor ) = @_;
  my $cf = $bn->{cfg};
  my $gl = $bn->{global};

  return -1 and $bn->warn('Post.pm image_resize() : arg not hash')
     unless ref $hfl eq 'HASH';

  my $tool = $bn->get($cf, 'UseGD') ? 'GD' : $bn->get($cf, 'UsePerlMagick') ? 'PerlMagick' : $bn->get($cf, 'UseImageMagick') ? 'ImageMagick' : '';

  return 0 unless $tool || ( $hfl->{path} =~ /\.(jpg|gif|png)$/ && -f $hfl->{path} );

  $width = $bn->get($cf, 'ThumbnailWidth') unless defined $width;
  $height = $bn->get($cf, 'ThumbnailHeight') unless defined $height;
  return -2 if !$width || !$height;
  return 0 unless $width <= $hfl->{width} || $height <= $hfl->{height};
  $hobj->{mime} = $mime ? $mime : $hfl->{path} =~ /\.(\w+)$/ ? lc $1 : 'jpg';
  $hobj->{size} = 1;

  $po->set_filename($hobj, $bn->get($cf, 'FileHeadThumb'), '', $gl->{INCREMENT}) unless $hobj->{path};
  $hfl->{mime} = $1 if $hfl->{path} =~ /\.(\w+)$/;

  # GD
  if ($tool eq 'GD') {
    eval("require GD");
    $bn->error('ERR_MOD_NOTOPEN', 'GD') if $@;
    my( $image, $src );
    if ( $width == $hfl->{width} && $height == $hfl->{height} ) {
      $image = $po->new_gd_image( $hfl, $truecolor );
    } else {
      $src = $po->new_gd_image( $hfl, 1 );
      $src or return -6;
      @{$hfl}{'width', 'height'} = $src->getBounds if !$hfl->{width} || !$hfl->{height};
      my $x = ($width / $hfl->{width}) < ($height / $hfl->{height}) ? $width / $hfl->{width} : $height / $hfl->{height};
      $width = int($x * $hfl->{width} + 0.5); $height = int($x * $hfl->{height} + 0.5);
      $image = GD::Image->new( $width, $height );
      $image->copyResampled( $src, 0, 0, 0, 0, $width, $height, $hfl->{width}, $hfl->{height} );
    }
    my $fh = $bn->open($hobj->{path}, '>') if $image;
    if ( $fh ) {
      binmode $fh;
      if ($hobj->{mime} =~ /jpe?g/i) {
        $image->trueColor(1);
        print $fh $image->jpeg(96);
      } elsif ($hobj->{mime} eq 'gif') {
        ## PNG -> GIF color overflow : no dither 256 colors down
        $image->trueColorToPalette();
        print $fh $image->gif();
      } else {
        $image->trueColor(0);
        print $fh $image->png(9);
      }
      close $fh;
    }
    undef $image;
    undef $src;

  # PerlMagick
  } elsif ($tool eq 'PerlMagick') {
    eval("require Image::Magick");
    $bn->error('ERR_MOD_NOTOPEN', 'Image::Magick') if $@;
    my $src = Image::Magick->new;
    eval {
      local $SIG{ALRM} = sub{ die "alarm\n" };
      alarm 3;
      my $err = $src->Read($hfl->{path});
      $bn->warn("Image::Magick Error $err [$hfl->{path}]") and return -8 if $err;
      @{$hfl}{'width', 'height'} = $src->Get('width', 'height') if !$hfl->{width} || !$hfl->{height};
      my $x = ($width / $hfl->{width}) < ($height / $hfl->{height}) ? $width / $hfl->{width} : $height / $hfl->{height};
      $width = int($x * $hfl->{width} + 0.5); $height = int($x * $hfl->{height} + 0.5);

      $src->Scale(width => $width, height => $height);
      $src->Write(filename => $hobj->{path}, quality => 95);
      undef $src;
      alarm 0;
    };
    $bn->Trace('ALRM') if $@ =~ /alarm\n/;
  # ImageMagick
  } elsif ($tool eq 'ImageMagick') {
    my $im_path = $bn->get($cf, 'ImageMagickPath');
    my $option = "-geometry $width" . ($width && $height ? 'x' : '') . $height;
    eval {
      local $SIG{ALRM} = sub{ die "alarm\n" };
      alarm 5;
      `$im_path $option $hfl->{path} $hobj->{path}`;
      alarm 0;
    };
    $bn->Trace('ALRM') if $@ =~ /alarm\n/;
    # GIF animetion format : acquisition only the last file
    unless (-e $hobj->{path}) {
      my $n = 0;
      while (-e "$hobj->{path}.$n") {
        $n ? unlink "$hobj->{path}.$n": rename "$hobj->{path}.$n", $hobj->{path};
        $n++ }
    }
    $hobj->{size} = -s $hobj->{path};
  }
  undef %$hobj unless -s $hobj->{path};
}

sub image_match_size {
  my($po, $hfl, $size, $rejume) = @_;
  my $cf = $bn->{cfg};

  return -1 and $bn->warn('Post.pm image_match_size() : arg not hash')
     unless ref $hfl eq 'HASH';
  return -2 unless -e $hfl->{path} && $size;

  $hfl->{size} = -s $hfl->{path};
  $hfl->{mime} = $1 if $hfl->{path} =~ /\.(\w+)$/;

  return -3 if $size > $hfl->{size};

  my $tool = $bn->get($cf, 'UseGD') ? 'GD' : $bn->get($cf, 'UsePerlMagick') ? 'PerlMagick' : $bn->get($cf, 'UseImageMagick') ? 'ImageMagick' : '';
  return 0 unless $tool;

  my $hobj = { mime => $hfl->{mime}, size => 1 };
  my($src, $objsize, $width, $height, $destW, $destH, $im_path);

  if ($tool eq 'GD') {
    eval("require GD");
    $bn->error('ERR_MOD_NOTOPEN', 'GD') if $@;
  } elsif ($tool eq 'PerlMagick') {
    eval("require Image::Magick");
    $bn->error('ERR_MOD_NOTOPEN', 'Image::Magick') if $@;
  } elsif ($tool eq 'ImageMagick') {
    $im_path = $bn->get($cf, 'ImageMagickPath');
  }

  my $per;
  my $r = 0;
  for ($per = defined $rejume ? $rejume : 90; $r < 2; $r++) {
    $po->set_filename($hobj, 'tmp', $r);

    # GD
    if ($tool eq 'GD') {
      if ( !defined $src ) {
        return 0 unless -f $hfl->{path};
        $src = $po->new_gd_image( $hfl, 1 );
        $src or return -6;
        ( $width, $height ) = $src->getBounds;
      }
      $destW = int($width * $per / 100);
      $destH = int($height * $per / 100);
      my $image = GD::Image->new($destW, $destH);
      $image->trueColor(1);
#      $image->copyResized($src, 0, 0, 0, 0, $destW, $destH, $width, $height); # xD
      $image->copyResampled($src, 0, 0, 0, 0, $destW, $destH, $width, $height);

      my $fh = $bn->open($hobj->{path}, '>');
      if ($fh) {
        binmode $fh;
        if ($hobj->{mime} =~ /jpe?g/i) {
          print $fh $image->jpeg(96 - $r);
        } elsif ($hobj->{mime} eq 'gif') {
          $image->trueColor(0);
          print $fh $image->gif;
        } else {
          $image->trueColor(0);
          print $fh $image->png(9 - $r);
        }
        close $fh;
      }
      undef $image;

    # PerlMagick
    } elsif ($tool eq 'PerlMagick') {
      unless (defined $src) {
        $src = Image::Magick->new;
        my $err = $src->Read($hfl->{path});
        $bn->warn("Image::Magick Error $err [$hfl->{path}]") and return -8 if $err;
        ($width, $height) = $src->Get('width', 'height');
      }
      $destW = int($width * $per / 100);
      $destH = int($height * $per / 100);
#       $src->Sample(width => $destW, height => $destH);
      $src->Scale(width => $destW, height => $destH);
      $src->Write(filename => $hobj->{path}, quality => 95 - $r);
      undef $src;

     # ImageMagick
     } elsif ($tool eq 'ImageMagick') {
      `$im_path -sample $per% $hfl->{path} $hobj->{path}`;
      unless (-e $hobj->{path}) {
        my $n = 0;
        while (-e "$hobj->{path}.$n") {
          $n ? unlink "$hobj->{path}.$n": rename "$hobj->{path}.$n", $hobj->{path};
          $n++ }
      }
     }
     $objsize = -s $hobj->{path};
     last if $size > $objsize;
     $per-=10;
     $per = 1 if $per < 1;
     unlink $hobj->{path};
  }

  if (-e $hobj->{path}) {
    @{$hobj}{'mime', 'width', 'height', 'size'} = ($hobj->{mime}, $destW, $destH, $objsize);
    return $hobj->{path};
  }
  return 0, $per;
}

1;

__END__
