#=============================================================================
# BBS Note Comet 1.x
# Copyright(C) WonderCatStudio. All rights reserved.
# This code cannot be redistributed without
# permission from wondercatstudio.com
# LastModify : 2007/12/21
# Version : 0.05.000 build 1
#=============================================================================
package BN::Search;
use strict;
use vars qw( $bn $VERSION );

$VERSION = '0.05.000';

sub new {
  my $class = shift;
  my $sea = bless { }, $class;
  $bn = $_[0];
  $sea;
}

sub search {
  my $sea = shift;
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my $sk = $bn->{skin};
  my $gl = $bn->{global};
  my $ck = $bn->{cookie};
  my $sys = $bn->{sys};
  my $tmp = $bn->{temp};
  my $arg = $bn->{arg};
  my $page = $in->{page};
  my $sort = $in->{sort};

  my( @indexs, @target, $buffer, $pagebuf, $nextanc );
  my $bg1 = $bn->get($sk, 'TagTableIn')->{bgcolor};
  my $bg2 = $bn->get($sk, 'TagTableOut')->{bgcolor};
  my $bbsnoteurl = $bn->get($cf, 'BBSNoteUrl');
  my $limit_search = $bn->get($cf, 'ViewSearchLimitLog');

  my @key = split / /, $sea->keyword_escape( $in->{keyword} );
  $in->{keyword} = join ' ', @key;
  ## no keyword
  unless ( @key ) { $bn->open_page; return }

  my $item = $sea->{item} = $bn->text( undef, 'search' );
  my $log_view = $in->{search_view};
  $log_view ||= $bn->get($cf, 'ViewSearchDefault');
  $log_view = $bn->get($cf, 'ViewSearchLimitMax')
    if $log_view > $bn->get($cf, 'ViewSearchLimitMax');

  $bn->set( $cf, 'LogView', $log_view );
  $bn->open_index( 'NOT_BLOCK_MODE' );

  $gl->{Page} = $in->{page} ? abs int $in->{page} : 1;
  $gl->{Index} = ( $gl->{Page} - 1 ) * $log_view;
  $gl->{Index} = $in->{log} if $in->{log};
  $gl->{Index} = $gl->{Page} = 0 if $gl->{Index} >= $gl->{LogTotal} || $gl->{Index} < 0;
  my $area_st = $gl->{Index};

  for (my $index_pos = 0, my $index_seek = $gl->{Index};
      $index_pos < $limit_search && $index_seek < $gl->{LogTotal};
      $index_pos++, $index_seek++
  ) { push @indexs, $bn->read_index( $index_seek, $sys->{sortmode} ) }
  $bn->close_index;


  $bn->send_http_header->head( $item->{result} );

  my @targets = qw/message name title parent reply image paint/;
  my %ta;
  for ( sort grep { /^target(?:\d+)?/ ? $_ : undef } keys %$in ) {
    map { my @a = split '=', $_, 2;
      $ta{$a[0]} = @a > 1 ? $a[1] : 1 } split ',', $in->{$_} }
  %ta = ( message => 1, name => 1, title => 1 ) if !defined %ta;
  if ( exists $ta{parent} && $ta{parent} && exists $ta{reply} && $ta{reply} )
   { delete $ta{parent}; delete $ta{reply} }

  my $type = $in->{type} ? $in->{type} : 'and';
  my $form_arg = $bn->set_form_arg( $arg->{SearchList} );
  my $form_target = ' target="bn_main"' if $bn->get($cf, 'UseTree') &&
   $bn->get($cf, 'UseTreeFrame') && ( $in->{frametype} || $ck->{frametype} );

  my $hitcnt = 0;
  my @val_sea = qw/message name title/;
  for ( my $i = 0, $gl->{IndexPos} = 0;
      $i <= $#indexs && $hitcnt <= $log_view;
      $gl->{IndexPos}++, $gl->{Index}++, $i++
  ) {
    $gl->{IndexNumber} = $indexs[$i];

    my $path = $bn->filelog($gl->{IndexNumber});
    next unless -e $path;
    my $n = 0;
    my $fh = $bn->open( $path ) or $bn->error( 'ERR_DATA_NOTOPEN', $path );
    my( @hit, $name, $date, $title );
    while ( <$fh> ) {
      my $val = $gl->{LogValue} = {}; my $ex = $gl->{LogExValue} = {};
      if ( !$n ) {
        next if $ta{reply};
        $bn->get_log_main_value( $_, $val, $ex );
        $title = $val->{title}; $date = $val->{date}; $name = $val->{name};
        if ( $ta{image} || $ta{paint} ) {
          next if $val->{file_name} eq '';
          next if $ta{paint} && $val->{applet} eq '';
        }
      } else {
        $bn->get_log_reply_value( $_, $val, $ex );
      }

      my $flag; my $k = 0; my @bits = ([],[],[]);
      ## bit analyse
      for ( 0..2 ) { $sea->analyse( \$val->{$val_sea[$_]}, $bits[$_] ) if $ta{$val_sea[$_]} }
      ## search keywords
      for my $str (@key) {
        # bit check
        for ( 0..2 ) { next if !$ta{$val_sea[$_]};
          my $p = 0;
          while ( ( $flag = index $val->{ $val_sea[$_] }, $str, $p ) > -1 )
           { if ( $bits[$_][$flag] == 3 ) { $p = $flag + 1; next } last }
          last if $flag > -1;
        }
        $hit[$k] = 1 if $flag > -1;
        $k++;
      }
      last if $ta{parent};
      last if $type eq 'and' && ( grep $_, @hit ) == @key;
      last if $type eq 'or' && ( grep $_, @hit );
      last if $ta{title} && !$ta{message} && !$ta{name};
      $n++;
    }
    close $fh;

    next if $type eq 'and' && ( grep $_, @hit ) != @key;
    next if $type eq 'or' && ( grep $_, @hit ) == 0;

    $hitcnt++;

    # next
    if ( $hitcnt > $log_view ) {
      $nextanc = 1;
      last;
    }

    $sea->tmpl_sea_hit_line( {
      index_number => $gl->{IndexNumber}, action => $bbsnoteurl,
      buffer => \$buffer, form_target => $form_target, arg => $form_arg,
      title => $title, name => $name, date => $date,
      keyword => $in->{keyword}, type => $in->{type},
      target => ( join ',', grep{ $_ if $ta{$_} } each %ta )
    } );

  }

  my $area_ed = $gl->{Index};

  require 'BN/Design.pm';
  my $dsn = BN::Design->new( $bn );
  my $over_color = $dsn->get_middle_color($bg1, $bg2);

  $sea->tmpl_sea_css_js({ color1 => $bg1, color2 => $bg2, over_color => $over_color });

  $pagebuf .= '<center><table width="80%"><tr>';

  my $farg = $bn->set_form_arg( { type => $in->{type}, target => $in->{target}} );

  if ( $area_st > 0 && $gl->{IndexPos} < $limit_search ) {
    my $i = $in->{pos};
    $i = 0 if $i < 0;
    my @r = split /,/, $in->{rev};
    my $n; for ( @r ) { last if $_ == $i; $n++ }
    my $rev = $r[ $n-1 ];
    $in->{rev} = join ',', @r[ 0..$n ];

    $pagebuf .= <<_HTML_;
    <form action="$bbsnoteurl" method="post">$farg
    <input type="hidden" name="fc" value="search">
    <input type="hidden" name="log" value="$i">
    <input type="hidden" name="pos" value="$rev">
    <input type="hidden" name="rev" value="$in->{rev}">
    <input type="hidden" name="keyword" value="$in->{keyword}">
    <td width=30%><input class="SerachHitButton" type="submit" value=" << " style="width:100px"></td>
    </form>
_HTML_

  } elsif( $in->{log} - $limit_search >= 0 ) {
    my $i = $in->{log} - $limit_search;
    $pagebuf .= <<_HTML_;
    <form action="$bbsnoteurl" method="post">$farg
    <input type="hidden" name="fc" value="search">
    <input type="hidden" name="log" value="$i">
    <input type="hidden" name="keyword" value="$in->{keyword}">
    <td width="30%"><input class="SerachHitButton" type="submit" value="<< $item->{old_log} $i-$in->{log}"></td>
    </form>
_HTML_

  } else { $pagebuf .= '<td width="30%">&nbsp;</td>' }



  my $ed = $area_ed < $gl->{LogTotal} ? $area_ed-1 : $item->{last};

  $pagebuf .= '<td width="30%" align="center" nowrap><small>'.
    $item->{search_area} .' : '. "$area_st - $ed". '</small></td>';

  if ( $nextanc ) {
    my $rev = join ',', grep $_ ne '', $in->{rev}, $area_st;
    $pagebuf .= <<_HTML_;
    <form action="$bbsnoteurl" method="post">$farg
    <input type="hidden" name="fc" value="search">
    <input type="hidden" name="log" value="$area_ed">
    <input type="hidden" name="pos" value="$area_st">
    <input type="hidden" name="rev" value="$rev">
    <input type="hidden" name="keyword" value="$in->{keyword}">
    <td width="30%" align="right"><input class="SerachHitButton" type="submit" value=" >> " style="width:100px"></td>
    </form>
_HTML_
  } elsif( $gl->{IndexPos} >= $limit_search ) {
    my $i = $gl->{Index} + $limit_search;
    $i = $item->{last} if $i > $gl->{LogTotal};
    $pagebuf.=<<_HTML_;
    <form action="$bbsnoteurl" method="post">$farg
    <input type="hidden" name="fc" value="search">
    <input type="hidden" name="log" value="$gl->{Index}">
    <input type="hidden" name="pos" value="$area_st">
    <input type="hidden" name="keyword" value="$in->{keyword}">
    <td width="30%" align="right"><INPUT class="SerachHitButton" type="submit" value=">> $item->{old_log} $gl->{Index}-$i"></td>
    </form>
_HTML_

  } else { $pagebuf .= '<td width="30%">&nbsp;</td>' }



  $pagebuf .= '</tr></table>';

  if ( $hitcnt ) {

    $bn->menu;
    $bn->print(<<_HTML_);
    $pagebuf
    <table class="SearchHitTableOut"><tr><td>
    <table class="SearchHitTableIn" width="100%" cellpadding="4" cellspacing="1" onmouseover="Over('$over_color')">
    <tr class="SearchHitCaption">
    <td class="SearchHitCaptionLog" style="color:$bg1" nowrap>$item->{log_view}</td>
    <td class="SearchHitCaptionTitle" style="color:$bg1" nowrap>$item->{title}</td>
    <td class="SearchHitCaptionName" style="color:$bg1" nowrap>$item->{name}</td>
    <td class="SearchHitCaptionDate" style="color:$bg1" nowrap>$item->{date}</td></tr>
    $buffer
    </td></tr></table>
    </td></tr></table>
    </center>
    $pagebuf
_HTML_

  } else {
    $bn->print( '<div align="center"><br><br><h2>', $item->{none}, '</h2>', $pagebuf );
  }

  $bn->close_index;
  $arg->{BackButton}{fc} = '';
  for (qw/keyword target type/) { $arg->{BackButton}{$_} = $in->{$_} }

  my $back =  $bn->back_button;
  $back =~ s/_self/_parent/g if $bn->get($cf, 'UseTreeFrame') && ( $in->{frametype} || $ck->{frametype} );

  $bn->print( $back, '</div>' );
  $bn->foot;
}

sub tmpl_sea_hit_line {
  my( $sea, $hash ) = @_;
  ${ $hash->{buffer} } .= <<_HTML_;
  <tr class="SearchHitList" onclick="document.form$hash->{index_number}.submit()">
  <form name="form$hash->{index_number}" method="post" action="$hash->{action}"$hash->{form_target}>
  <input type="hidden" name="fc" value="thread">
  <input type="hidden" name="log" value="$hash->{index_number}">
  <input type="hidden" name="keyword" value="$hash->{keyword}">
  <input type="hidden" name="target" value="$hash->{target}">
  <input type="hidden" name="type" value="$hash->{type}">
  $hash->{arg}
  <td class="SearchHitLog"><input class="submit" type="submit" value="$hash->{index_number}" style="width:100%"></td></form>
  <td class="SearchHitTitle" align="left">$hash->{title} &nbsp;</td>
  <td class="SearchHitName" nowrap>$hash->{name}</td>
  <td class="SearchHitDate" nowrap><tt>$hash->{date}</tt></td>
  </tr>
_HTML_
}

sub tmpl_sea_css_js {
  my( $sea, $hash ) = @_;
$bn->print(<<_HTML_);
<style type="text/css">
<!--
.SerachHitButton {
  cursor      : pointer;
  border      : 1px;
  font-size   : 10pt;
  color       : $hash->{color1};
  background  : $hash->{color2};
}
.SearchHitTableOut {
  width       : 80%;
  padding     : 1px;
  background  : $hash->{color2};
}
.SearchHitCaption {
  font-size   : 10pt;
  font-weight : 900;
  text-align  : center;
}

.SearchHitCaptionLog,
.SearchHitCaptionTitle,
.SearchHitCaptionName,
.SearchHitCaptionDate {
  border : 1px solid $hash->{over_color}
}

.SearchHitList {
  cursor      : pointer;
  text-align  : center;
  background  : $hash->{color1};
}
.SearchHitLog {
  width       : 5%;
}
.SearchHitTitle {
  width       : 80%;
  text-align  : left;
}
.SearchHitName {
  width       : 10%;
}
.SearchHitDate {
  width       : 5%;
}
//-->
</style>

<script type="text/javascript">
var currRow=-1;var selRow=-1;var hlColor;
function Over(color){hlColor = color;srcElem = window.event.srcElement;
while(srcElem.tagName!="TR"&&srcElem.tagName!="TABLE")srcElem = srcElem.parentElement;
if(srcElem.tagName!="TR")return;
if(srcElem.rowIndex > 0){hilite(srcElem)}else{hilite(-1)}}
function hilite(newRow){
if(hlColor!=null){if(currRow!=-1&&currRow!=selRow){currRow.runtimeStyle.backgroundColor=''}
if(newRow!=-1&&newRow!=selRow){newRow.runtimeStyle.backgroundColor=hlColor}}currRow=newRow}
</script>
_HTML_

}

sub keyword_escape {
  my( $pa, $keyword ) = @_;
  my $str = $keyword;
  $str =~ s/\201\100/ /g;
  $str =~ s/["'|,]/ /g;
  $str =~ s/ +/ /g;
  $str =~ s/^ +//g;
  return $str;
}
sub analyse {
  my( $pa, $str, $bit ) = @_;
  return unless $bn->{sys}{Charset} =~ /shift.jis/i;
  undef @$bit;
  my($i,$f);
  my $max = length $$str;
  for ($i = 0; $i < $max; $i++) {
    $_ = substr $$str,$i,1;
    if ($f>1) {
      $f = /[\x40-\xFC]/ ? 3 : 0;
    } elsif (/[\x81-\x9F\xE0-\xEA\xED-\xEE\xFA-\xFB\xFC]/) {
      $f = 2;
    } elsif (/[\x20-\x7E\xA1-\xDF]/) {
      $f = 1;
    } else {
      $f = 0;
    }
    $$bit[$i] = $f;
    $f = 0 if $f==3;
  }
}

sub keyword {
  my $sea = shift;
  my $in = $bn->{in};
  my $str = $in->{keyword};

  $str =~ s/\201\100/ /g;
  $str =~ s/["'|,]/ /g;
  $str =~ s/ +/ /g;
  $str =~ s/^ +//g;

  my @key = split / /, $str;
  return unless @key;

  my $hl;
  my $n = -1;
  my @c = qw/FFFF33 66FF66 FF9933 66CCCC FF3333 6666FF 009966/;
  for (@key) {
    $n++;
    $hl .= "hl('$_','".(@c < $n ? $n = 0 && $c[$n] : $c[$n])."');";
  }

$bn->print(<<_HTML_);
<script langage="javascript">
function hl(w,c) {if(document.body && document.body.createTextRange) {
var rng = document.body.createTextRange();while(rng.findText(w,1,2)){rng.pasteHTML("<span style='color:black;background-color:#"+c+"'>"+rng.text+"</span>");rng.collapse(false)}}}
window.onerror=new Function(';');
$hl
</script>
_HTML_
}

1;

__END__
