#=============================================================================
# BBS Note Comet 1.x 
# Copyright(C) WonderCatStudio. All rights reserved.
# http://wondercatstudio.com
# LastModify : 2007/11/26
# Version : 0.11.000 build 1
# Language : Japanese
#=============================================================================
package BN::Text::jp::error;
use strict;
use vars qw( $VERSION );

$VERSION = '0.11.000';

sub new {
    my $tx = bless { }, $_[0];
    $tx->init;
}

sub init {
	my $tx = shift;

	my %txt = (
    'CHARSET' => 'shift_jis',
    'ERR_FUNCTION'             => 'G[:̋@\͎gpł܂B',

    'ERR_BOOT_INIT'            => 'NG[:([_1])ł܂łB',
    'ERR_BOOT_MOD'             => 'NG[:([_1])ł܂łB<br>[_2]',
    'ERR_CONFIG_NOTFOUND'      => 'NG[:ݒt@C([_1])܂łB',
    'ERR_SKIN_NOTFOUND'        => 'NG[:XLt@C([_1])܂łB',
    'ERR_SYSINDEX_NOTOPEN'     => 'NG[:VXeCfbNXt@C([_1])J܂łB',
    'ERR_DIR_NOTFOUND'         => 'G[:fBNg([_1])܂łB',
    'ERR_DIR_NOTMAKE'          => 'G[:fBNg([_1])쐬ł܂łB',
    'ERR_DATA_NOTFOUND'        => 'G[:w肳ꂽf[^([_1])܂łB',
    'ERR_DATA_NOTOPEN'         => 'G[:w肳ꂽf[^([_1])JƂł܂łB',
    'ERR_MOD_NOTOPEN'          => 'G[:W[([_1])JƂł܂łB[_2]',
    'ERR_CONTENT_LENGTH'       => 'VXeG[:NGXg̃f[^TCY傫܂B',
    'ERR_TMP_FILENAME'         => 'VXeG[:e|t@C擾ł܂łB',
    'ERR_SMPT'                 => 'VXeG[:SMTP쐬ł܂łB<br>̃T[o[ł͓eʒm͎gpł܂B',
    'ERR_LOCKED'               => 'VXeG[:bNɎs܂B<br>̃bZ[WłꍇAǗ҂ɂAB',

    'ERR_SYS_NOTREADINDEX'     => 'VXet@CG[:VXeCfbNX̎w肳ꂽԍ([_1])ǍނƂł܂łB',
    'ERR_SYS_NOTINDEXNUM'      => 'VXet@CG[:VXeCfbNX͎w肳ꂽԍ([_1])݂͑܂B',
    'ERR_SYS_NOTADDINDEX'      => 'VXet@CG[:VXeCfbNX̓CfbNXǉł܂łB',
    'ERR_SYS_NOTINDEXMAKE'     => 'VXet@CG[:VXeCfbNX([_1])쐬邱Ƃł܂łB<br>(sys)fBNg̃p[~bV݉\ɂĉB',
    'ERR_SYS_NOTINDEXWRITE'    => 'VXet@CG[:VXeCfbNX([_1])ނƂł܂łB',
    'ERR_SYS_BROKENINDEX'      => 'VXet@CG[:vIG[łB<br>VXeCfbNX͔jĂ\܂B',
    'ERR_SYS_LOCKEDINDEX'      => 'VXet@CG[:SẴXbhbNĂ邽߁AKvȃCfbNX쐬ł܂łB',

    'ERR_SYS_NOTOPEN'          => 'VXet@CG[:VXet@C([_1])ǍނƂł܂łB',
    'ERR_SYS_NOTITEM'          => 'VXet@CG[:VXet@C̎w肪܂łB',
    'ERR_SYS_NOTWRITE'         => 'VXet@CG[:VXet@C([_1])ɏނƂł܂łB',

    'ERR_SYS_COUNTERROR'       => 'VXet@CG[:vIG[łB<br>O邩炩̎ɂ<br>ȃJE^擾ł܂łB',
    'ERR_SYS_CRYPTERROR'       => 'VXeG[:Í񂪔jĂ܂',

    'ERR_MULTIPLEPOST'         => 'eG[I:AełI<br><br>e͋ۂ܂B<br>x悭m߉B',
    'ERR_POST_RANGE'           => 'eG[I:ANZX [_1] [_2] ȏ[_3]͐Ă܂B',
    'ERR_REPLYPOST'            => 'eG[I:ԐMe𒴂߁ÃXbhɂ͕ԐMe͂ł܂B',
    'ERR_DELETE_AUTHOR'        => '폜G[I:폜邽߂̌܂B',

    'ERR_SKIN_TAG'             => 'XL^OG[I:XL^O [_1]s [_2] <b>[_3]</b> ̕^O܂B[_4]',
    'ERR_THREAD_LOCK'          => 'XbhbN:̃Xbh̓bNĂ邽ߕԐMEҏWE폜sƂ͂ł܂B',

    'ERR_CAPTOR_SIZE'          => "MG[I:摜̎Mf[^TCYl𒴂܂B\nM : [_1] byte / el : [_2] byte",
    'ERR_CAPTOR_SIZE_REJUME'   => "MG[I:摜̎Mf[^TCYl𒴂܂B\nēxe鎖ɂ摜kĂ̓es܂B\nM : [_1] byte / el : [_2] byte / k : [_3] %",
    'ERR_CAPTOR_BROKEN'        => 'MG[I:Mꂽf[^͔jĂ܂B',
    'ERR_CAPTOR_ANIME_SIZE'    => "MG[I:Ajf[^̎Mf[^TCYl𒴂܂B\nM : [_1] byte / el : [_2] byte",
    'ERR_CAPTOR_THUMB_SIZE'    => "MG[I:TlC摜̎Mf[^TCYl𒴂܂B\nM : [_1] byte / el : [_2] byte",
    'ERR_CAPTOR_PIXEL_SIZE'    => "MG[I:摜TCYl𒴂܂B\nM : [_1] x [_2] / el : [_3] x [_4]",

    'ERR_ACCESS_POROXY'        => 'ANZXG[I:vLVoR͋Ă܂B<br>HOST<b> : [_1]</b><br>IP<b> : [_2]</b><br>Proxy : Lv[_3] [_4] [_5]<br><br>Ǘ҂ɊYzXg̃ANZX\oĉB',
    'ERR_ACCESS_IP_HOST'       => 'ANZXG[I:̃zXgEIP̃ANZXĂ܂B',
    'ERR_ACCESS_RAWIP'         => 'ANZXG[I:zXgtłȂIP̃ANZX͋Ă܂B',
    'ERR_ACCESS_BOOKMARK'      => 'ANZXG[I:ubN}[ÑANZX͋֎~Ă܂B',
    'ERR_ACCESS_REFERER'       => 'ANZXG[I:URL̃ANZXĂ܂B',

    'ERR_POOL_FAILED_ID'       => 'G[II:w肳ꂽID([_1])̓v[Ă܂łB',
    'ERR_POOL_NOTFOUND_ID'     => 'G[II:w肳ꂽID([_1])͌܂łB<br>łɏĂ\܂B',

    'DEFF_FORM_ARRAY_TYPE_ROW' => 'ϐG[:tH[ s\̂̎w肪ԈĂ܂B',
    'BAD_WRITE'                => 'G[II:t@C([_1])ɏ݂ł܂łB',
    'BAD_REQUEST'              => 'G[II:sȃNGXgM܂B',
    'PASSWORD_ERROR'           => 'pX[hsv:pX[hႢ܂I<br>x悭m߉B',

	);

	return \%txt;
}

1;

__END__
