#=============================================================================
# BBS Note Comet 1.x 
# Copyright(C) WonderCatStudio. All rights reserved.
# This code cannot be redistributed without
# permission from wondercatstudio.com
# LastModify : 2006/01/20
# Version : 0.04
#=============================================================================
package BN::XML;
use strict;
use vars qw( $bn $VERSION );

$VERSION = '0.04.000';

sub new {
  my $class = shift;
  my $xm = bless { }, $class;
  $bn = $_[0];
  $xm;
}

sub rss1 {
  my( $xm, $no_header ) = @_;
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my $sk = $bn->{skin};
  my $gl = $bn->{global};
  my $sys = $bn->{sys};

  my $view = int $in->{view};

  $sys->{sortmode} = $in->{sort} eq '' ?
  $bn->get($cf, 'ViewSortType') : $in->{sort} ? 1 : 0;
  my $log_view = $bn->get($cf, 'LogView');
   $log_view = $view if 0 < $view && $view <= 30 ;
  my $log_max = $bn->get($cf, 'LogMax');

  $gl->{Page} = $in->{page} ? int $in->{page} : 1 ;
  $gl->{Index} = ($gl->{Page} - 1) * $log_view;
  $gl->{Index} = $gl->{Page} = 0 if $gl->{Index} >= $gl->{LogTotal};


  my $fh_index = $bn->open_index;
  my $log_total = $gl->{LogTotal};
  my(@indexs, @threads);
  for (my $index_pos = 0, my $index_seek = $gl->{Index};
      $index_pos < $log_view && $index_seek < $gl->{LogTotal};
      $index_pos++, $index_seek++
  ) {
  push @indexs, $bn->read_index($index_seek, $sys->{sortmode});
  push @threads, ($sys->{sortmode} ? $bn->read_index($index_seek, 2) : $gl->{LogTotal} - $index_seek);
  }
  my $mod = $xm->_rss_date( $bn->get_date((stat $fh_index)[9]) );
  $bn->close_index;

  unless ( $no_header ) {
    $bn->send_http_header('text/xml');
    if(exists $in->{modified} && $in->{modified} . $bn->{XML_DATE_SPAN} ge $mod){
      $bn->print('304 Not Modified');
      return;
    }
  }

  my $path = $ENV{REQUEST_URI};
  $path = $1 if $path =~ /([^\?]+)/;

  my $la = $sys->{Language};
  my $bn_home = $bn->get($cf, 'HomePageUrl');
  $bn->escape_quote(\$bn_home);
  my $bn_title = $bn->get($cf, 'BbsTitle');

  my $bn_url = "http://$ENV{HTTP_HOST}$path";
  my $index_url = $bn->{bn_dir}. $bn->get( $cf, 'IndexFilePath' );
  if ( $index_url =~ /index\.html?$/ && -f $index_url ) {
    $index_url = $bn_url;
    $index_url =~ s/([^\\\/]+)$//;
  } else {
    $index_url = $bn_url;
  }

  my $xsl_url = '<?xml-stylesheet type="text/xsl" href="'. $bn_url. '?fc=xsl1"?>' unless $no_header;
  my $bn_ver = $BN::VERSION =~ /(\d+.\d+)/ ? $1 : '';
  my $dir_url = $bn->get($cf, 'DirFileUrl');

  my $skin_ver = $bn->get($sk, 'SkinVersion');
  my $skin_name = $bn->get($sk, 'SkinName');
  my $skin_copy = $bn->get($sk, 'SkinCopyright');
  my $skin_site = $bn->get($sk, 'SkinAuthorSiteURL');
  my $skin_modify = $bn->get($sk, 'SkinLastmodify');
  my $skin_author = $bn->get($sk, 'SkinAuthor');

  my $cf_co = $bn->get($cf, 'NeedData');
  my $cf_im = $bn->get($cf, 'UseImageMagick');
  my $cf_up = $bn->get($cf, 'UseUpload');
  my $cf_tag = $bn->get($cf, 'UseTag');

  my $description = $bn->get($cf, 'AdminComment');
   $description ||= "BBS NOTE COMET $bn_ver";

  my( $app, $seq, $items );

  if (exists $bn->{module}{Paint}) {
    my %ap;
    for (@{ $bn->{module}{Paint}{applets} })
     { $ap{$_->{applet}} = 1 }
    $app = join '', map{ "<bn:$_>1</bn:$_>\n" }keys %ap;
  }

$bn->print(<<_XML_);
<?xml version="1.0" encoding="$sys->{Charset}"?>
$xsl_url
<rdf:RDF
  xmlns="http://purl.org/rss/1.0/"
  xmlns:dc="http://purl.org/dc/elements/1.1/"
  xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
  xmlns:bn="http://wondercatstudio.com/bn/1.0/"
  xml:lang="$la"
>

<channel rdf:about="$index_url">
<title>$bn_title</title>
<link>$index_url</link>
<description>$description</description>
<dc:language>$la</dc:language>
<dc:date>$mod</dc:date>
<bn:home href="$bn_home" />
<bn:skin href="$skin_site"
 name="$skin_name"
 version="$skin_ver"
 lastmodify="$skin_modify"
 copyright="$skin_copy"
 author="$skin_author"
 />
<bn:verion>$BN::VERSION</bn:verion>
<bn:data>$dir_url</bn:data>
<bn:cfg>
<bn:log>$log_total</bn:log>
<bn:limit>$log_max</bn:limit>
<bn:view>$log_view</bn:view>
<bn:co>$cf_co</bn:co>
<bn:im>$cf_im</bn:im>
<bn:sort>$sys->{sortmode}</bn:sort>
<bn:tag>$cf_tag</bn:tag>
<bn:upload>$cf_up</bn:upload>
$app
</bn:cfg>
_XML_

  for ( my $i = 0, $gl->{IndexPos} = 0;
    $i <= $#indexs;
    $gl->{IndexPos}++, $gl->{Index}++, $i++
  ) {
  $gl->{IndexNumber} = $indexs[$i];
  $gl->{ThreadNumber} = $threads[$i];

  my $val = $gl->{LogValue} = {};
  my $ex = $gl->{LogExValue} = {};
  my $data = {};
  $bn->app->get_log($gl->{IndexNumber}, '', $val, $ex);
  $bn->get_src_value($data, $val, $ex);
  $bn->data_init($data);
  my $mod = $xm->_rss_date( $bn->get_date((stat $bn->filelog($gl->{IndexNumber}))[9]) );
  my $date = $xm->_rss_date( $data->{date} );
  my $msg = $data->{message};

  my $pos = 0;
  $msg =~ s/&nbsp;/ /g;
  $msg =~ s/&/%26/g;
  $msg =~ s/(<BR>|<P>)/ /g;
  $msg =~ s/ +/ /g;

  while ($pos >= 0) {
    $pos = index $msg,'<',$pos;
    if ($pos >= 0) {
      my $s = index $msg,'>',$pos + 1;
      if ($s >= 0) {
        my $a = substr $msg, 0, $pos if $pos;
        $msg = $a.(substr $msg, $s+1);
      } else {
        $pos++
      }
    } else { last }
  }

  $seq.="<rdf:li rdf:resource=\"$bn_url?$gl->{IndexNumber}\" />\n";

  $msg =~ s/</&lt\;/g;
  $msg =~ s/>/&gt\;/g;

  $items.=<<_XML_;
<item rdf:about="$bn_url?$gl->{IndexNumber}">
<title>$data->{title}</title>
<link>$bn_url?$gl->{IndexNumber}</link>
<description>$msg</description>
<dc:creator>$data->{name}</dc:creator>
<dc:date>$date</dc:date>
<bn:lastmodify>$mod</bn:lastmodify>
<bn:log>$gl->{IndexNumber}</bn:log>
<bn:image>$data->{image_src}</bn:image>
<bn:anime>$data->{anime_src}</bn:anime>
<bn:thumbnail>$data->{thumbnail_src}</bn:thumbnail>
<bn:object_src>$data->{object_src}</bn:object_src>
<bn:object_src_length>$data->{object_src_length}</bn:object_src_length>
<bn:image_width>$data->{file_width}</bn:image_width>
<bn:image_height>$data->{file_height}</bn:image_height>
<bn:image_length>$data->{file_length}</bn:image_length>
</item>
_XML_

  }

  $bn->print("<items>\n<rdf:Seq>\n$seq</rdf:Seq>\n</items>\n\n</channel>\n$items\n\n</rdf:RDF>");

}

sub rss2 {
  my $xm = shift;
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my $sk = $bn->{skin};
  my $gl = $bn->{global};
  my $sys = $bn->{sys};

  my $view = int $in->{view};

  $sys->{sortmode} = $in->{sort} eq '' ?
  $bn->get($cf, 'ViewSortType') : $in->{sort} ? 1 : 0;
  my $log_view = $bn->get($cf, 'LogView');
   $log_view = $view if 0 < $view && $view <= 30 ;
  my $log_max = $bn->get($cf, 'LogMax');

  $gl->{Page} = $in->{page} ? int $in->{page} : 1 ;
  $gl->{Index} = ($gl->{Page} - 1) * $log_view;
  $gl->{Index} = $gl->{Page} = 0 if $gl->{Index} >= $gl->{LogTotal};

  my $fh_index = $bn->open_index;
  my $log_total = $gl->{LogTotal};
  my(@indexs, @threads);
  for (my $index_pos = 0, my $index_seek = $gl->{Index};
      $index_pos < $log_view && $index_seek < $gl->{LogTotal};
      $index_pos++, $index_seek++
  ) {
  push @indexs, $bn->read_index($index_seek, $sys->{sortmode});
  push @threads, ($sys->{sortmode} ? $bn->read_index($index_seek, 2) : $gl->{LogTotal} - $index_seek);
  }
  my $mod = $xm->_rss_date( $bn->get_date((stat $fh_index)[9]) );
  $bn->close_index;

  $bn->send_http_header('text/xml');

  if(exists $in->{modified} && $in->{modified} . $bn->{XML_DATE_SPAN} ge $mod){
  $bn->print('304 Not Modified');
  return;
  }

  my $path = $ENV{REQUEST_URI};
  $path = $1 if $path =~ /([^\?]+)/;

  my $la = $sys->{Language};
  my $bn_home = $bn->get($cf, 'HomePageUrl');
  my $bn_title = $bn->get($cf, 'BbsTitle');

  my $bn_url = "http://$ENV{HTTP_HOST}$path";
  my $bn_ver = $BN::VERSION =~ /(\d+.\d+)/ ? $1 : '';
  my $dir_url = $bn->get($cf, 'DirFileUrl');

  my $skin_ver = $bn->get($sk, 'SkinVersion');
  my $skin_name = $bn->get($sk, 'SkinName');
  my $skin_copy = $bn->get($sk, 'SkinCopyright');
  my $skin_site = $bn->get($sk, 'SkinAuthorSiteURL');
  my $skin_modify = $bn->get($sk, 'SkinLastmodify');
  my $skin_author = $bn->get($sk, 'SkinAuthor');

  my $cf_co = $bn->get($cf, 'NeedData');
  my $cf_im = $bn->get($cf, 'UseImageMagick');
  my $cf_up = $bn->get($cf, 'UseUpload');
  my $cf_tag = $bn->get($cf, 'UseTag');

  my $description = $bn->get($cf, 'AdminComment');
   $description ||= "BBS NOTE COMET $bn_ver";

  my( $app, $seq, $items );

  if (exists $bn->{module}{Paint}) {
  my %ap;
  for (@{ $bn->{module}{Paint}{applets} })
    { $ap{$_->{applet}} = 1 }
  $app = join '', map{ "<bn:$_>1</bn:$_>\n" }keys %ap;
  }

$bn->print(<<_XML_);
<?xml version="1.0" encoding="$sys->{Charset}"?>

<rss version="2.0"
  xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
  xmlns:dc="http://purl.org/dc/elements/1.1/"
  xmlns:bn="http://wondercatstudio.com/bn/1.0/"
  xmlns:admin="http://webns.net/mvcb/"
  xmlns="http://purl.org/rss/1.0/">

<channel>
<title>$bn_title</title>
<link>$bn_url</link>
<description>$description</description>
<dc:language>$la</dc:language>
<dc:date>$mod</dc:date>
<admin:generatorAgent rdf:resource="http://wondercatstudio.com" />
<bn:home href="$bn_home" />
<bn:skin href="$skin_site"
 name="$skin_name"
 version="$skin_ver"
 lastmodify="$skin_modify"
 copyright="$skin_copy"
 author="$skin_author"
 />
<bn:verion>$BN::VERSION</bn:verion>
<bn:data>$dir_url</bn:data>
<bn:cfg>
<bn:log>$log_total</bn:log>
<bn:limit>$log_max</bn:limit>
<bn:view>$log_view</bn:view>
<bn:co>$cf_co</bn:co>
<bn:im>$cf_im</bn:im>
<bn:sort>$sys->{sortmode}</bn:sort>
<bn:tag>$cf_tag</bn:tag>
<bn:upload>$cf_up</bn:upload>
$app
</bn:cfg>
_XML_

  for ( my $i = 0, $gl->{IndexPos} = 0;
    $i <= $#indexs;
    $gl->{IndexPos}++, $gl->{Index}++, $i++
  ) {
  $gl->{IndexNumber} = $indexs[$i];
  $gl->{ThreadNumber} = $threads[$i];

  my $val = $gl->{LogValue} = {};
  my $ex = $gl->{LogExValue} = {};
  my $data = {};
  $bn->app->get_log($gl->{IndexNumber}, '', $val, $ex);
  $bn->get_src_value($data, $val, $ex);
  $bn->data_init($data);
  my $mod = $xm->_rss_date( $bn->get_date((stat $bn->filelog($gl->{IndexNumber}))[9]) );
  my $date = $xm->_rss_date( $data->{date} );
  my $msg = $data->{message};

  my $pos = 0;
  $msg =~ s/&nbsp;/ /g;
  $msg =~ s/&/%26/g;
  $msg =~ s/(<BR>|<P>)/ /g;
  $msg =~ s/ +/ /g;

  while ($pos >= 0) {
    $pos = index $msg,'<',$pos;
    if ($pos >= 0) {
      my $s = index $msg,'>',$pos + 1;
      if ($s >= 0) {
        my $a = substr $msg, 0, $pos if $pos;
        $msg = $a.(substr $msg, $s+1);
      } else {
        $pos++
      }
    } else { last }
  }

  $seq.="<rdf:li rdf:resource=\"$bn_url?$gl->{IndexNumber}\" />\n";

  $msg =~ s/</&lt\;/g;
  $msg =~ s/>/&gt\;/g;

  $items.=<<_XML_;
<item rdf:about="$bn_url?$gl->{IndexNumber}">
<title>$data->{title}</title>
<link>$bn_url?$gl->{IndexNumber}</link>
<description>$msg</description>
<dc:creator>$data->{name}</dc:creator>
<dc:date>$date</dc:date>
<bn:lastmodify>$mod</bn:lastmodify>
<bn:log>$gl->{IndexNumber}</bn:log>
<bn:image>$data->{image_src}</bn:image>
<bn:anime>$data->{anime_src}</bn:anime>
<bn:thumbnail>$data->{thumbnail_src}</bn:thumbnail>
<bn:object_src>$data->{object_src}</bn:object_src>
<bn:object_src_length>$data->{object_src_length}</bn:object_src_length>
<bn:image_width>$data->{file_width}</bn:image_width>
<bn:image_height>$data->{file_height}</bn:image_height>
<bn:image_length>$data->{file_length}</bn:image_length>
</item>
_XML_

  }

  $bn->print("<items>\n<rdf:Seq>\n$seq</rdf:Seq>\n</items>\n\n</channel>\n$items\n\n</rss>");

}

sub xsl1 {
  my $xm = shift;
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my $sk = $bn->{skin};
  my $gl = $bn->{global};
  my $sys = $bn->{sys};
  my $la = $sys->{Language};
  my $data = {};
  $bn->tag_init($data);
#  $bn->send_http_header('text/xsl');
  $bn->send_http_header('text/xml');

$bn->print (<<_XSL_);
<?xml version="1.0" encoding="$sys->{Charset}"?>
<xsl:stylesheet version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
  xmlns="http://www.w3.org/1999/xhtml"
  xmlns:rss="http://purl.org/rss/1.0/"
  xmlns:dc="http://purl.org/dc/elements/1.1/"
  xmlns:bn="http://wondercatstudio.com/bn/1.0/"
  exclude-result-prefixes="rdf rss dc bn">

  <xsl:template match="/">
  <xsl:apply-templates select="rdf:RDF"/>
  </xsl:template>

  <xsl:template match="rdf:RDF">
  <html xml:lang="$la" lang="$la">
    <head>
    <title><xsl:value-of select="rss:channel/rss:title"/></title>
    <style type="text/css">
      body { margin:0px;padding:5px;background-color : $data->{tagbodybgcolor}; color :$data->{tagbodytext} ; font-family : 'Osaka, sans-serif'}
      a { color :$data->{tagbodylink} }
      table { width : 100% ; border : outset 3px $data->{tagtableoutbgcolor} ; margin-bottom : 2px}
      hr { color: $data->{tagbodylink}; height: 3px }
      .title { font-size : 25pt; font-weight : 900 }
      .item1,.item1 a { color : $data->{tagtableoutbgcolor}; background : $data->{tagtableinbgcolor} }
      .item2,.item2 a { color : $data->{tagtableinbgcolor}; background : $data->{tagtableoutbgcolor} }
    </style>
    </head>
    <body>
    <a class="title" href="{rss:channel/rss:link}">
      <xsl:value-of select="rss:channel/rss:title"/></a><br/>
    <xsl:value-of select="rss:channel/rss:description"/>
    <hr/>
    <xsl:apply-templates select="rss:item"/>
    <hr/>
    BBSNote Comet $BN::VERSION
    </body>
  </html>
  </xsl:template>

  <xsl:template match="rss:item">
   <xsl:variable name="dir" select="/rdf:RDF/rss:channel/bn:data"/>
   <xsl:variable name="image" select="bn:image"/>
   <xsl:variable name="thumbnail" select="bn:thumbnail"/>
   <table class="item1">
  <xsl:if test="position() mod 2 = 0">
     <xsl:attribute name="class">item2</xsl:attribute>
  </xsl:if>
   <tr>
  <td>
   
   <xsl:choose>
     <xsl:when test="rss:title != ''">
     <a href="{rss:link}"><xsl:value-of select="bn:log"/> :: <xsl:value-of select="rss:title"/></a>
     </xsl:when>
     <xsl:otherwise>
     <a href="{rss:link}"><xsl:value-of select="bn:log"/> :: UnTitled</a>
     </xsl:otherwise>
   </xsl:choose>
  : <xsl:value-of select="dc:creator"/>
     <tt> [<xsl:value-of select="dc:date"/>]</tt>
  </td>
   </tr>
   <tr>
  <td>
   <xsl:if test="\$image != '' or \$thumbnail != ''">
   <img src="" align="left">
     <xsl:attribute name="src">
    <xsl:choose>
     <xsl:when test="\$thumbnail != ''">
     <xsl:value-of select="concat(\$dir,'/',\$thumbnail)"/>
     </xsl:when>
     <xsl:when test="\$image != ''">
     <xsl:value-of select="concat(\$dir,'/',\$image)"/>
     </xsl:when>
    </xsl:choose>
     </xsl:attribute>
   </img>
   </xsl:if>
   <xsl:value-of select="rss:description"/>
  </td>
   </tr>
   </table>
  </xsl:template>
</xsl:stylesheet>
_XSL_
#   <xsl:text disable-output-escaping="yes">img src="</xsl:text>
#   <xsl:text disable-output-escaping="yes">" align="left"/</xsl:text>

}

sub _rss_date {
  my $xm = shift;
  $bn->{XML_DATE_SPAN} ||= '+09:00';
  if($_[0] =~ /(\d*)\/(\d\d)\/(\d\d) \((\w*)\) (\d\d):(\d\d):?(\d\d)?/){
    my($year,$month,$day,$week,$hour,$min,$sec) = ($1,$2,$3,$4,$5,$6,$7);
    $sec = '00' unless $7;
    return "$year-$month-$day"."T$hour:$min:$sec" . $bn->{XML_DATE_SPAN};
  }
}

1;

__END__
