#================================================================================
# LastModify : 2005/11/28
# Skin       : Basic
# Version    : 1.00
#================================================================================
package BN::CMS::Design;
use strict;
use vars qw( $bn $VERSION );
$VERSION = '1.00';
sub colors {
#-- ƂȂx[X̐F
  my $base = 'D0E8FF';
#-- ύX^OƐF
  my @phase_tags = (
#   |---- Tag Key -----------------|- RRGGBB -|
    [ 'TagBody:bgcolor',             'D0E8FF' ],
    [ 'TagBody:text',                '0066CC' ],
    [ 'TagBody:link',                '333399' ],
    [ 'TagBody:vlink',               '333366' ],
    [ 'TagBody:alink',               'FF1111' ],
    [ 'TagMainNumber:color',         '333399' ],
    [ 'TagMainTitle:color',          '333399' ],
    [ 'TagMainUser:color',           '337399' ],
    [ 'TagMainMessage:color',        '000066' ],
    [ 'TagMainEdit:color',           '002266' ],
    [ 'TagResNumber:color',          '333399' ],
    [ 'TagResTitle:color',           '333399' ],
    [ 'TagResUser:color',            '0099CC' ],
    [ 'TagResMessage:color',         '000066' ],
    [ 'TagResEdit:color',            '004466' ],
    [ 'TagNameCap:color',            'FFCC00' ],
    [ 'TagNameTrip:color',           '99FF00' ],
    [ 'TagFormItems:color',          '333399' ],
    [ 'TagFormAstMark:color',        'DD1111' ],
    [ 'TagCatalogTableOut:bgcolor',  '003399' ],
    [ 'TagCatalogTableIn:bgcolor',   'FFFFFF' ],
    [ 'TagTableOut:bgcolor',         '003399' ],
    [ 'TagTableIn:bgcolor',          'FFFFFF' ],
    [ 'TagTableFont:color',          '005599' ],
    [ 'StyleSheet',                  '003366' ],
    [ 'StyleSheet',                  '00A0CC' ],
    [ 'StyleSheet',                  '3366FF' ],
    [ 'StyleSheet',                  'A7D7EB' ],
    [ 'StyleSheet',                  'FEFEFF' ],
  );
  return( $base, \@phase_tags );
}
#-- ύX摜̐F
sub image_colors {
  return [qw/
  /]
}
sub image_list {
#-- ϊ摜
  my( $dsn, $paths ) = @_;
  return [
  ];
}
sub default_stylesheet {
#-- X^CV[g
  return [
  '/* tH[{^X^C */',
  '.button,.submit,.back,.post,.reply,.reset{',
  '    font-size:10pt;',
  '    background:#00A0CC;',
  '    color:#FEFEFF;',
  '    border:1;',
  '    border-style:dotted;',
  '}',
  '.button A,{ color:#FEFEFF; text-decoration:none }',
  '/* tH[̓X^C */',
  '.input,.select{',
  '    font-size:10pt;',
  '    border-right  :1px solid #A7D7EB;',
  '    border-left   :2px solid #003366;',
  '    border-bottom :1px solid #A7D7EB;',
  '    border-top    :2px solid #003366;',
  '    background    :#00A0CC;',
  '    color         :#FEFEFF;',
  '}',
  '/* pX^C */',
  '.quot{',
  '    color:#3366FF;',
  '    text-decoration:underline;',
  '}',
  '/* r */',
  'hr {',
  '    border-bottom :1px solid #D0E8FF;',
  '    border-top  :1px solid #0066CC;',
  '}'  ]
}
sub effect {
#-- ␳
  my( $dsn, $mo, $base, $color, $phase ) = @_;
  for (qw/
    0066CC
    333399
    333366
    003399
    337399
    0099CC
    000066
    FF1111
    FFFFFF
  /) { $phase->{$_} = $mo->yuv2colorize( $base, $_, $phase, 30 ) }
  $phase->{'003399'} = $mo->yuv2colorize( 'FFFFFF', '003399', $phase );
  $phase->{'00A0CC'} = $mo->yuv2colorize( 'FEFEFF', '00A0CC', $phase );
}
sub items {
  my $item = $bn->{mo}{CMS}{item};
  $item->{ skin_design } = 'fUCi';
}

sub config {
  my $dsn = $_[0];
  my $cf = $bn->{cfg};
  my $sk = $bn->{skin};
  my $cms = $bn->{mo}{CMS};
  my $item = $cms->{item};

  $bn->call( 'DesignConfig' );

  $dsn->items;
  $item->{skin_design_txt} = 'PFw肷邾őŜ̐Fݒ𐮂܂B';

  my $color = defined $bn->get( $sk, 'SkinDesign' ) ? $bn->get( $sk, 'SkinDesign' ) :
  defined $bn->get( $cf, 'SkinDesign' ) ? $bn->get( $cf, 'SkinDesign' ) : '#'. ( $dsn->colors )[0];

  $cms->col( 'skin_design', $color );
  my @p;
  $p[ ( $bn->get($cf, 'SkinDesignPattern') ? 1 : 0 ) ] = ' checked';
  $bn->print(
    '<tr><td>&nbsp;</td><td>',
    '<input type="radio" name="skin_design_pattern" id="skin_design_pattern_rgb" value="0"', $p[0], '>',
    '<label for="skin_design_pattern_rgb">RGBVtg</label>',
    '<input type="radio" name="skin_design_pattern" id="skin_design_pattern_hsb" value="1"', $p[1], '>',
    '<label for="skin_design_pattern_hsb">HSBVtg</label>',
    '</td></tr>'
  );
  $cms->inf( 'skin_design_txt' );
}

sub design {
  my $dsn = $_[0];
  my $in = $bn->{in};
  my $cf = $bn->{cfg};
  my $sk = $bn->{skin};
  my $mo = $bn->mo( 'Design' );
  my $debug;

  $dsn->{design_images_path} = {
    original_dir => $bn->{sys}{DirImages},
    phase_dir => $bn->{sys}{DirImages},
    original_url => '$images',
    phase_url => '$images',
  };

  $bn->call( 'DesignWrite' );

  $dsn->items;

  ## 
  my $color = $mo->get_color( $in->{skin_design} );
  my $pattern = $in->{SkinDesignPattern} = int $in->{skin_design_pattern};
  return if $bn->get($cf, 'SkinDesign') eq '#'.$color && $bn->get($cf, 'SkinDesignPattern') eq $pattern;
  $in->{SkinDesign} = '#'.$color;

  ## ͐F̕
  my( $r, $g, $b ) = $mo->get_rgb( $color );
  my( $hue, $saturation, $brightness ) = $mo->rgb2hsb( $r, $g, $b );

  ## Fe[u
  my( $base, $phase_tags ) = $dsn->colors;
  my $image_colors  = $dsn->image_colors;
  my $images_list = $dsn->image_list( $dsn->{design_images_path} );

  ## 摜URLύX
  ## - ʏ͕ύXȂB
  ## - 摜URLƕύXꍇɎw肷B
  $in->{DirImagesUrl} = $bn->get($cf, 'DirImagesUrl'); # ύXȂ
#  $in->{DirImagesUrl} = './images'; # ύX

#-- FύXvZ ----------------------------------------------------

  my( %phase_colors, @cfg_list );
  if ( @$phase_tags ) {
    my %cfg;
    for ( @$phase_tags ) {
      my( $tag, $val ) = @$_;
      my( $key, $elm ) = split /:/, $tag, 2;
      $cfg{$key} = 0;
      $phase_colors{$val} = 0;
    }
    push @cfg_list, keys %cfg;
    push @cfg_list, 'StyleSheet';
  }

  my $phase = $dsn->conv( $mo, \%phase_colors, $pattern, $base, $color, $hue, $saturation, $brightness );
  my $phase_image = $dsn->conv( $mo, $image_colors, $pattern, $base, $color, $hue, $saturation, $brightness );

#-- 摜̐Fϊ --------------------------------------------------

  if ( each %$phase_image ) {
    for my $i ( @$images_list )
     { $mo->gif2colorize( $i->[0], $i->[1], $base, $color, $phase_image ) }
  }

#-- F␳Eϊ --------------------------------------------------

  $dsn->effect( $mo, $base, $color, $phase );

#-- ݐF ΉϐZbg -------------------------------------

  my @write_tags;
  for ( @cfg_list ) { $in->{$_} = $bn->get( $sk, $_ );
    push @write_tags, [ $_, $_, '%' ] }
  if ( @$phase_tags ) {
    for ( @$phase_tags ) {
      my( $tag, $val ) = @$_;
      my( $key, $elm ) = split /:/, $tag, 2;
      $in->{$key}{$elm} = $phase->{$val} if defined $key && defined $elm && defined $val;
    }
  }

#-- X^CV[g̐Fϊ ----------------------------------------

  if ( $dsn->stylesheet( $phase, $images_list, $dsn->default_stylesheet ) ) {
    push @write_tags, [ 'StyleSheet', 'StyleSheet', '@' ];
  }

#-- ݒ菑 --------------------------------------------------
#---- |------- Cfg Key -------|--- Input Value ----|- Type -|------
  $bn->{mo}{Write}->write(
    [
      [ 'DirImagesUrl',       'DirImagesUrl',       '$' ],
    ],[
      [ 'SkinDesign',         'SkinDesign',         '$' ],
      [ 'SkinDesignPattern',  'SkinDesignPattern',  '$' ],
      @write_tags
    ]
  );

  for ( @cfg_list ) { delete $in->{$_} }

  $bn->set( $bn->{cfg}, 'TxtBottom', $debug ) if defined $debug;

}

sub stylesheet {
  my( $dsn, $phase, $list, $stylesheet ) = @_;
  my $in = $bn->{in};

  if ( ref $stylesheet ne 'ARRAY' ) {
    my $sys = $bn->{sys};
    my $dir = $bn->get( $bn->{cfg}, 'SkinDir' );
    my $skincfg = defined $dir ?
      "$dir/$sys->{SkinConfig}.$sys->{Exe}" : $sys->{SkinCfg};
    my $fh = $bn->open( $skincfg );
    $fh or return;

    my $st = ( __var => {}, __type => {} );
    $bn->define( $st, 'StyleSheet', undef, '@' );
    $in->{StyleSheet} = ();
    while ( <$fh> ) {
      chomp;
      next if !/\S/ || /^#/;
      my( $var, $val ) = $_ =~ /^\s*(\S+)(?: +|\t+)(.+)$/;
      $val =~ s/\s*$//;
      next unless $var ne '' && defined $val;
      next unless $var eq 'StyleSheet';
      $bn->set($st, $var, $val);
    }
    close $fh;
    $stylesheet = $bn->get( $st, 'StyleSheet' );
  }

  my $pos;
  my $sheet = join "\n", @$stylesheet;
  while ( $_ = index $sheet, '#', $pos ) {
    last if $_ == -1;
    $pos = $_ + 1;
    my $s = substr $sheet, $pos, 6;
    next unless exists $phase->{$s};
    my $b = substr $sheet, 0, $pos - 1;
    $sheet = $b. $phase->{$s}. substr $sheet, $pos + 6;
    $pos += 6;
  }

  # 摜u
  if ( ref $list eq 'ARRAY' ) {
    for my $i (@$list)
      { $sheet =~ s!\Q$i->[2]\E!$i->[3]!g if -e $i->[1] && defined $i->[2] }
  }
  $in->{StyleSheet} = [ split /\n/, $sheet ];

  return 1;
}
sub conv {
  my( $dsn, $mo, $colors, $pattern, $base, $color, $hue, $saturation, $brightness ) = @_;
  my @a = ref $colors eq 'ARRAY' ? @$colors : keys %$colors;
  my %phase;
  for ( @a ) {
    if ( $pattern ) {
      my( $d_h, $d_s, $d_v ) = $mo->hsb2diff( $base, $_ );
      $phase{$_} = '#'.$mo->hsb2rgb( $hue + $d_h, $saturation + $d_s, $brightness + $d_v );
    } else {
      $phase{$_} = '#'.$mo->set_color( $color, $mo->color2diff( $base, $_ ) );
    }
  }
  return \%phase;
}
sub new { $bn = $_[1]; bless { }, $_[0] }

1;
